2010-07-29  Mark Mason <glowingpurple@gmail.com>
	
	* mini-ops.h: Fix mips branch opcodes
	* mini-mips.h: enable IMT for MIPS
	* mini-mips.c: Use NULLIFY_INS(), fixup *_OVF expansions with extra move.
	* tramp-mips.c: Some cleanups to trampoline handling
	
2010-07-27  Mark Mason <glowingpurple@gmail.com>

	* mini-mips.c: Fix compilation errors.

2010-07-25  Zoltan Varga  <vargaz@gmail.com>

	* mini-trampolines.c (common_call_trampoline): Fix a warning.

2010-07-24  Zoltan Varga  <vargaz@gmail.com>

	* mini-s390x.c: Change the calling convention to pass this as first as on other
	architectures. Remove some dead code from the get_vcall_slot().

2010-07-24  Geoff Norton  <gnorton@novell.com>

	* mini-darwin.c: Having reviewed xnu-1504.7.4 it is safe to call fork directly
	here, it seems the old implementation was a hold over from the linux behaviour
	This fixed gdb backtrace on amd64 and ppc.

2010-07-23  Zoltan Varga  <vargaz@gmail.com>

	* xdebug.c (mono_save_trampoline_xdebug_info): Call
	mono_loader_lock/unlock_if_inited () to avoid asserts on some platforms during
	startup.

2010-07-23  Marek Habersack  <mhabersack@novell.com>

	* Makefile.am (version.h): generate version using GIT commit info,
	removed the old svn and git-svn code.

2010-07-22  Jb Evain  <jbevain@novell.com>

	* method-to-ir.c (BRANCH_COST): set to 10.

2010-07-20  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (op_to_op_src2_membase): Reorganize the amd64 op->op membase
	code, it was missing a few 'break's.

2010-07-20  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mini_emit_inst_for_method): Add Array.GetLength/GetLowerBound ().
	Fixes #618176.

2010-07-16  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c: Fix the arm build by passing a MonoGenericSharingContext to get_call_info.

2010-07-16  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c: Add more SIMD instructions.

2010-07-15  Miguel de Icaza  <miguel@novell.com>

	* mini.c: Allow "casts" to be passed on MONO_DEBUG as well.

2010-07-15  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c: Change the calling convention to pass this as first as on other
	architectures. Remove some dead code from the get_vcall_slot() and the implementation
	of the CALL_MEMBASE opcodes as a result.

2010-07-13  Miguel de Icaza  <miguel@novell.com>

	* mini.c: LLVM is disabled by default on LLVM builds.  You can use
	the MONO_ENV_OPTIONS to set the --llvm flag.

2010-07-13  Atsushi Enomoto  <atsushi@ximian.com>

	* driver.c : windows build fix for --with-moonlight.

2010-07-12  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* mini.c|h:
	* mini-exceptions.c: Add an option to MONO_DEBUG for tracking down exceptions
	that reach native code from a reverse pinvoke.

2010-07-11  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mono_method_to_ir): Kill some duplicated code.

	* mini-<ARCH>.c (get_call_info): Call mini_type_get_underlying_type () before passing
	a type to MONO_TYPE_IS_REFERENCE (), since the latter can't handle VAR/MVAR.
	Fixes #620864.

	* generics.cs: Add a test.

2010-07-11 Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c (mono_jit_compile_method_inner): Don't bomb out if we don't
	support a given runtime implemented method.

2010-07-10  Mark Probst  <mark.probst@gmail.com>

	* mini-darwin.c: Register the exception thread with the GC.

2010-07-10  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c (set_metadata_flag): Set metadata flags only when using the LLVM
	mono branch.

2010-07-09  Zoltan Varga  <vargaz@gmail.com>

	* mini.h (MONO_INST_HAS_CONSTANT_LOAD): New instruction flag marking loads which load
	from constant memory.

	* ir-emit.h: Clean up the _FAULT macros a bit.

	* decompose.c: Mark some loads as constant.

	* mini-llvm.c: Pass the constant-ness of loads to LLVM using custom metadata.

2010-07-09  Miguel de Icaza  <miguel@novell.com>

	* driver.c (mini_usage): Change the name of the --sgen flag to be
	--gc=sgen and also support --gc=boehm.   These flags can also be
	set on MONO_ENV_OPTIONS to propagate this to children processes.

	* main.c: Remove the MONO_VM_OPTIONS environment variable that
	only supported "sgen" and "llvm" config options and instead parse
	the MONO_ENV_OPTIONS as options that are parsed by the command
	line parser.   Any command line option that Mono supports can be
	passed in this environment variable.

2010-07-09  Zoltan Varga  <vargaz@gmail.com>

	* ir-emit.h mini-llvm.c: Fix support for explicit-null-checks +
	LLVM.

	* mini.c (mini_method_compile): Run abcrem uncoditionally when LLVM is used since
	it can now eliminate more than just bounds checks.

	* ir-emit.h: Add MAY_FAULT versions of the LOAD_MEMBASE macros which take
	an extra 'fault' argument.

	* method-to-ir.c: Set the MONO_INST_FAULT of the array opcodes which are decomposed
	later.

	* decompose.c: Propagate the MONO_INST_FAULT flag from the array opcodes to their
	decomposition.

	* mini-llvm.c: Remove support for the X86/AMD64 COMPARE_MEMBASE opcodes, they are
	no longer generated when LLVM is used.

	* abcremoval.c: Eliminate MONO_INST_FAULT flags if possible.

2010-07-09  Zoltan Varga  <vargaz@gmail.com>

	* ir-emit.h mini-llvm.c: Fix support for explicit-null-checks + LLVM.

2010-07-09  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* driver.c: Moonlight: Force line buffering for stdout.

2010-07-09  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c (emit_load): Revert the last changes, the load/store intrinsics
	are only callable using invoke.

2010-07-09  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c (process_bb): Use emit_load () in one more place.

	* mini-llvm-cpp.cpp (force_pass_linking): Link in more function passes so
	MONO_LLVM=xxx is actually usable.

	* mini-llvm.c (emit_load): Use the mono specific load intrinsics even outside clauses
	since LLVM might be able to hoist them out of loops.
	(emit_store): Ditto.

2010-07-08  Neale Ferguson <neale@sinenomine.net>

	* mini-s390x.c: Correct setting value of header from cfg->header - fix crash
	in typeload-unaligned test.

2010-07-08  Zoltan Varga  <vargaz@gmail.com>

	* xdebug.c (mono_save_trampoline_xdebug_info): Make this receive a MonoTrampInfo.

	* tramp-<ARCH>.c: Move the calls to save_trampoline_xdebug_info () into
	mini-trampolines.c/mini-exceptions.c. Use a more human readable name for
	generic trampolines+rgctx fetch trampolines.

2010-07-08  Geoff Norton  <gnorton@novell.com>

	* genmdesc.pl: nacl is not a new inst slot, it just modifies the size slot.

2010-07-07  Zoltan Varga  <vargaz@gmail.com>

	* tramp-arm.c (mono_arch_create_rgctx_lazy_fetch_trampoline): Add xdebug info.

	* method-to-ir.c (emit_imt_argument): Call add_outarg_reg even if MONO_ARCH_IMT_REG
	is not defined in the LLVM case to keep the imt arg alive.

2010-07-06  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-<ARCH>.c mini-llvm.c: Clean up the naming of the llvm related trampoline
	functions, now its 'llvm_<FOO>_trampoline'.

	* method-to-ir.c (emit_imt_argument): Fix llvm support.

	* mini-llvm.c: Use only one mono specific LLVM calling convention since imt/rgctx
	cannot be passed in the same call.

	* mini-amd64.h mini-amd64.c tramp-amd64.c aot-compiler.c: Change the IMT
	register to be the same as the RGCTX register, the two can't be used together on
	the same call.

2010-07-05  Miguel de Icaza  <miguel@novell.com>

	* driver.c (mono_main), main.c: Add support for MONO_VM_CONFIG
	that allows the user to force the VM to use llvm or sgen.

2010-07-05  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-ppc.c (mono_arch_handle_exception): Resume from the signal handler
	before processing the exception on PPC too.

	* mini-ppc.h (MONO_CONTEXT_SET_SP): Define this to fix the PPC build.

	* mini-ppc.c tramp-ppc.c aot-compiler.c: Change the managed calling convention so
	'this' is always passed as the first argument, before the vtype ret arg. This
	simplifies get_this_arg_reg () and LLVM integration.

2010-07-05  Martin Baulig  <martin@ximian.com>

	* exceptions-x86.c (mono_arch_handle_exception): Port this to
	Windows; apply my patch from r159782 in the mono-2-6 branch.

2010-07-05  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* Makefile.am: Don't build the debug assembler files if we're building without
	debugger support.

2010-07-05  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (arch_emit_unbox_trampoline): Fix this after the callconv changes.

2010-07-04  Zoltan Varga  <vargaz@gmail.com>

	* tramp-arm.c (mono_arch_create_generic_trampoline): Fix the max trampoline
	length.

	* mini-arm.h (MonoContext): Get rid of the 'ebp' field, use
	regs [ARMREG_FP] instead.

	* unwind.c (decode_lsda): Use read32 for reading 32 bit quantities.

	* tramp-arm.c (mono_arch_create_generic_trampoline): Save the original sp to
	lmf->iregs [ARMREG_IP] to be consistent with mono_arch_emit_prolog ().

	* mini-arm.h (MonoLMF): Remove unused fregs field, add comments for other fields.

	* exceptions-arm.c: Clean up the handling of LMFs. Add LLVM exception trampolines.

	* mini-arm.c: Always use V5 for passing IMT/RGCTX when running under LLVM.

	* method-to-ir.c (emit_imt_argument): Fix LLVM support for architectures
	without IMT_REG defined (ARM).

	* exceptions-arm.c: Add LLVM throw exception trampolines, add xdebug info for
	the trampolines.

2010-07-03  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c (process_bb): Disable OP_MEMORY_BARRIER on arm.

2010-07-02  Zoltan Varga  <vargaz@gmail.com>

	* mini.h: Applied patch from Elijah Taylor (elijahtaylor@google.com). Fix some
	definitions to match their declarations and vice-versa.

2010-07-01  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am (common_sources): Add mini-llvm.h.

	* unwind.c (mono_unwind_decode_fde): Fix the decoding of the lsda offset.

2010-06-30  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_cleanup): Avoid calling mono_runtime_shutdown () if cross
	compiling.

Wed Jun 30 12:10:57 CEST 2010 Paolo Molaro <lupus@ximian.com>

	* Makefile.am, mini-llvm.h, mini-unwind.h, mini.c, mini.h, xdebug.c:
	implemt the option of loading the llvm backend from a module so
	that we can have a single binary and the bloat from llvm is
	only experienced when it is actually loaded.

Wed Jun 30 12:02:39 CEST 2010 Paolo Molaro <lupus@ximian.com>

	* mini-llvm.c: remove direct access to mono_defaults.

2010-06-29  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c (mono_arch_get_vcall_slot): This is no longer used on ARM, so make it
	a no-op.

	* mini-trampolines.c (mono_vcall_trampoline): Fix a warning.

	* mini-x86.c (mono_arch_get_vcall_slot): Remove most cases as the only caller
	is now mono_arch_nullify_class_init_trampoline ().
	(mono_arch_output_basic_block): Remove the special casing from the CALL_MEMBASE
	opcodes, they are no longer needed.

	* mini-amd64.c (mono_arch_get_vcall_slot): Remove most cases as the only caller is
	now mono_arch_nullify_class_init_trampoline ().
	(mono_arch_output_basic_block): Remove the special casing from the CALL_MEMBASE
	opcodes, they are no longer needed.

	* mini-trampolines.c (mono_vcall_trampoline): Use the LLVM method of obtaining the
	vtable on platforms which support it.

	* driver.c: Print the full LLVM version we are compiled against in --version.

	* aot-runtime.c (decode_exception_debug_info): Separate the LLVM and non-LLVM code
	a bit better. Decode nesting information to fix eh support for llvm+aot.

	* aot-compiler.c (emit_exception_debug_info): Encode nesting information for LLVM
	methods.

	* mini-llvm.c (mono_llvm_cleanup): Dispose the aot module too.

	* mini-arm.c (get_call_info): Change the managed calling convention so 'this'
	is always passed as the first argument, before the vtype ret arg. This simplifies
	get_this_arg_reg () and LLVM integration.

2010-06-28  Zoltan Varga  <vargaz@gmail.com>

	* mini-trampolines.c mini.c: Rework the virtual call handling code by using a separate
	vtable trampoline for each vtable slot for both the LLVM and non-LLVM cases. Move
	most of the vcall specific code to mono_vcall_trampoline () from
	common_call_trampoline ().

2010-06-27  Zoltan Varga  <vargaz@gmail.com>

	* mini-trampolines.c (common_call_trampoline): Remove the code which created static
	rgctx trampolines when called from LLVM, they won't work for dynamic rgctx arguments
	if the callsite is patched.

	* mini-llvm.c (process_call): Disable calls which need an rgctx arg if not using
	the llvm branch.

	* tramp-amd64.c (mono_arch_create_rgctx_lazy_fetch_trampoline): Fix the name of
	the trampoline in the xdebug info.

	* mini-trampolines.c (common_call_trampoline): Make the last change work for LLVM
	as well.

2010-06-26  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c: Fix a few problems exposed by make check.

2010-06-25  Mark Probst  <mark.probst@gmail.com>

	* mini-trampolines.c (common_call_trampoline): An ugly hack to
	work around a potentially very hard to fix problem with inflating
	generic methods.

2010-06-26  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mono_emit_wb_aware_memcpy): Remove the workaround as the core
	problem has been fixes.

2010-06-25  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am: Add an 'SGEN' make variable to allow tests to be run with SGEN.

	* mini-gc.c (mini_gc_init_cfg): Use mono_gc_is_moving () instead of HAVE_SGEN_GC.
	It might be be better to define a MonoGCJitOptions structure later and have the
	GC return that.

	* mini-darwin.c: Don't undefine pthread_ calls for SGEN, they are no longer defined.

	* Makefile.am: Use libwapi.la for both sgen and non-sgen builds.

	* debugger-agent.c (get_objref): Implement support for sgen.

	* driver.c: Remove the unused gc_wrapper.h include.

	* driver.c (mono_main): Delegate the --desktop mode optimizations to the GC
	implementation.

2010-06-25  Zoltan Varga  <vargaz@gmail.com>

	* driver.c (mono_main): Use mono_gc_get_description () to print the GC name.

	* mini-gc.c (mini_gc_init_cfg): New function to initialize GC specific flags
	in MonoCompile.

	* method-to-ir.c mini.c: Remove usage of HAVE_SGEN_GC and use runtime checks
	instead.

2010-06-23  Miguel de Icaza  <miguel@novell.com>

	* Makefile.am: Build the mono-sgen binary a Mono VM with the Sgen
	GC enabled as well as libmono-sgen-2.0 and libomonosgen-static

	* driver.c: Do not depend on the USED_GC_NAME when using SGen, use
	it only for Boehm diagnostics.

	* Makefile.am: Make the file a bit more consistent.

	* debug-debugger.c: Wrap the entire file with an #ifdef
	MONO_DEBUGGER_SUPPORTED to simplify the build.

	* Makefile.am: Fix the opcodes build issue by including the
	source, not by including the .lo file directly

	Always bring the MDB sources into the build, to drop the
	dependency on the AM_CONDITIONAL from configure.in as the hard
	debugger supports Boehm, but not Sgen, this simplifies the build. 

	* Renamed the *.s files into *.S

2010-06-24 Rodrigo Kumpera  <rkumpera@novell.com>

	* method-to-ir.c (mono_emit_wb_aware_memcpy): Don't emit bitmap
	wb for now on 64bits systems while issues with valuetype returns
	are not fixed.

2010-06-24  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm-cpp.cpp (mono_llvm_create_ee): Add support for using a standard set of
	passes by calling createStandardFunctionPasses ().

2010-06-23  Zoltan Varga  <vargaz@gmail.com>

	* mini.h (MONO_INS_HAS_NO_SIDE_EFFECT): Add OP_LDADDR.

2010-06-22  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mono_method_to_ir): Don't mark loads from OP_LDADDR with
	MONO_INST_FAULT.

	* mini-llvm.c (mono_llvm_emit_method): Recalculate MONO_INST_INDIRECT flags to
	allow better optimization if the OP_LDADDR which caused the flag to be set was
	optimized away.

	* exceptions-amd64.c (get_throw_trampoline): Align the stack properly.

	* mini-amd64.c (mono_arch_emit_exceptions): Pass only the type token index, not
	the type token.

	* mini-llvm.c (emit_entry_bb): Save the this argument only in gshared methods.

	* mini-llvm.c: Fix a couple memory leaks. Get rid of a few #ifdefs.

2010-06-22  Zoltan Varga  <vargaz@gmail.com>

	* tramp-amd64.c (mono_arch_nullify_class_init_trampoline): Call patch_callsite ()
	to handle the code sequence generated for non-near calls. Fixes #616056.

2010-06-21  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-x86.c (mono_arch_find_jit_info_ext): Adjust eip in the lmf case too.

	* exceptions-x86.c: Add a resume_unwind trampoline for LLVM.

	* mini-llvm.c (exception_cb): For nested clauses, add the same try range to the
	nesting clause too.
	(mono_llvm_check_method_supported): Enable llvm for methods with nested clauses.
	(mono_llvm_emit_method): Instead of calling 'mono_resume_unwind' directly, call a
	trampoline which saves the context, so changes made to callee saved registers in
	finally clauses are visible to a nesting catch clause.

	* exceptions-amd64.c: Add a resume_unwind trampoline for LLVM.

	* mini-exceptions.c (mono_handle_exception_internal): Fix support for nested clauses
	in LLVM compiled code.
	(mono_handle_exception_internal): Add a 'ctx' argument containing the state after
	the finally handler has ran.

	* mini.h (ResumeState): New structure containing information required to resume
	exception handling after executing LLVM compiled finally clauses.

	* exceptions-amd64.c (get_throw_trampoline): Clean up the amd64 throw trampolines a
	bit, by passing all the registers as one argument.

2010-06-19  Zoltan Varga  <vargaz@gmail.com>

	* tramp-amd64.c (mono_arch_create_generic_trampoline): Increase the buf len a little,
	to avoid an assert.

2010-06-18  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_klass_info): Mark unloadable classes properly.

	* aot-compiler.c aot-runtime.c: Fix LLVM support.

	* mini-llvm.c: When emitting OP_CALL_HANDLER, avoid branching directly to the landing
	pad, branch to a new bblock instead.

	* aot-compiler.c (emit_method_code): Use cfg->header instead of the header of
	orig_method.

	* exceptions-amd64.c (mono_arch_exceptions_init): Fix fullaot support.

	* mini-llvm.c (process_bb): Add support for OP_SQRT when using the LLVM mono branch.

2010-06-17  Geoff Norton  <gnorton@novell.com>

	* mini-arm.h:
	* exceptions-arm.c: Move the UCONTEXT macros to mono-sigcontext.h so they
	can be used by sgen.

2010-06-17  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_klass_info): Handle type load exceptions.

	* method-to-ir.c (mono_method_to_ir): Avoid a crash if mono_method_get_header ()
	fails.

	* exceptions-x86.c (mono_x86_throw_corlib_exception): Negate the decrement of
	the ip done by throw_exception (), it is not needed for corlib exceptions.

2010-06-17 Rodrigo Kumpera  <rkumpera@novell.com>

	* method-to-ir.c (mono_emit_wb_aware_memcpy): Simplify this function.
	Call new jit icall mono_gc_wbarrier_value_copy_bitmap for vt wbarrier
	of size > 5 words. This support fast barriers for value types up to
	256/512 bytes which	beyond that the copying itself is the major issue.

	* method-to-ir.c (mini_emit_stobj): The intrinsic version is safe
	for gsharing, so use it.

	This eliminate all calls to mono_value_copy from managed code in
	gmcs, fsharp and ipy.

	This gives a 2% perf boost on ipy and 1% on gmcs over previous patches.

	Even thou a lot of mono_value_copy calls were eliminated from fsharp,
	performance kept

	* mini.c (mini_init): Register new icall.

2010-06-17 Rodrigo Kumpera  <rkumpera@novell.com>

	* method-to-ir.c (mono_emit_wb_aware_memcpy): Handle nested valuetypes.
	This eliminates 2% of mono_value_copy calls on ipy and 12% on fsharp.

2010-06-17 Rodrigo Kumpera  <rkumpera@novell.com>

	* method-to-ir.c (mini_emit_stobj): Don't call mono_value_copy for small
	value types as the overhead is huge. Manually expand it up to 5 words to
	avoid code bloat.

	This improves gmcs times by 5% and unmodified binary-tree by 78%. The later
	is an exception that performance is dominated by mono_value_copy.

	This puts sgen about 5% ahead of boehm in terms of wall-clock on a Core2Quad.

2010-06-17  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c (process_call): Disable LLVM for calls to generic class init
	trampolines on x86, since those have their own cconv.

	* exceptions-x86.c (mono_arch_exceptions_init): Implement the llvm throw corlib
	exception trampolines.

	* tramp-x86.c: Add xdebug info for a few trampolines.

	* mini-llvm.c: Set the name of the arguments.

	* mini-llvm.c (emit_cond_system_exception): Pass the ip of to throw_corlib_trampoline
	using a block address if using the LLVM mono branch.

	* exceptions-amd64.c (mono_arch_exceptions_init): Add new LLVM throw corlib exception
	trampolines.

2010-06-15  Zoltan Varga  <vargaz@gmail.com>

	* mini-ppc.c (mono_arch_get_cie_program): Define this for powerpc too.

	* mini-llvm.c (process_bb): Add a missing CHECK_FAILURE.

	* mini.c (mini_init): Remove some of the llvm restrictions, they are no longer needed.

	* method-to-ir.c (mono_method_to_ir): Enable fast virtual calls when using llvm.

	* mini-trampolines.c (mono_llvm_vcall_trampoline): Rewrite this to use one vtable
	trampoline per vtable slot index. The slot, along with the 'this' argument is enough
	to identify the vtable slot address plus the method which needs to be compiled.

	* mini.c (mini_get_vtable_trampoline): Use one vtable trampoline per vtable slot when
	using llvm.

	* mini-x86.c (get_call_info_internal): Change the managed calling convention so
	'this' is always passed as the first argument, before the vtype ret arg. This
	simplifies get_this_arg_reg () and LLVM integration.

	* mini-amd64.c (get_call_info): Fix the handling of MONO_TYPE_TYPEDBYREF after
	the latest changes.

	* tramp-x86.c (mono_arch_create_generic_trampoline): Emit unwind info for
	these trampolines.

	* mini-x86.c (mono_arch_get_cie_program): Implement this for x86.

	* mini-llvm.c: Fix compilation with llvm 2.6.

	* mini-amd64.c (CallInfo): Fix the position of the vret_arg_index field.

	* mini-llvm.c (mono_llvm_emit_method): Fix the build if LLVM_MONO_BRANCH is not
	defined.

	* mini-amd64.c (get_call_info): Change the managed calling convention so 'this'
	is always passed as the first argument, before the vtype ret arg. This simplifies
	get_this_arg_reg () and LLVM integration.

2010-06-14 Rodrigo Kumpera  <rkumpera@novell.com>

	* method-to-ir.c (mono_method_to_ir): Add support for .ctor intrinsics.

	* method-to-ir.c (mini_emit_inst_for_ctor): New function for .ctor intrinsics.
	For now just call simd intrinsics. This makes "x[0] = new Vector4f (10)" 
	translate into much nicer code.

2010-06-14  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c (sig_to_llvm_sig_full): Add a 'sinfo' out argument which returns
	parameter index information. Use this to simplify a lot of code.

	* unwind.c (mono_unwind_decode_fde): Handle augmentions using a loop.

2010-06-12  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (compile_method): Add a 'depth' parameter to add_generic_class too
	to fix infinite generic recursion. Fixes #612702.

2010-06-11  Zoltan Varga  <vargaz@gmail.com>

	* object.c: Use a callback to create IMT trampolines, allowing the usage of one
	imt trampoline per imt slot when using LLVM.

2010-06-10  Jonathan Pryor  <jpryor@novell.com>

	* mini.c (mini_cleanup): Call mono_runtime_shutdown(). Fixes #438454.

2010-06-09  Levi Bard  <levi@unity3d.com>

	* debugger-agent.c: Clear unloaded types on appdomain unload.

2010-06-08  Zoltan Varga  <vargaz@gmail.com>

	* liveness.c (visit_bb): Make the component vregs of long vars volatile as well.
	Fixes #612206.

	* exceptions.cs: Add a test.

2010-06-06  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c (mono_llvm_check_method_supported): Only disable llvm for nested clauses.

	* mini.c (mini_method_compile): Move the LLVM checks to a function in mini-llvm.c.

	* mini.c (mono_jit_runtime_invoke): Initialize *exc to NULL before calling the wrapper,
	so it doesn't have to do it.

	* helpers.c (mono_disassemble_code): Flush stdout, so the output from the spawned
	process does not mix with ours.

	* mini-llvm.c (mono_llvm_emit_method): Refactor this giant function into smaller
	ones.

	* mini-llvm.c method-to-ir.c ir-emit.h: When using the llvm mono branch, allow
	loads/stores which can throw exceptions inside clauses.

2010-06-05  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c (mono_llvm_emit_method): Fix support for finally clauses with more than
	one ENDFINALLY.

	* mini.c (mini_init): Register mono_resume_unwind as an icall.

2010-06-03  Zoltan Varga  <vargaz@gmail.com>

	* dwarfwriter.c: Update after the mono_debug_lookup_locals () changes.

	* debugger-agent.c (method_commands_internal): Ditto. Return scope information for
	locals.

2010-06-03  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (appdomain_unload): Clear all breakpoint instances in the dying
	appdomain.

2010-06-02  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (set_rgctx_arg): New helper function to remove some duplicate code.
	Use a separate generic class init trampoline for llvm, since it needs a different
	signature.

	* unwind.c (mono_unwind_decode_fde): Make this decode the mono specific LSDA which
	includes the location of this/rgctx.

	* mini-llvm.c aot-runtime.c: Enable generic sharing for llvm if using the LLVM mono
	branch.

2010-06-01  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_method_compile): Enable llvm+exceptions on LLVM SVN.

	* mini-llvm.c (emit_cond_system_exception): Disable llvm when this occurs in a
	clause.

2010-05-31  Zoltan Varga  <vargaz@gmail.com>

	* unwind.c (mono_unwind_decode_fde): The FDE only has an augmention if the CIE
	says so.

	* aot-runtime.c (decode_eh_frame): Fix an assert condition.

	* aot-compiler.c (patch_to_string): New debugging helper function.

2010-05-30  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-amd64.c (get_throw_trampoline): Fix the xdebug name of the corlib
	trampoline.

	* exceptions-x86.c (mono_arch_exceptions_init): Create an llvm rethrow trampoline too.

	* mini-llvm.c (mono_llvm_emit_method): Implement OP_RETHROW.

	* method-to-ir.c (mono_method_to_ir): Emit a OP_NOT_REACHED after a rethrow.

	* mini-llvm.c (emit_call): Compute the containing try clause correctly for nested
	clauses.

	* mini.c (create_jit_info): Print EH clause info for LLVM too.

2010-05-28  Mark Probst  <mark.probst@gmail.com>

	* method-to-ir.c (mono_method_to_ir): Emit a write barrier for
	cpobj with reference types.

2010-05-28  Mark Probst  <mark.probst@gmail.com>

	* method-to-ir.c (mono_method_to_ir): Only explicitly add the
	write barrier for reference types.

2010-05-27  Zoltan Varga  <vargaz@gmail.com>

	* mini-s390x.c (mono_arch_output_basic_block): Applied patch from Aurelien Minvielle
	. Fix OP_ATOMIC_EXCHANGE_I4 on s390x. Fixes #609023.

2010-05-31  Martin Baulig  <martin@ximian.com>

	Fix #608271.

	* debugger-agent.c (breakpoints_cleanup): Iterate over `event_requests', call
	clear_breakpoint() on all breakpoint events and remove them from the list.

2010-05-27  Martin Baulig  <martin@ximian.com>

	Fix #605698.

	* debugger-agent.c (method_commands, type_commands): Temporarily
	set the appdomain while executing this method; do all metadata
	calls in the debuggee's appdomain where user assemblies are loaded.

2010-05-27  Zoltan Varga  <vargaz@gmail.com>

	* mini-s390x.c (mono_arch_get_delegate_invoke_impls): Fix the s390x build.

2010-05-26 Rodrigo Kumpera  <rkumpera@novell.com>

	* method-to-ir.c (mono_method_to_ir): Add missing write barrier to stobj.

2010-05-26  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c: Instead of freeing method headers immediately, save them in a list in
	MonoCompile, and free them in mono_destroy_compile (), since the MonoType's in them could
	be referenced even after the header is freed.

	* aot-runtime.c: Remove the half finished support for decoding the .arm_exidx
	section.

2010-05-25  Zoltan Varga  <vargaz@gmail.com>

2010-05-25  Bill Holmes  <billholmes54@gmail.com>

	* genmdesc.c (main): Fixing the detection of the nacl switch.

	Code is contributed under MIT/X11 license.

2010-05-25  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-amd64.c (mono_arch_find_jit_info_ext): Adjust the ip for LMF frames too.

	* mini-llvm.c aot-compiler.c: More LLVM 2.8 updates.

	* mini.h (LLVM_CHECK_VERSION): New helper macro.

2010-05-25  Miguel de Icaza  <miguel@novell.com>

	* genmdesc.pl (build_spec): Add support for nacl: keyword also to
	the Perl program

	* genmdesc.c: Added support for nacl: key on the machine
	description files to support the extra space required by Google
	Native Client.

2010-05-23  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_jit_compile_method_inner): Propagate exceptions in one more place.

2010-05-23  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_jit_compile_method_inner): Propagate exceptions from
	mono_runtime_class_init_full ().
	(mono_jit_runtime_invoke): Ditto. Fixes #608073.

2010-05-22  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c mini-llvm-cpp.cpp: Update after LLVM 2.8 changes.

2010-05-21  Zoltan Varga  <vargaz@gmail.com>

	* mini-ppc.c (mono_arch_output_basic_block): Use ins->inst_c1 instead of p1, the
	two are not the same on ilp32.

2010-05-21  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_jit_compile_method_inner): Remove a DISABLE_JIT block which was
	added by mistake.

	* mini-ppc.c: Fix the DISABLE_JIT build.

2010-05-20  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (decode_resolve_method_ref): Rename this from decode_method_ref_2.
	(make_writable): Remove this unused function.

2010-05-20  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c: Collect all information about a PLT entry into a separate MonoPltEntry
	structure. Make the labels to plt entries local symbols instead of assembler local
	labels, since tha latter causes problems for the iphone linker.

2010-05-19  Zoltan Varga  <vargaz@gmail.com>

	* mini-ppc.c (mono_ppc_is_direct_call_sequence): Handle one more case with ilp32.

2010-05-17  Zoltan Varga  <vargaz@gmail.com>

	* mini-ppc.c (mono_ppc_is_direct_call_sequence): Handle ilp32.
	(ppc_patch_full): Ditto.

	* mini-arm.c (mono_arch_build_imt_thunk): Fix the fail_tramp case.

	* method-to-ir.c (mono_method_to_ir): Use fast generic virtual method invocation
	if gshared is enabled, to avoid asserts in the trampoline code.

	* mini-ia64.c (mono_arch_build_imt_thunk): Implement generalized imt thunks
	on ia64.

2010-05-15  Geoff Norton  <gnorton@novell.com>

	* dwarfwriter.c, xdebug.c: Fix a pretty large leak when running in 
	xdebug mode.

2010-05-14  Geoff Norton  <gnorton@novell.com>

	* exceptions-x86.c: Fix the alignment of this trampoline so we dont get a 
	misaligned stack on darwin.

2010-05-14  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c aot-compiler.c: Implement support for generalized imt thunks on
	arm.

2010-05-14  Zoltan Varga  <vargaz@gmail.com>

	* xdebug.c: Fix ARM support.

2010-05-13  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-x86.c (mono_arch_handle_exception): Resume from the signal handler
	and do most of the work on the normal stack.
	(mono_x86_get_signal_exception_trampoline): New x86 specific trampoline function.

2010-05-13  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c: Put non-code data into the .rodata section on linux.

2010-05-13  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-arm.c (mono_arch_handle_exception): Fix the cross-compile case.

2010-05-13  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-arm.c (mono_arch_handle_exception): Resume from the signal handler
	and do most of the work on the normal stack.

2010-05-13  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-amd64.c (mono_arch_handle_exception): Resume from the signal handler
	and do most of the work on the normal stack even if sigaltstack is disabled.

2010-05-12  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-amd64.c (mono_arch_sigctx_to_monoctx): Simplify this now that
	UCONTEXT_REG_ constants are available on linux as well.
	(mono_arch_monoctx_to_sigctx): Ditto.
	(mono_arch_ip_from_context): Ditto.

2010-05-12  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (set_breakpoint): Fix setting of pending breakpoints in
	other domains.

2010-05-11  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_plt): Don't align the plt to a pagesize on x86, it is
	no longer needed.

2010-05-10  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (insert_breakpoint): Print a more descriptive error message
	if a breakpoint cannot be inserted.

2010-05-08  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_and_reloc_code): Fix a warning.

2010-05-07  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (frame_commands): Return an error instead of asserting if
	no JIT info is found for the method.

2010-05-05 Jonathan Chambers  <joncham@gmail.com>

	* debugger-agent.c (mono_debugger_agent_thread_interrupt): Protect against a NULL sigctx
	in debug printf.

2010-05-05  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_get_trampolines): New arch specific function returning
	a list of arch specific trampolines.

	* aot-compiler.c (emit_trampolines): Use it.

2010-05-05  Zoltan Varga  <vargaz@gmail.com>

	* tramp-<ARCH>.c exceptions-<ARCH>.c mini-trampolines.c mini-exceptions.c
	aot-compiler.c: Use the _full trampoline creation functions on all platforms,
	get rid of the _full from their name.

2010-05-05  Zoltan Varga  <vargaz@gmail.com>

	* tramp-x86.c (mono_arch_create_generic_trampoline): Call
	get_nullified_class_init_trampoline to remove some code duplication.

2010-05-03  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (mono_arch_emit_prolog): Fix full-aot support for thread
	attach.

2010-05-01  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_emit_load_aotconst): New arch-specific function.

	* tramp-amd64.c: Use emit_load_aotconst to remove some code duplication.

	* aot-runtime.c (init_plt): Make the default entries point to the AOT trampoline,
	there is no need to jump through the first plt entry.

	* aot-runtime.c (mono_aot_get_named_code): Rename to mono_aot_get_trampoline.

	* aot-runtime.c (mono_aot_get_plt_entry): Move the arch specific parts to an
	arch-specific function.
	(mono_aot_get_plt_info_offset): Ditto.

	* aot-runtime.c (mono_aot_register_jit_icall): New helper function called from
	mono_arch_init () to register jit icalls called from full-aot trampolines.
	(load_function): Get rid of the arch specific #ifdefs, move the relevant code
	to mini-<ARCH>.c.

	* exceptions-amd64.c (mono_arch_get_throw_corlib_exception_full): Get rid of
	the specialized throw corlib exception trampoline, use a variant of the normal
	trampoline along with a new C function which does the call to
	mono_exception_from_token (), just like on x86.

2010-05-01  Zoltan Varga  <vargaz@gmail.com>

	* mini-trampolines.c aot-compiler.c tramp-<ARCH>.c exceptions-<ARCH>.c:
	Reorganize the full aot trampoline creation functions, instead of taking a bunch
	of out arguments, they will now take a MonoTrampInfo** out argument. Simplify
	some code in aot-compiler.c because of this. Remove the non-full aot trampoline
	creation functions on architectures which have the full-aot ones.

2010-05-01  Zoltan Varga  <vargaz@gmail.com>

	* mini-ppc.c (mono_arch_decompose_long_opts): Fix LNEG.

2010-05-01  Zoltan Varga  <vargaz@gmail.com>

	* mini-ppc.c (mono_arch_emit_exceptions): Initialize exc_throw_pos/found
	explicitly, this seems to be required by some gcc versions at -O2.

	* mini-arm.c: Ditto.

2010-05-01  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (mono_arch_get_delegate_invoke_impl): Fix full-aot support for
	has_target delegate invokes.

2010-05-01  Zoltan Varga  <vargaz@gmail.com>

	* mini.h (MonoAotTrampInfo): Rename this to MonoTrampInfo, add patches/unwind
	info fields.

	* aot-compiler.c (mono_aot_tramp_info_create): Rename to mono_tramp_info_create,
	add patches/unwind info arguments, move to mini.c.

	* mini-<ARCH>.c aot-compiler.c: Update after the above changes.

2010-04-30  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (type_commands): Add a new CMD_TYPE_GET_SOURCE_FILES_2
	command which returns full path names.

2010-04-29  Zoltan Varga  <vargaz@gmail.com>

	* tramp-x86.c (mono_arch_create_generic_class_init_trampoline_full): Set the
	code_size output variable.

	* mini-x86.c (mono_arch_emit_prolog): Compute the GOT addr before calling
	mono_get_lmf_addr.
	
2010-04-29  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (mono_arch_emit_prolog): Remove a disable_aot which is not needed.
	(mono_arch_cpu_optimizazions): Make this a no-op when running with full aot.
	(mono_arch_cpu_enumerate_simd_versions): Ditto.

2010-04-29  Zoltan Varga  <vargaz@gmail.com>

	* image-writer.c (asm_writer_emit_alignment): Use ilog2 for alignments for the
	apple assembler.

2010-04-29  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (mono_arch_emit_prolog): Avoid an assert in full-aot mode.

2010-04-29  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (load_function): Use TARGET_X86 instead of __i386__.

2010-04-28  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_got_info): Double the buffer size to avoid an assert.

2010-04-27  Zoltan Varga  <vargaz@gmail.com>

	* dwarfwriter.c (emit_line_number_info): Get rid of the usage of GArray, so
	line number support works with eglib.

2010-04-27  Miguel de Icaza  <miguel@novell.com>

	* driver.c, mini.c: Since linking with LLVM makes the default Mono
	dirty an extra 70kb pages on startup we are now going to choose a
	different strategy: ship mono and mono-llvm binaries, with the
	second being the one that links with LLVM and defaults to LLVM
	being enabled.

2010-04-27  Zoltan Varga  <vargaz@gmail.com>

	* tramp-x86.c exceptions-x86.c mini-x86.c aot-compiler.c aot-runtime.c: 
	Implement full-aot support on x86.

	* method-to-ir.c: Always use a got var on x86 too, just like on ppc, because the
	trampolines depend on it. Use MONO_ARCH_GOT_REG as the got register, instead of
	the first register returned by get_global_int_regs ().

	* cpu-x86.md: Fix the length of insertx_u1_slow.

	* iltests.il.in: Disable tail call tests when running with full-aot.

2010-04-26  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mono_op_to_op_imm_noemul): Fix a warning.

2010-04-24  Mark Probst  <mark.probst@gmail.com>

	* mini.c, driver.c: Initialize mono_use_llvm in mono_main(), not
	in the initializer, because it's non-constant.

2010-04-23  Miguel de Icaza  <miguel@novell.com>

	* mini.c: Use MONO_USE_LLVM as an environment flag to turn the use
	of LLVM on by default.   Used for buildbots and other setups.

2010-04-24  Zoltan Varga  <vargaz@gmail.com>

	* mini.c: Set mono_use_llvm to FALSE even if mono is compiled with LLVM.

2010-04-23  Kornel Pal  <kornelpal@gmail.com>

	* method-to-ir.c (mono_method_to_ir): Enable inlining of pointer-sized unmanaged
	initonly static fields when using moving GC.

	Contributed under MIT/X11 license.

2010-04-23  Geoff Norton  <gnorton@novell.com>

	* mini-amd64.h: Darwin x86_64 support.

2010-04-20  Jonathan Pryor  <jpryor@novell.com>

	* exceptions-arm.c: Remove platform checks in favor of configure checks.

2010-04-19  Jonathan Pryor  <jpryor@novell.com>

	* exceptions-arm.c: Add Android support for sigcontext structure.

2010-04-16  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_jit_compile_method_inner): Implement the check for native func
	wrappers correctly now that their wrapper info is NULL.

2010-04-16  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_jit_compile_method_inner): Avoid calling
	mono_marshal_method_from_wrapper () for native func wrappers. Fixes #597189.

2010-04-16  Zoltan Varga  <vargaz@gmail.com>

	* genmdesc.c (inst_name): Define this as a copy of mono_inst_name in helpers.c,
	so the latter can be #ifndef DISABLE_JIT-ed.

	* helpers.c: Comment out the opstr array if DISABLE_JIT is set.

2010-04-16  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c driver.c: Disable a few more things when DISABLE_JIT is set.

2010-04-16  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c (emit_entry_bb): Fix support for simd arguments passed on the
	stack.

2010-04-15  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (type_commands): Call mono_class_setup_methods () before
	calling mono_class_num_methods (). Fixes #592244.

2010-04-14  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (mono_arch_get_llvm_call_info): Handle empty structures correctly.

	* mini-llvm.c: Disable LLVM for calls with non-default calling conventions.

2010-04-14  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (handle_box_inst): Merge into handle_box, simplify the merged
	version.
	* (handle_alloc): Ditto.
	(mono_method_to_ir): Remove the constrained call restriction added by a previous
	change, its not needed anymore.

2010-04-12  Zoltan Varga   Kumpera  <rkumpera@novell.com>

	* mini-posix.c (sigusr1_signal_handler): Fix build on
	non x86/amd64 systems.

2010-04-13  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mono_method_to_ir): Disable generic sharing for constrained
	calls where the constrained class needs a context. Fixes #595863.

	* iltests.il.in: Add a test.

2010-04-13  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_method_compile): Disable llvm+methods with clauses again, llvm
	2.6/SVN seems to have broken support for them.

2010-04-13  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c: Fix support for LLVM 2.6.

2010-04-10  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (thread_commands): Add a GET_ID command to get the
	MonoInternalThread belonging to the thread.

Fri Apr 9 15:28:01 CEST 2010 Paolo Molaro <lupus@ximian.com>

	* driver.c, optflags-def.h, ir-emit.h: introduce an unsupported
	unsafe optimization that will remove bound checks.

2010-04-08  Kornel Pal  <kornelpal@gmail.com>

	* method-to-ir.c (mini_emit_inst_for_method): Fix a typo that caused
	CompareExchange not to be inlined for I8.

	Contributed under MIT/X11 license.

2010-04-07 Rodrigo Kumpera  <rkumpera@novell.com>

	* array.cs: Add tests for cast between primitive array types.

2010-04-07 Andreia Gaita  <avidigal@novell.com>

	* Makefile.am: create a convenience library for moon to link with

2010-04-07 Paolo Molaro <lupus@ximian.com>

	* method-to-ir.c: optimize array accesses from generic interfaces.

2010-04-06  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c: Update after the memset/memcpy intrinsics changes in LLVM SVN.

2010-04-05 Rodrigo Kumpera  <rkumpera@novell.com>

	* method-to-ir.c (mono_method_to_ir): Handle call to virtual final methods
	of marshalbyref classes.

	Fixes #515884.

2010-04-05 Rodrigo Kumpera  <rkumpera@novell.com>

	* aot-compiler.c (emit_exception_debug_info): Encode try holes
	information.

	* aot-runtime.c (decode_exception_debug_info): Decode try holes
	information.

	* mini.h: Increase AOT version.

2010-04-04  Andreas Faerber  <andreas.faerber@web.de>

	* mini-x86.h: Only enable soft debugger when using sigaction or on
	Windows. Fixes build on Haiku (lacks siginfo_t).

	Code is contributed under MIT/X11 license.

2010-04-02  Andreas Faerber  <andreas.faerber@web.de>

	* mini.h, mini-x86.h: Suppress sigaction for Haiku, add support for
	BeOS-style signal handlers.

	Code is contributed under MIT/X11 license.
	
2010-04-02  Zoltan Varga  <vargaz@gmail.com>

	* mini-posix.c (sigusr1_signal_handler): Fix openbsd support.

2010-04-01 Rodrigo Kumpera  <rkumpera@novell.com>

	* mini-exceptions.c: Fix win32 build.

2010-04-01  Mark Probst  <mark.probst@gmail.com>

	* mini.c, driver.c: Call mono_gc_base_init() before
	mono_debug_init().

2010-04-01  Sebastien Pouliot  <sebastien@ximian.com>

	* method-to-ir.c (ensure_method_is_allowed_to_[access_field|
	call_method]): Delegate the actual work in security-core-clr.c
	to ease code sharing.

2010-04-01  Zoltan Varga  <vargaz@gmail.com>

	* decompose.c (mono_decompose_opcode): Set the cfg exception if the unsupported
	float conv.ovf.un opcodes are encountered, instead of asserting later.
	Fixes #566296.

2010-04-01  Zoltan Varga  <vargaz@gmail.com>

	* decompose.c (mono_decompose_opcode): Add OP_ICONV_TO_U4_UN as a no-op.

	* iltests.il.in: Add a test.

2010-04-01  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_emit_call): Fail compilation if an argument is too
	large. Fixes #567040.

	* method-to-ir.c: Call CHECK_CFG_EXCEPTION after emitting a call.

2010-04-01  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (handle_ccastclass): Call save_cast_details (). Fixes
	#592711.

2010-03-31 Rolf Bjarne Kvinge <RKvinge@novell.com>

	* mini-trampolines.c: Surround mono_handler_block_guard_trampoline and
	mono_create_handler_block_trampoline with the proper #ifdef so that it
	compiles on amd64.

2010-03-30 Rodrigo Kumpera  <rkumpera@novell.com>

	* mini-exceptions.c: Introduce mono_walk_stack_full, which
	allows to select if it's new or old context that is passed to 
	the callback.

	* mini-exceptions.c (mono_handle_exception_internal): Handle the
	case when executing a guarded handler from the EH machinery.

	* mini-exceptions.c (mono_install_handler_block_guard): New function
	responsible for checking for handler blocks, installing the guard and
	clearing abort state.

	* mini-posix.c (sigusr1_signal_handler): Call mono_install_handler_block_guard
	to check for handler blocks and skip interruption logic if one was found.

	* mini-trampolines.c (mono_handler_block_guard_trampoline): Function called
	by the handler block guard trampoline. Resumes interruption by raising the
	pending ThreadAbortException.

	* mini.c (create_jit_info): Calculate the end address of a finally block.

	* mini-x86.c (mono_arch_install_handler_block_guard): Patch the return address
	of a finally block to a specified address and return the old one.

	* tramp-x86.c (mono_arch_create_handler_block_trampoline): The handler block
	trampoline patches the original return address and calls the trampoline function.

2010-03-30  Zoltan Varga  <vargaz@gmail.com>

	* mini-trampolines.c (mono_aot_trampoline): Remove some dead code.

	* aot-runtime.c (mono_aot_patch_plt_entry): New helper function, which only
	does the patching if the callee is in the same domain.

	* aot-runtime.c mini-trampolines.c: Call mono_aot_patch_plt_entry instead
	of mono_arch_patch_plt_entry ().

2010-03-30 Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c (create_jit_info): Fix try block hole length encoding.

2010-03-30 Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c (create_jit_info): Emit saner debug spew. Now it doesn't
	duplicate information and print offsets instead of absolute addresses.

2010-03-29  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (jit_end): Send type loads for types loaded before the VMStart
	event is sent. Fixes #591733.

2010-03-26  Zoltan Varga  <vargaz@gmail.com>

	* mini-posix.c (SIG_HANDLER_SIGNATURE): Handle the case when ctx is NULL on
	OpenBSD.

2010-03-26  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (mono_debugger_agent_init): Set the GC type of the
	thread_to_tls hash table.

	* image-writer.c (bin_writer_emit_writeout): Fix the size of the got.plt
	section. Fixes #591000.

2010-03-26  Andreas Faerber  <andreas.faerber@web.de>

	* Makefile.am (version.h): Check for pure .git directory only,
	fixes SVN revision when using git without git-svn.

	Contributed under MIT/X11 license.

2010-03-26  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c: Apply some openbsd changes from openbsd ports.

2010-03-24 Rodrigo Kumpera  <rkumpera@novell.com>

	* basic-simd.cs: Test for vector x scalar binary operators.

2010-03-24 Rodrigo Kumpera  <rkumpera@novell.com>

	* simd-intrincs.c (simd_intrinsic_emit_binary): Support binary
	intrinsics with expanded scalar arguments.

2010-03-24 Rodrigo Kumpera  <rkumpera@novell.com>

	* mini-exceptions.c (get_exception_catch_class): Non catch clauses
	don't have an exception class, so don't decode it. This would crash
	with filter clauses.

2010-03-24  U-anarquia\miguel  <miguel@anarquia>

	Make sure that trunk builds with DISABLE_JIT, an update to the
	PlayStation 3 port.
	
	* mini.c (mini_get_shared_method): this code seems to be necessary
	regardless of whether DISABLE_JIT has been defined.

	(mono_jit_compile_method_inner): it seems that this method is
	required even in full AOT mode, so ifdef out only the pieces that
	try to genrate code (the body of code that applies patches to the
	code).  

	(mini_method_compile): do not compile when using DISABLE_JIT.

	* mini-ppc.c (mono_arch_get_allocatable_int_vars)
	(mono_arch_output_basic_block, mono-arch_emit_exceptions): Do not
	compile when DISABLE_JIT is set.

2010-03-24  Mark Probst  <mark.probst@gmail.com>

	* mini.c (mono_create_tls_get): Only create a TLS operation if the
	arch really supports it.

2010-03-24  Mark Probst  <mark.probst@gmail.com>

	* mini-x86.c, mini-x86.h, mini.c: CEE_MONO_TLS support for Darwin/x86.

2010-03-23  Neale Ferguson <neale@sinenomine.net>

	* exceptions-s390x.c: Add support for
	mono_arch_get_throw_corlib_exception and fix throw by name.

	* mini-s390x.c: Add IMT support; Fix stack parameter passing
	logic (especially for varargs); Correct localloc sizing; Add
	mono_arch_get_this_arg_from_call and
	mono_arch_get_this_arg_from_call.

	* mini-s390x.h: Add support for facility list extraction;
	Correct/update MONO_ARCH_xxx settings.

	* mini-s390.c: Minor corrections to instruction output for
	varargs. No IMT implementation - I think it's time to deprecate
	s390 and just leave s390x.

	* tramp-s390x.c: Correct creation of trampoline instruction


	* cpu-s390x.md: Update some instruction lengths

2010-03-23  Zoltan Varga  <vargaz@gmail.com>

	* mini-generic-sharing.c (fill_in_rgctx_template_slot): Remove an assert which
	can be hit with partial sharing.

	* mini-generic-sharing.c (get_shared_class): Handle partially shared methods
	in non-shared classes correctly.
	(generic_inst_is_sharable): Allow all primitive types in partial sharing.
	Turn on partial sharing.

2010-03-23  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.h: Put back MONO_ARCH_NOMAP32BIT for OpenBSD which was removed
	by mistake.

2010-03-23  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mono_method_to_ir): Handle the failure of
	mono_method_signature ().

	* mini-trampolines.c (mono_delegate_trampoline): Ditto.

	* mini.c (mini_method_compile): Get the signature of cfg->method early with
	error checking, so later calls do not need error checking.

2010-03-22  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-amd64.c: Add support for OpenBSD which has no UCONTEXT_GREGS.

	* mini-amd64.h: Enable MONO_ARCH_USE_SIGACTION on OpenBSD as well.

2010-03-22 Rodrigo Kumpera  <rkumpera@novell.com>

	* mini-exceptions.c (mono_handle_exception_internal): Don't
	check try_end for archs different than s390. 

	* mini.c (create_jit_info): Don't crash if the finallt block is the
	last one.

2010-03-22 Rodrigo Kumpera  <rkumpera@novell.com>

	* driver.c (mono_main): Don't free global codeman under linux since
	glic now peeks at code on stack for more archs than just amd64.

Mon Mar 22 18:09:09 CET 2010 Paolo Molaro <lupus@ximian.com>

	* mini.c, method-to-ir.c: changes to support compressed interface
	bitmaps.

2010-03-22  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.h: Applied patch from Robert Nagy (Robert@openbsd.org).
	Use sigaction on OpenBSD too.

2010-03-22  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (event_req_matches_assembly): Handle request modifiers too.

2010-03-21  Andreas Faerber  <andreas.faerber@web.de>

	* debugger-agent.c: #include sys/select.h for fd_set.

	Code is contributed under MIT/X11 license.

2010-03-21  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (SIG_HANDLER_SIGNATURE): Fix the build on platforms without sigaction
	(openbsd+amd64 ?).

2010-03-21  Zoltan Varga  <vargaz@gmail.com>

	* mini-ppc.c (mono_arch_emit_exceptions): Avoid an assert in ppc_patch () for
	some large methods with lots of exception handlers. Fixes #440924.

Sat Mar 20 11:56:24 CET 2010 Paolo Molaro <lupus@ximian.com>

	* method-to-ir.c: remove code duplication for interface checks.

2010-03-19  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (clear_event_requests_for_assembly): New helper function.
	(assembly_unload): Clear all event requests referencing the to-be unloaded
	assembly.


Fri Mar 19 16:45:20 CET 2010 Paolo Molaro <lupus@ximian.com>

	* mini.h, mini-exceptions.c: restore the state of the stack
	guard page permissions.

2010-03-19  Zoltan Varga  <vargaz@gmail.com>

	* mini-trampolines.c (common_call_trampoline): Remove the condition guarding the
	call site patching code, it doesn't appear to be needed.

2010-03-19  Zoltan Varga  <vargaz@gmail.com>

	* mini-generic-sharing.c: Add infrastructure for partial sharing, ie.
	sharing generic methods whose type arguments are a mix of reference and
	non-reference types. Not yet turned on.

	* mini.c (mini_get_shared_method): New helper function to return
	the method which will be compiled/registered in the JIT tables when doing
	generic sharing.
	(mono_domain_lookup_shared_generic): Moved to mini.c from mini-generic-sharing.c,
	use mini_get_shared_method ().

	* mini.c (mini_method_compile): Register the same method which is compiled when
	doing generic sharing.

	* mini.c aot-compiler.c aot-runtime.c: Add support for partial sharing.

	* generics.cs: Add partial sharing tests.

2010-03-17 Jerry Maine  <crashfourit@gmail.com>

	* mini.h : Changed the SIMD_VERSION* enum values to match those in Mono.Simd.AccelMode.
		   Add an enum value that or's all possable values together. Add an enum value
		   that marks the end of the used bit indexes.

	* mini-amd64.c : Make changes to match the changes in mini.h 

	* mini-x86.c : Make changes to match the changes in mini.h

	* simd-intrinsics.c : Reorder the SimdIntrinsc struct to add more bits to
		   simd_version to support more simd versions. Changed the name of
		   simd_version to simd_version_flags to make it more intuitive that
		   it now contains bit flags. Reordered the *_intrinsics arrays to
		   match the changes above. Changed emit_intrinsics() to use the new
		   setup mentioned above.

	Code is contributed under MIT/X11 license.

2010-03-17 Rodrigo Kumpera  <rkumpera@novell.com>

	* mini-*.c (mono_arch_output_basic_block): Record try block holes on all
	remaining archs. Alpha and hppa maintainers, please stand up.

2010-03-17  Zoltan Varga  <vargaz@gmail.com>

	* mini-ppc.c (mono_arch_build_imt_thunk): Always save and restore r11 since it
	is needed even when fail_tramp!=NULL.

2010-03-17  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (insert_breakpoint): Write a log message.

2010-03-16 Rodrigo Kumpera  <rkumpera@novell.com>

	* iltests.il.in: Add a few tests for LEAVE going over multiple
	finally clauses.

2010-03-16 Rodrigo Kumpera  <rkumpera@novell.com>

	 * mini-x86.c (mono_arch_output_basic_block): Record try block holes.

2010-03-16 Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.h (MonoBasicBlock): Add native_length field.
	* mini.h (MonoCompile): Add try_block_holes field.
	* mini.h (MonoInst): Add exception_clause pointer to
	the data union.

	* mini.c (mono_codegen): Calculate MonoBasicBlock::native_length.
	* mini.c (mono_cfg_add_try_hole): New function to register possible
	holes in try blocks.
	* mini.c (create_jit_info): Fill in the holes information.

	* mini-exceptions.c: Verify for holes when checking if an IP is covered
	by a try block.

	* method-to-ir.c: Add the EH clause to the CALL_HANDLE instruction.

Tue Mar 16 13:16:16 CET 2010 Paolo Molaro <lupus@ximian.com>

	* jit-icalls.c: adjusted for the array API changes.

2010-03-16  Zoltan Varga  <vargaz@gmail.com>

	* iltests.il.in: Disable the fconv_to_i test on sparc too.

2010-03-16  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c: Simplify the way breakpoints are processed by removing
	the 'pending' flag. This fixes support for appdomains too.


Mon Mar 15 18:25:49 CET 2010 Paolo Molaro <lupus@ximian.com>

	* mini-amd64.c, mini-ia64.c: remove direct access to method->header.

2010-03-12  Zoltan Varga  <vargaz@gmail.com>

	* simd-intrinsics.c (simd_intrinsic_emit_getter): Don't emit shuffle opcodes
	when using LLVM, LLVM generates it itself when needed.

	* mini-llvm-cpp.cpp (mono_llvm_build_aligned_load): New helper function.

	* mini-llvm.c: Use an unaligned load for OP_LOADX_MEMBASE. Add zero extension
	to some OP_EXTRACT_ opcodes. Fix the naming of some sse intrinsics. Fix
	OP_ANDNPS/OP_ANDNPD.

2010-03-11  Zoltan Varga  <vargaz@gmail.com>

	* tramp-x86.c (mono_arch_create_monitor_enter_trampoline_full): Use 'code' for
	the pc instead of 'buf'. Fix the call to mono_arch_flush_icache ().
	(mono_arch_create_monitor_exit_trampoline_full): Ditto.

2010-03-11  Martin Baulig  <martin@ximian.com>

	* debugger-agent.c (type_commands): Add NULL check to
	`CMD_TYPE_GET_SOURCE_FILES'.

2010-03-09  Zoltan Varga  <vargaz@gmail.com>

	* mini-ppc.c (mono_arch_decompose_opts): Fix OP_ICONV_TO_R_UN when cross-compiling.

2010-03-09  Zoltan Varga  <vargaz@gmail.com>

	* mini-codegen.c (mono_peephole_ins): Fix the OP_FMOVE optimization. Fixes
	#586664.

	* iltests.il.in: Add a test.

2010-03-05  Martin Baulig  <martin@ximian.com>

	Add support for aborting invocations.

	* debugger-agent.c
	(InvokeData): Added `InvokeData *last_invoke'.
	(DebuggerTlsData): Renamed `invoke' into `pending_invoke' and
	added a new `invoke' field to keep the `InvokeData *' throughout
	the invocation.
	(ErrorCode): Added `ERR_NO_INVOCATION'.
	(CmdVM): Added `CMD_VM_ABORT_INVOKE'.
	(mono_debugger_agent_handle_exception): Don't report any exception
	if an abort was requested.
	(invoke_method): Store the `InvokeData *' in `tls->invoke'; reset
	a thread abort if necessary.
	(vm_commands): Implement `CMD_VM_ABORT_INVOKE'.

2010-03-08  Rodrigo Kumpera  <rkumpera@novell.com>

	* method-to-ir.c: Store the initial basic block returned by mono_basic_block_split
	so we can release the whole list and not just the first one. Free
	it in more places as well.

2010-03-08  Rodrigo Kumpera  <rkumpera@novell.com>

	* method-to-ir.c: Revert r153222 as it doesn't belong here.

Mon Mar 8 17:58:26 CET 2010 Paolo Molaro <lupus@ximian.com>

	* mini.h, *.c: prepare for MonoMethodHeader to become a transient entity.

Mon Mar 8 17:35:26 CET 2010 Paolo Molaro <lupus@ximian.com>

	* driver.c: report also other misc build options.

2010-03-07  Rodrigo Kumpera  <rkumpera@novell.com>

	* method-to-ir.c: Generate better code for the NewObject
	intrinsic.
	
2010-03-07  Zoltan Varga  <vargaz@gmail.com>

	* branch-opts.c (mono_if_conversion): Disable one of the cases when deadce
	is disabled. Fixes #582322.

	* iltests.il.in: Add a test.

2010-03-06  Zoltan Varga  <vargaz@gmail.com>

	* tramp-amd64.c (mono_arch_create_monitor_exit_trampoline_full): Delegate
	the handling of obj->synchronization == null and owner != current thread to
	mono_monitor_exit ().

	* tramp-x86.c (mono_arch_create_monitor_exit_trampoline_full): Ditto.


Sat Mar 6 18:14:15 CET 2010 Paolo Molaro <lupus@ximian.com>

	* mini.c: change the way emulated opcode info is stored and save about
	4 KB of runtime memory.

2010-03-04  David S. Miller  <davem@davemloft.net>

       * mini-sparc.h: Always use MONO_ARCH_USE_SIGACTION.  Linux kernels
       that don't provide the siginfo in the second signal handler argument
       are buggy, and this has been fixed for years.
       * mini.h (GET_CONTEXT): Remove __sparc__ special case.
       (SIG_HANDLER_SIGNATURE, SIG_HANDLER_PARMS): Likewise.

2010-03-04  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (find_symbol): Fix a leak.
	(decode_patch): Ditto.

2010-03-04  Zoltan Varga  <vargaz@gmail.com>

	* mini.h (MONO_INST_IS_TEMP): Kill this unused define.

2010-03-04  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_resolve_patch_target): Fix an uninitialized variable.

Wed Mar 3 19:19:21 CET 2010 Paolo Molaro <lupus@ximian.com>

	* method-to-ir.c: MONO_PROFILE_STRING_ALLOC is dead.

2010-03-03  Rodrigo Kumpera  <rkumpera@novell.com>

	* method-to-ir.c (mono_method_to_ir): Don't create a runtime vtable
	to check for errors, it's enough to create the metadata open.

	Fixes #562150

2010-03-03  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* trace.c|h:
	* mini-exceptions.c: Add support for printing stack traces when handling
	exceptions, and when printing exceptions thrown while tracing also print
	the exception message.

2010-03-03  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* trace.c: We need to parse exclude tokens ('-') before string tokens,
	since the exclude token is a valid string character.

2010-03-02  Levi Bard  <levi@unity3d.com>

	* debugger-agent.c: Invalidate thread stacks on domain unload.

2010-03-02  Mark Probst  <mark.probst@gmail.com>

	* method-to-ir.c: Emit dummy_use for stored reference after write
	barriers to make sure the object is pinned if the GC interrupts
	before the write barrier is done.

2010-03-02  Zoltan Varga  <vargaz@gmail.com>

	* cpu-<ARCH>.md: dummy_use was missing src1:i.

2010-03-01  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c: Add a log message printing the protocol version.

2010-03-01  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c: Add a new command to communicate the protocol version used
	by the client. This could be used to allow newer runtimes to communicate with
	older clients.

2010-03-01  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (domain_commands): Add a new command to create a boxed value.

2010-03-01  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (type_commands): Fix the setting of fields with a reference
	type.

Mon Mar 1 15:20:44 CET 2010 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c: make the arm cpu arch configurable with the
	MONO_CPU_ARCH env var (for example: "armv4 thumb").
	Bug #584198.

Mon Mar 1 14:48:35 CET 2010 Paolo Molaro <lupus@ximian.com>

	* mini.c, mini.h, driver.c: added the --jitmap option to enable
	support for the perf tool on Linux.

Mon Mar 1 14:43:55 CET 2010 Paolo Molaro <lupus@ximian.com>

	* method-to-ir.c: make string.InsertenalSetChar() specialization
	effective.

2010-03-01  Robert Jordan  <robertj@gmx.net>

	* Makefile.am: fix the non-static build.

2010-02-26  Zoltan Varga  <vargaz@gmail.com>

	* mini-generic-sharing.c: Move the contents of ../metadata/generic-sharing.c
	here.

2010-02-26  Robert Jordan  <robertj@gmx.net>

	* tasklets.c (continuation_store): Return from an error condition
	immediately.

2010-02-26  Martin Baulig  <martin@ximian.com>

	* debug-debugger.c (MonoDebuggerInfo): Added `abort_runtime_invoke'.

	* debug-mini.c
	(MonoDebuggerThreadInfo): Added `internal_flags'.
	(MonoDebuggerInternalThreadFlags): New enum.
	(_mono_debugger_throw_exception): Don't signal the debugger if a
	type abort was requested.
	(_mono_debugger_unhandled_exception): Likewise.
	(mono_debugger_abort_runtime_invoke): New method to abort an invocation.
	(mono_debugger_runtime_invoke): If the debugger requested a thread
	abort during the invocation, reset it here.

2010-02-26  Martin Baulig  <martin@ximian.com>

	* debug-mini.c (MonoDebuggerThreadInfo): Use `MonoInternalThread *'
	instead of `MonoThread *'.

2010-02-25  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (mono_aot_find_jit_info): Use a merge sort for sorting the
	code offsets table, as it is mostly sorted.

2010-02-25  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (do_invoke_method): Fix invoking of static methods on vtypes.
	Fixes #582991.

2010-02-25  Zoltan Varga  <vargaz@gmail.com>

	* driver.c (mono_main): Get rid of mono_setup_vtable_in_class_init.

Wed Feb 24 15:58:03 CET 2010 Paolo Molaro <lupus@ximian.com>

	* Makefile.am: build the new ABI version of the libmono library.
	* debugger-agent.c, mini.c: fix warnings with the new API.
	* jit.h: don't depend on glib.h being included.

2010-02-24  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mono_method_to_ir): Implement AOT support for fast TLS access.

2010-02-24  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mono_method_to_ir): Implement support for fast access to
	ThreadStatic variables.

2010-02-24  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (notify_thread): Skip terminated threads, since their tls
	data is not freed yet. Fixes #582460.

2010-02-23  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c: Add support for the caught/uncaught flags on exception
	event requests. Bump protocol minor version.

2010-02-22  Zoltan Varga  <vargaz@gmail.com>

	* decompose.c (mono_decompose_long_opts): Handle OP_LCONV_TO_OVF_I8 here too.

2010-02-22  Zoltan Varga  <vargaz@gmail.com>

	* decompose.c (mono_decompose_opcode): Handle OP_LCONV_TO_OVF_I8. Fixes
	#581950.

	* iltests.il.in: Add a test.

2010-02-22  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c (inline_method): Check for loader errors.

2010-02-22  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c (mono_method_check_inlining): Use !mono_method_get_header_summary
	instead of mono_method_get_header as it doesn't decode locals
	so the called method can have unresolved dependencies that will only
	be satisfied after the current method is JIT'd.

	Fixes #550968.

2010-02-22  Zoltan Varga  <vargaz@gmail.com>

	* basic.cs (test_0_div_opt): Speed this up a bit.

2010-02-20  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c: Fix DISABLE_JIT support after the latest changes.

	* mini.c (mono_jit_create_remoting_trampoline): Call
	mono_create_specific_trampoline () instead of
	mono_arch_create_specific_trampoline ().

	* mini-trampolines.c tramp-arm.c: Disable more stuff when DISABLE_JIT is set.

2010-02-20  Zoltan Varga  <vargaz@gmail.com>

	* unwind.c (mono_unwind_get_cie_program): New function, moved here from
	aot-compiler.c, so it can be found even if DISABLE_JIT is set.

	* aot-compiler.c xdebug.c: Update callers of mono_arch_unwind_get_cie_program ().

	* mini-amd64.c: Fix DISABLE_JIT support.

2010-02-20  Geoff Norton  <gnorton@novell.com>

	* aot-runtime.c: Ensure we dont leak a held lock when unwinding exceptions.

2010-02-20  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (mono_debugger_agent_handle_exception): Receive two contexts,
	one for the throw and one for the catch. Mark uncaught exceptions by a NULL
	CATCH_TXT. Send normal exception events for unhandled exceptions too.
	(mono_debugger_agent_handle_unhandled_exception): Remove this, merged into
	handle_exception.

2010-02-18  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-x86.c (mono_arch_get_restore_context): Changes this so it restores
	edx/ecx too. This is needed to support OP_SEQ_POINT.

2010-02-18  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-amd64.c (get_throw_trampoline): Add xdebug info.

	* method-to-ir.c (mono_method_to_ir): Fix SIZEOF in dynamic methods.

2010-02-16  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c aot-compiler.c aot-runtime.c unwind.c: Finish support
	LLVM+AOT+exceptions, not enabled yet.

2010-02-15  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (SIG_HANDLER_SIGNATURE): Fix the windows build.

2010-02-15  Zoltan Varga  <vargaz@gmail.com>

	* tramp-amd64.c (mono_arch_create_rgctx_lazy_fetch_trampoline_full): Emit
	xdebug info for these.

	* mini-trampolines.c (common_call_trampoline): Use mini_jit_info_table_find ()
	in a few places.

	* mini.c (mini_get_vtable_trampoline): Make this take a 'slot_index' argument,
	not used yet.

2010-02-13  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (load_profile_files): Update after the profiler changes.

2010-02-13  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_jit_compile_method_inner): Avoid passing icall wrappers to
	mono_profiler_method_end_jit, since the profiler has no way to process wrappers.

	* aot-runtime.c mini.c: Resurrect the aot pagefault profiling stuff, it is useful
	for mtouch.

2010-02-13 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* debugger-agent.c: handle incomplete reads and EINTR in
	recv()/send(). This could have been causing random
	disconnections.

2010-02-13  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (decode_exception_debug_info): Fix aot support for sequence
	points.

	* mini-arm.c (mono_arch_allocate_vars): Allocate the seq point related vars first
	so they have small offsets. Fixes #566311.

2010-02-12  Rodrigo Kumpera  <rkumpera@novell.com>

	* method-to-ir.c (mono_method_check_inlining): Check for loader errors.

2010-02-11  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c: Remove the special casing of byref in a few places now that
	mini_type_get_underlying_type () handles it.

	* mini-generic-sharing.c (mini_type_get_underlying_type): Handle byref as well
	by returning native int. Fixes #577984.

2010-02-11  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (handle_isinst): Factor out the is_complex_isinst check into
	a macro.

	* mini-llvm.c (exception_cb): Put the clause index into the type info instead
	of putting the clause itself.

	* mini-arm.c mini.c linear-scan.c: Disable more stuff when DISABLE_JIT is used.

2010-02-09  Zoltan Varga  <vargaz@gmail.com>

	* unwind.c (mono_unwind_frame): Use read32 for reading a 32 bit value, since it
	might be unaligned.

2010-02-10  Geoff Norton  <gnorton@novell.com>

	* aot-compiler.c: Make the number of IMT trampolines configurable as well.

2010-02-08  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_code): Create the ut trampolines here, so they work for
	llvm methods too.

	* aot-compiler.c (emit_code): Don't add the llvm label prefix to 'methods', since
	it is not an LLVM generated symbol.

	* mini-llvm.c (emit_entry_bb): Fix the handling of simd types.

	* method-to-ir.c (handle_castclass): Turn off the more efficient isinst/castclass
	implementation in gshared mode because it causes regressions.

	* mini-trampolines.c: Add a stat for the number of calls to trampolines.

	* image-writer.c (asm_writer_emit_global): Don't prepend the global prefix, it
	should be done by the caller.

	* mini-llvm.c (mono_llvm_emit_method): Don't make the debug symbols global.

	* aot-compiler.c (emit_code): Add the llvm label prefix before 'methods'.

	* mini-exceptions.c (mini_jit_info_table_find): Search the root domain as well,
	since mono_jit_info_table_find () doesn't do it anymore.

	* mini-generic-sharing.c debugger-agent.c: Call mini_jit_info_table_find ()
	instead of mono_jit_info_table_find ().

2010-02-07  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c aot-runtime.c: Add support for MONO_WRAPPER_WRITE_BARRIER.

	* aot-compiler.c (encode_method_ref): Update after the removal of
	mono_gc_get_managed_allocator_type ().

	* method-to-ir.c (mono_method_to_ir): Place a seq point just before a RET.
	Fixes #564538.

2010-02-06  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (handle_castclass): Use the icall for classes with variant
	generic params as well.
	(handle_isinst): Ditto.

	* method-to-ir.c: Make isninst/castclass checks in gshared code more efficient
	instead of always calling an icall.

	* aot-compiler.c (emit_llvm_file): Take into account trampolines etc when
	computing the size of the got.

	* aot-compiler.c (emit_code): Change the way the 'methods' symbol is emitted
	when using LLVM. Instead of emitting it as an LLVM method, emit it using
	the assembly directive '.set' so it points to the first LLVM emitted method.

2010-02-04  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c (mini_method_verify): Report the method which failed to verify.

2010-02-04  Rodrigo Kumpera  <rkumpera@novell.com>

	* method-to-ir.c (mono_method_to_ir): Use the new basic block formation pass
	to avoid JIT'ng dead basic blocks. This is the same behavior as the
	runtime MS verifier.

2010-02-04  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (decode_value): Fix decoding of vtype instances. Fixes
	#561962.

2010-02-04  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c: Init the jit module only when first JITting.

	* aot-compiler.c (emit_plt): Fix the naming of plt entries of llvm+darwin.

	* mini-llvm.c (get_plt_entry): Make the plt entries have hidden visibility.

	* mini-llvm.c (mono_llvm_emit_aot_module): Remove the dummy got after it is
	replaced with the real got.

	* debugger-agent.c (type_commands): Return the enumness if the type as well.

	* image-writer.c: Reduce the amount of #ifdefs a bit.

	* aot-compiler.c: Reduce the amount of #ifdefs. Add beginnings of support for
	llvm on darwin/arm.

	* aot-compiler.c (mono_compile_assembly): Handle asmonly+llvm mode.

	* mini-llvm.c (mono_llvm_emit_method): Don't make the 'type_info' symbols
	global.

2010-02-02  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c (mono_llvm_emit_method): Add support for unaligned loads.
	(mono_llvm_emit_method): Fix unaligned stores too.

	* mini-amd64.c (mono_arch_emit_prolog): Initialize lmf->rsp in the prolog too
	so async stack walks don't crash.

2010-02-02  Zoltan Varga  <vargaz@gmail.com>

	* mini-trampolines.c (common_call_trampoline): Fix a problem where the callsite
	was not patched if the callee needed an rgctx trampoline.

2010-02-01  Zoltan Varga  <vargaz@gmail.com>

	* mini-ppc.c (mono_arch_get_global_int_regs): Reserve r29 for holding the
	vtable address in AOT code.

2010-02-01  Zoltan Varga  <vargaz@gmail.com>

	* mini-codegen.c: Remove support for CEE_ opcodes which cannot occur in
	MonoInst's.

Mon Feb 1 16:29:10 CET 2010 Paolo Molaro <lupus@ximian.com>

	* genmdesc.pl: remove dependency on external cpp.

2010-02-01  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mini_emit_ldelema_1_ins): Avoid emitting an OP_SEXT_I4 when
	using LLVM, its not needed, and abcrem can't handle it.

Mon Feb 1 14:29:43 CET 2010 Paolo Molaro <lupus@ximian.com>

	* genmdesc.c, genmdesc.pl, cpu-x86.md: introduced templates to make
	it easier to group instructions and reduce duplication.

2010-02-01  Zoltan Varga  <vargaz@gmail.com>

	* decompose.c: Move the array/soft float decompose routines here from
	method-to-ir.c.

	* method-to-ir.c: Export a few functions so they can be used from decompose.c.

2010-01-31  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c (mono_llvm_emit_method): Add a call to llvm.invariant.start
	to tell LLVM that the got is constant, not used yet.

	* aot-compiler.c: Pass more optimization flags to llvm's 'opt'.

2010-01-30  Zoltan Varga  <vargaz@gmail.com>

	* mini-ppc.c (mono_arch_emit_prolog): Fix full aot support for native to
	managed wrappers.

2010-01-30  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (add_wrappers): Commit the hack which generates
	native-to-managed wrappers for methods decorated with the MonoPInvokeCallback
	custom attribute.

2010-01-29  Zoltan Varga  <vargaz@gmail.com>

	* mini.h (MONO_INST_FAULT): New instruction flag for loads which can cause
	a fault, only used by the LLVM backend.

	* ir-emit.h: Add _FAULT variants of the LOAD_MEMBASE macros. Mark
	OP_CHECK_THIS with OP_IMPLICIT_EXCEPTION.

	* method-to-ir.c: Use the new LOAD_MEMBASE_FAULT opcodes, get rid of the
	calls to MONO_EMIT_NULL_CHECK which is automatically done by the new macros.

	* mini-llvm.c: Only generate volatile loads from load instructions which have
	the MONO_INST_FAULT flag set.

2010-01-29  Zoltan Varga  <vargaz@gmail.com>

	* unwind.c (mono_unwind_decode_fde): Fix the decoding of the LSDA offset on
	64 bit platforms.

2010-01-28  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_save_seq_point_info): Fix the handling of bblocks without
	sequence points. Fixes #571236.

2010-01-28  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (mono_debugger_agent_init): Call appdomain_unload at the
	end of the appdomain unload process, after assemblies have been unloaded.
	Fixes #574842.

2010-01-27  Zoltan Varga  <vargaz@gmail.com>

	* abcremoval.c (process_block): Fix the if (region) check so abcrem actually
	works.

	* mini-amd64.c: Make the soft debugger work on platforms without MAP_32BIT.
	Fixes #573988.

2010-01-26  Zoltan Varga  <vargaz@gmail.com>

	* dwarfwriter.c (emit_type): Treat MONO_TYPE_PTR as 'I' not 'I4'.

2010-01-26  Geoff Norton  <gnorton@novell.com>

	* aot-compiler.c: Fix a logic error introduced when guarding against enums
	with struct marshalability.

2010-01-24  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_method_compile): Improve the processing MONO_VERBOSE_METHOD so
	it supports class names as well.

	* mini.h (MonoCompile): Add a few flags to control JIT behavior which are
	needed by the GC map code.

	* mini.c (mini_method_compile): Call a function in mini-gc.c to set the new
	flags if needed.

	* method-to-ir.c (mono_method_to_ir): Emit initialization code for ref variables
	if cfg->init_ref_vars is set.

	* liveness.c (optimize_initlocals): Disable the initlocals opt for ref vars if
	cfg->disable_initlocals_op_refs is set.

	* method-to-ir.c (mono_spill_global_vars): Compute more precise live ranges
	using liveness info if cfg->compute_precise_live_ranges is set.

	* mini-gc.c: Ongoing work. Improve logging and debugging support. Handle
	volatile variables correctly. Add comments about the live ranges. Not enabled
	yet.

2010-01-24  Zoltan Varga  <vargaz@gmail.com>

	* mini.h (MonoDebugOptions): Add an option to init stack frames by writing
	0x2a into them in method prologs.

	* mini-amd64.c (mono_arch_emit_prolog): Implement it.

2010-01-22  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm-cpp.cpp: Remove uses of dynamic_cast, it no longer works with llvm
	classes, since llvm is compiled with -fno-rtti.

	* mini.h (COMPILE_SOFT_FLOAT): New macro, similar to COMPILE_LLVM.

	* method-to-ir.c ir-emit.h: Use if (COMPILE_SOFT_FLOAT) in a few places since
	llvm does not require it.

	* aot-runtime.c (load_method): Print the full name of the last aot method.

2010-01-21  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-amd64.c (mono_arch_notify_pending_exc): Avoid a crash if the
	thread has not fully started yet.

2010-01-21  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (can_marshal_struct): Allow marshalling enums.

2010-01-21  Miguel de Icaza  <miguel@novell.com>

	* driver.c: Do not abort if LLVM is not supported, print a
	warning and add the information to the Mono JIT information.

2010-01-21  Zoltan Varga  <vargaz@gmail.com>

	* ir-emit.h (MONO_EMIT_NULL_CHECK): Don't emit an OP_IMPLICIT_EXCEPTION when
	using explicit null checks.

2010-01-20  Zoltan Varga  <vargaz@gmail.com>

	* xdebug.c: New file extracted from aot-compiler.c, containing the XDEBUG
	related code.

	* aot-compiler.c (encode_method_ref): Use mono_marshal_wrapper_info_from_wrapper
	() in one place.
	(mono_aot_wrapper_name): Remove the special handling of delegate invoke wrappers,
	its no longer needed.

	* method-to-ir.c (mono_method_to_ir): Fix a warning.

	* exceptions-<ARCH>.c: Introduce a MONO_ARCH_HAVE_THROW_EXCEPTION_BY_NAME
	define for platforms still using it (s390). Get rid of the
	mono_arch_get_throw_exception_by_name () routines on all other platforms.

	* exceptions-x86.c: Rework the throw trampolines so there is only one function
	which can generate throw/rethrow/corlib trampolines for llvm/not llvm code.

	* exceptions-x86.c: Add LLVM specific throw trampolines which doesn't assume
	the caller pushed the arguments.

	* mini-llvm.c: Enable throwing exceptions on x86.

	* mini-posix.c (SIG_HANDLER_SIGNATURE): Avoid
	"Thread (nil) may have been prematurely finalized" messages if this is called
	on a thread not registered with the runtime.

	* mini-exceptions.c (mono_handle_native_sigsegv): Ditto.

2010-01-19  Zoltan Varga  <vargaz@gmail.com>

	* jit-icalls.c (mono_array_new_3): New jit icall.

	* aot-compiler.c aot-runtime.c: Add support for ElementAddr wrappers.

	* arrays.cs: Add a test for 3 dimensional arrays.

2010-01-19  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-x86.c (mono_arch_get_throw_corlib_exception): Emit xdebug info.
	(mono_arch_find_jit_info_ext): Disable the popping of arguments when LLVM is
	used.

	* mini-llvm.c (emit_cond_system_exception): Abort when an implicit exception is
	thrown on x86.

	* unwind.c (mono_unwind_decode_fde): Fix an assert on x86.

	* mini-x86.h (MONO_CONTEXT_SET_LLVM_EXC_REG): Define this for x86.

	* mini-llvm.c: Disable OP_THROW on x86, it doesn't work yet.

2010-01-18  Bill Holmes  <billholmes54@gmail.com>

	* debugger-agent.c : Changing the PLATFORM_WIN32 preprocessor check to
	  HOST_WIN32.  Also including winsock2. to define struct in_addr.

	* mini-amd64.h : Changing the PLATFORM_WIN32 preprocessor check to HOST_WIN32.

	* mini-x86.h : Changing the PLATFORM_WIN32 preprocessor check to HOST_WIN32.

	Code is contributed under MIT/X11 license.

2010-01-18  Zoltan Varga  <vargaz@gmail.com>

	* mini.h (MonoCompile): Add 'disable_out_of_line_bblocks' flag.

	* branch-opts.c (mono_optimize_branches): Honor the new flag.

	* mini.c (mini_method_compile): Set the new flag when running under the
	debugger.

2010-01-18  Zoltan Varga  <vargaz@gmail.com>

	* mini-gc.c: Change the GC map to use a ref/noref/pin value instead of just
	a ref/noref value + a global pin flag, so parts of stack frames can still be
	precisely marked even if they include stuff which needs pinning. Improve logging.
	Fix many bugs. Not enabled yet.

	* gc-test.cs: Add a few tests.

	* liveness.c (mono_analyze_liveness): Make the debug output controllable by
	the normal -v options. Avoid propagating liveness information through bblocks
	which end with a NOT_REACHED opcode.

	* mini.c (mono_jit_compile_method_inner): Avoid reading cfg->prof_options
	after cfg has been freed.

2010-01-17  Zoltan Varga  <vargaz@gmail.com>

	* branch-opts.c (mono_branch_optimize_exception_target): Stop the optimization
	if a clause is skipped because it uses the exception object, since it could
	have caught the exception.

	* exceptions.cs: Add a test.

2010-01-16  Zoltan Varga  <vargaz@gmail.com>

       * mini-trampolines.c (mono_create_static_rgctx_trampoline): Add an assert.

        * aot-runtime.c (mono_aot_get_method): Handle ftnptr's correctly for the
        ICollection<T> wrappers.

2010-01-16  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (decode_value): Fix the decoding of I/U/PTR.

2010-01-16  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (emit_call_body): Always use near calls when AOTing even if
	NOMAP32BIT or optimize_for_xen is set.

2010-01-16  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c aot-runtime.c: Get rid of mono_aot_str_hash (), use
	mono_metadata_str_hash () instead.

2010-01-15  Zoltan Varga  <vargaz@gmail.com>

	* ir-emit.h (MONO_EMIT_NEW_ICOMPARE_IMM): Use sizeof (mgreg_t) instead of
	sizeof (void*).

        * unwind.c (mono_unwind_frame): Use mgreg_t instead of gssize.

2010-01-15  Zoltan Varga  <vargaz@gmail.com>

	* ir-emit.h (MONO_EMIT_NEW_CHECK_THIS): Emit an explicit null check if the
	flag is set.

	* mini-ppc.c (mono_arch_emit_exceptions): Compute the size of the exception
	throwing code correctly.

	* mini.h (MONO_AOT_FILE_VERSION): Bump this because of the IMT hashing changes.

2010-01-15  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (mono_aot_plt_resolve): Reenable the previous assert for
	ftnptrs created by us, handle RGCTX_FETCH correctly.
	(mono_aot_get_lazy_fetch_trampoline): Add an ftnptr.

	* mini-trampolines.c (mono_create_generic_class_init_trampoline): Remove the
	ftnptr added by mono_aot_get_named_code ().

2010-01-14  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c: Fix a few LLVM problems.

	* mini-llvm.c (simd_class_to_llvm_type): Fix compilation on !x86/amd64.

2010-01-13  Mark Probst  <mark.probst@gmail.com>

	* method-to-ir.c (mini_emit_stobj): Use EMIT_NEW_CLASSCONST when
	AOT compiling.

Wed Jan 13 15:54:53 CET 2010 Paolo Molaro <lupus@ximian.com>

	* jit.h, method-to-ir.c: added ability to set the policy for
	inserting breakpoints from the break IL instruction or the
	Debugger.Break () API call.

2010-01-13  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (load_aot_module): Add more comments to explain why referenced
	assemblies need to be eagerly loaded.

2010-01-12  Zoltan Varga  <vargaz@gmail.com>

	* dwarfwriter.c (emit_line_number_info): Fix the eglib case so it doesn't crash.

2010-01-11  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (mono_debugger_agent_parse_options): Allow onthrow without
	an argument which matches any exception.

2010-01-10  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mono_emit_method_call_full): Avoid the virt->nonvirt
	optimization if the called method is gshared and marshalbyref, since gshared
	methods can' have wrappers. Fixes #569390.

	* generics.cs: Add a test.

2010-01-10  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (mono_print_thread_dump_from_ctx): New helper function
	callable from gdb.

2010-01-10  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_print_method_from_ip): Fix the lookup of trampolines.

2010-01-09  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (transport_connect): comment out freeaddrinfo calls under win32,
	since it is not supported in win2000.

2010-01-08  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (load_image): Add a SET_ERROR argument to set the loader
	error if loading an assembly fails.
	(mono_aot_plt_resolve): Return NULL instead of asserting if loading fails.

	* mini-trampolines.c (mono_aot_plt_trampoline): Throw a pending loader error
	if exists.

	* aot-runtime.c (decode_exception_debug_info): Set jinfo->from_llvm for LLVM
	compiled methods.

	* mini-llvm-cpp.cpp: Remove the unused ctx variable.

	* mini-llvm.c (mono_llvm_emit_method): Add some comments about why aot+clauses
	is not supported yet.

	* unwind.c (DW_EH_PE_absptr): Add more DW_EH_PE_ constants.

2010-01-07  Rodrigo Kumpera  <rkumpera@novell.com>

	* method-to-ir.c: All types with variant arguments must fallback to the
	slow path. This makes cast of variant delegates work.

	* mini-trampolines.c (mono_get_vcall_slot_addr): Add new variance_used out
	argument that is set to TRUE is the returned vtable slot is for a variant
	interface. Changed a g_print + g_assert_not_reached to a g_error.

	* mini-trampilines.c (common_call_trampoline): Handle variant interfaces in
	a similar fashion of generic virtual methods.

2010-01-07  Rodrigo Kumpera  <rkumpera@novell.com>

	* helpers.c (mono_disassemble_code): Fix a g_hash_table warning
	when cfg is null.

	* mini-trampolines.c (mono_convert_imt_slot_to_vtable_slot): Convert a given
	method using a variance aware function.

	* mini-x86.c: Add support for dumping IMT thunks if DEBUG_IMT is defined.

2010-01-07  Rodrigo Kumpera  <rkumpera@novell.com>

	* method-to-ir.c (mono_method_to_ir): Casts to variant interfaces
	do an icall for now.

2010-01-07  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm-cpp.cpp (mono_llvm_create_ee): Add an ugly hack to fix #564695.
	If LLVM decides to set the code model to Large, reset it to Default.

2010-01-07  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (mono_xdebug_flush): Export it so it is present in
	stripped binaries as well.

2010-01-07  Zoltan Varga  <vargaz@gmail.com>

	* mini-trampolines.c (common_call_trampoline): Add an rgctx trampoline if a shared
	method is called from LLVM compiled code, as that code can't pass an rgctx arg.

	* mini-llvm.c (mono_llvm_emit_method): Enable calls to methods needing an rgctx
	reg.

2010-01-06  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_method_compile): Extract the JIT info creation code into a
	separate function.

	* mini-llvm.c (mono_llvm_emit_method): Pass the info in MonoExceptionClause
	as the type info to llvm.eh.selector.
	(exception_cb): Use the type info for filling out some fields of
	MonoJitExceptionInfo like the flags and the exception class. This is needed
	because the LLVM produced exception handling clauses might not match the original
	IL clauses, i.e. there might be more than one LLVM clause for one IL clause.

	* unwind.c (mono_unwind_decode_fde): Extract the LSDA decoding code into a
	separate function. Add an extra argument which returns the type infos
	corresponding to the exception clauses.

	* mini.c (mini_method_compile): Enable LLVM compilation of methods having
	exception handling clauses.

2010-01-04  Zoltan Varga  <vargaz@gmail.com>

	* mini-trampolines.c (mono_convert_imt_slot_to_vtable_slot): Call
	mono_method_get_vtable_slot () instead of accessing imt_method->slot directly,
	to fix an AOT case.

2010-01-04  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c (mono_compile_is_broken): Skip methods from serialization's
	internal assembly.

2010-01-04  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_method_compile): Fix a few memory leaks introduced by the
	llvm code.

2009-01-04  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c (mini_method_compile): Verify the method before calling
	mono_compile_create_vars as this might crash since it uses method
	information.

	Fixes #560196.

2010-01-04  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mono_method_to_ir): Avoid calling mono_class_vtable () in
	one case if AOTing, since the class might not be a concrete class.

2010-01-03  Zoltan Varga  <vargaz@gmail.com>

	* mini-codegen.c abcremoval.c: Remove the duplicate g_slist_append_mempool
	functions which are now defined in mempool-internals.h.

	* mini.c (mini_free_jit_domain_info): Free the seq point hash tables.

	* mini-llvm.c (mono_llvm_emit_method): Handle OP_ABS.

2009-12-30  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c:
	* method-to.ir.c:
	* mini-*.c: Properly handle generic enums.

	Fixes #566294

2009-12-28  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mono_method_to_ir): Handle the failure of mono_class_vtable ()
	in a few more places.

2009-12-27  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (add_wrappers): Don't use dyn runtime invoke for methods with
	nullable parameters. Fixes #567351.

2009-12-26  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini-trampolines.c (common_call_trampoline): Add assert for NULL resolved generic method.

2009-12-26  Zoltan Varga  <vargaz@gmail.com>

	* mini-trampolines.c: Use mono_arch_get_this_arg_from_call () to avoid the slow
	mono_get_generic_context_from_code () call.

	* mini-<ARCH>.c: Get rid of mono_arch_find_this_arg (), it is no longer used.

2009-12-25  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (decode_klass_ref): Don't call mono_class_init (), its not
	needed.

2009-12-24  Sebastien Pouliot  <sebastien@ximian.com>

	* method-to-ir.c (mono_method_to_ir): Avoid SIGSEGV when
	mono_method_get_signature returns NULL. Fix #567084

2009-12-25  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (find_extra_method): Call mono_aot_wrapper_name only once,
	instead of once for each module.

2009-12-22  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (ss_start): Implement step over for the last sequence
	point in methods.

	* mini.c (mono_save_seq_point_info): Don't link sequence points which don't
	have the STEP_LOC flag set.

	* aot-runtime.c (decode_klass_ref): Avoid a crash if a decode_klass_ref () call
	fails. Fixes #566689.

2009-12-21  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_add_seq_point): New helper function.
	(mono_save_seq_point_info): New function to save sequence point info, extracted
	from mini_method_compile ().

	* mini-<ARCH>.c: Call mono_add_seq_point to remember sequence points.

	* mini.h (MonoSeqPointInfo): New structure containing information about
	the sequence points of a JITted method.
	(MonoBasicBlock): Add 'seq_points' and 'last_seq_point' fields. Remove unused
	'bucket' field.

	* mini.c debugger-agent.c aot-compiler.c aot-runtime.c: Change the way sequence
	point information is stored, use a MonoSeqPointInfo structure instead of a
	GPtrArray. For each seq point, compute a list of successor seq points.

	* debugger-agent.c: Use the successor list to implement step-over more
	efficiently: instead of single stepping until a different line/IL offset is
	reached, place breakpoints into all successor seq points.

	* mini.h: Bump AOT file format version.

2009-12-21  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am (AM_CFLAGS): Include LLVM_CFLAGS.

	* mini-llvm.c: Avoid defining the __STDC_... macros if already defined.

2009-12-21  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-ppc.c (mono_ppc_set_func_into_sigctx): Fix the cross-compiler
	build.

2009-12-18  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (mono_arch_get_argument_info): Allocate memory for CallInfo using
	alloca as g_malloc is not signal safe.

2009-12-18  Zoltan Varga  <vargaz@gmail.com>

	* tramp-x86.c (mono_arch_patch_callsite): Fix the call to
	VALGRIND_DISCARD_TRANSLATIONS.

	* *.c: Include mono/utils/memcheck.h, and remove #ifdef HAVE_VALGRIND_MEMCHECK_H
	checks, they are no longer needed.

	* exceptions-ppc.c (mono_ppc_set_func_into_sigctx): New helper function to set
	a function into a sigctx which can handle function pointers.

	* mini-ppc.c: Implement soft debugger support on ppc64.

	* mini-ppc.c: Implement soft debugger support.

2009-12-17  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c: Handle OP_LADD_OVF_UN. Place all alloca's into the entry bb.

2009-12-17  Marek Habersack  <mhabersack@novell.com>

	* mini.c (mono_get_runtime_build_info): include Mono version in
	the returned value.

	* driver.c (mono_main): VERSION is now included in the string
	returned from mono_get_runtime_build_info()

2009-12-17  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mono_method_to_ir): Add support for CALLI with unmanaged
	signatures. Fixes #565143.

	* jit-icalls.c (mono_get_native_calli_wrapper): New JIT icall.

2009-12-16  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (arch_emit_autoreg): Align code to 4 in the ppc case.

2009-12-16 Rodrigo Kumpera  <rkumpera@novell.com>

	* mini-x86.h: Forgot to add a 0x to MONO_ARCH_MAX_FRAME_SIZE define
	making max stack 10x smaller.

2009-12-16  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_resolve_patch_target): Comment out an assert which could be hit.

2009-12-15 Rodrigo Kumpera  <rkumpera@novell.com>

	* method-to-ir.c (mini_emit_memcpy): Assert if size is too big.

2009-12-15 Rodrigo Kumpera  <rkumpera@novell.com>

	* mini-x86.c (mono_arch_allocate_vars): Fail compilation if the frame size is
	bigger than MONO_ARCH_MAX_FRAME_SIZE.

	* mini-x86.c (mono_arch_emit_prolog): Handle huge frames.

	* mini-x86.h: Define MONO_ARCH_MAX_FRAME_SIZE to be 1Mb.

	* mini-amd64.c / mini-amd64.h: Same fixes as of above.

	* mini.c (mini_method_compile): Check if mono_arch_allocate_vars failed
	the compilation.

2009-12-14  Miguel de Icaza  <miguel@novell.com>

	* method-to-ir.c (mono_method_to_ir): CEE_UNUSUED opcodes now
	raise an invalid program exception.   

	For other opcodes that we might not handle use a g_warning and
	raise the exception.   Beats termination.

	Fixes #561724

2009-12-14  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mono_emit_rgctx_method_call_full): Fix a warning.

	* tramp-amd64.c (mono_arch_nullify_class_init_trampoline): Fix the LLVM support
	by merging the LLVM and !MAP_32BIT cases.

2009-12-14  Geoff Norton  <gnorton@novell.com>

	* debugger-agent.c: The end_runtime_invoke guard isn't working on 
	AMD64 as __builtin_frame_address (1) returns NULL.  Disable the 
	behaviour by default, and make it runtime configurable.
	
2009-12-13 Jonathan Chambers <joncham@gmail.com>

	* debugger-agent.c (mono_debugger_agent_thread_interrupt): Handle a NULL
	sigctx being passed in, as we have no CONTEXT available in the APC.

	(mono_debugger_agent_cleanup): Use explicit cond wait implementation
	for now.

	Code contributed under MIT/X11 license.

2009-12-13  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c mini-llvm.c: Fix support for monitor enter/exit trampolines
	in the LLVM backend on AMD64.

	* aot-runtime.c (decode_eh_frame): Initialize the clauses from the info in the
	FDE.

	* unwind.c (mono_unwind_decode_fde): Implement decoding of a couple more formats.

	* mini-llvm.c: Export mono_personality for AOT.

	* mini.c (mini_method_compile): Fix some problems with llvm+aot+clauses.

	* mini-ops.h (OP_IMPLICIT_EXCEPTION): New opcode marking the place where an
	implicit exception can occur.

	* ir-emit.h (MONO_EMIT_NEW_IMPLICIT_EXCEPTION): New macro to emit an
	OP_IMPLICIT_EXCEPTION instruction.

	* ir-emit.h (MONO_EMIT_NEW_CHECK_THIS): New macro.

	* method-to-ir.c: Use MONO_EMIT_NEW_CHECK_THIS in a few places.

	* mini-llvm.c: Handle OP_IMPLICIT_EXCEPTION by disabling llvm if it occurs
	inside a protected block.

	* mini-llvm.c: Revert the last change, the signature of monitor entry/exit
	trampolines doesn't include the argument.

	* mini-llvm.c (mono_llvm_emit_method): Enable calls to monitor entry/exit
	trampolines on amd64.

	* mini-amd64.h (MONO_ARCH_MONITOR_OBJECT_REG): Use MONO_AMD64_ARG_REG1 instead
	of RDI.

	* mini.c (mini_method_compile): Add some comments as to why LLVM is currently
	disabled for methods with clauses.

	* mini-llvm.c: Enable support for catch clauses.

	* mini-exceptions.c (mono_resume_unwind): New function to resume unwinding at the
	end of an LLVM compiled finally clause.
	(mono_handle_exception_internal): Save the exception handling state in TLS
	before calling an LLVM compiled finally clause, so mono_resume_unwind () can
	resume unwinding from that point.

	* unwind.c (mono_unwind_get_ops_from_fde): Rename this to
	mono_unwind_decode_fde, decode the Language Specific Data Area (LSDA) too,
	to obtain the addresses of the exception handling regions.

	* mini-llvm.c: Add beginnings of support for exception handling, currently only
	finally clauses are supported.

	* mini.c (mini_method_compile): Add support for LLVM code with exception
	handlers.

2009-12-12  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c (mono_llvm_emit_method): Allocate the 'pindexes' array with the
	proper size.

2009-12-12  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c: Encode the this argument of vtype methods as a struct, not
	as a primitive type.

2009-12-11  Zoltan Varga  <vargaz@gmail.com>

	* driver.c: Applied patch from Matt McClellan (matt@mc-c.net). Add a check
	for 2 parameter sched_setaffinity in older glibc versions. Fixes
	#564000.

2009-12-11  Marek Habersack  <mhabersack@novell.com>

	* method-to-ir.c (mini_redirect_call): do not redirect the
	InternalAllocateStr internal call if string profiling is enabled.

2009-12-10  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (add_wrappers): Avoid generating synchronized wrappers for
	generic methods.

	* unwind.h: Rename this to mini-unwind.h to avoid conflicts with the gcc
	unwind.h header file.

	* tramp-x86.c (mono_arch_patch_callsite): Patch the code when using valgrind,
	newer valgrind versions seems to handle this fine.

2009-12-09  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (start_runtime_invoke): Fix a crash if this is called
	on the debugger thread.

2009-12-08  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c (mono_llvm_emit_method): Add more SIMD opcodes.

	* mini.c (mono_print_method_from_ip): Fix the lookup of trampolines.

	* mini-codegen.c (mono_local_regalloc): Allow non-call opcodes with cloc:c.

	* cpu-<ARCH>.md: Make call_handler clob:c.

	* mini.c: Reenable SSA for methods with clauses.

	* mini.c (mini_method_compile): Disable SSA for now for methods with clauses,
	as it causes failures on x86.

2009-12-08  Sebastien Pouliot  <sebastien@ximian.com>

	* driver.c: Fail gracefully with --compile-all if mono_method_signature
	returns NULL (e.g. a bad assembly).

2009-12-08  Geoff Norton  <gnorton@novell.com>

	* debugger-agent.c:  Refactor the mono_runtime_invoke guarding against
	stepping out into native code.  There were issues with nested invokes
	like .cctors.

2009-12-07  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_method_compile): Do the disable_llvm checks early
	and avoid the LLVM compile pass if the checks fail.

	* mini.c ssa.c abcremoval.c: Enable SSA for methods with exception clauses.

	* mini-llvm.c: Put our methods/globals into the 'llvm.used' array, so the
	LLVM optimizations don't try to remove them.

	* aot-compiler.c (emit_llvm_file): Save the result of opt into a
	different file so the original remains.

2009-12-06  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c mini.c: Fix alignment issues with SIMD vars.

	* aot-runtime.c (decode_arm_exidx): Handle most descriptors created by gas.

	* aot-runtime.c (decode_arm_exidx): Refactor this into two functions, add
	support for non-inline unwind descriptors.

2009-12-07  Geoff Norton  <gnorton@novell.com>

	* debugger-agent.c:  Darwin can colesce signals, so we need to handle
	the interrupt_count slightly differently.  Native threads were never
	marked as resumed.

2009-12-05  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (decode_arm_exidx): New function to initialize a MonoJitInfo
	based on the contents of the ARM .exidx section. Not yet used since llvm doesn't
	yet generate this info.

	* mini-llvm.c: Fix the conversion of call results if they are unsigned.

	* debugger-agent.c (buffer_add_value): Treat I/U as a valuetype, so the
	client can distinguish between intptrs and longs.

2009-12-05  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_trampoline): Emit the trampoline info into the global
	blob.

	* aot-runtime.c (load_function): Update after the change above.

	* mini.h: Bump AOT file format version.

	* method-to-ir.c (mono_method_to_ir): Disallow the delegate optimization
	if the delegate class is dynamic.

	* method-to-ir.c (handle_delegate_ctor): Allow the method_code optimization
	in gshared code too using the new rgctx info type
	MONO_RGCTX_INFO_METHOD_DELEGATE_CODE.

2009-12-04  Geoff Norton  <gnorton@novell.com>

	* debugger-agent.c: When doing a func-eval invoke on a suspended runtime,
	we need to track the original suspend count so the thread properly
	wakes up in resume_thread.

2009-12-04  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (handle_delegate_ctor): Add support for using this from gshared
	code.

	* generics.cs: Add a test.

	* method-to-ir.c (emit_get_rgctx_method): Make this work even if context_used
	is 0. Simplify a lot of code using this.

	* mini-trampolines.c (mono_delegate_trampoline): Call
	mono_create_static_rgctx_trampoline () before saving the final address in
	delegate->method_code, to avoid calling it each time a delegate is first called.

	* method-to-ir.c (mono_method_to_ir): Allow fast delegate creation for methods
	which need static rgctx trampolines.

	* mini-trampolines.c (mono_create_static_rgctx_trampoline): Use a cache
	keyed on the method+addr pair, since addr could be either the method addr or
	an unbox trampoline in the AOT case. Fixes #560246.

2009-12-03  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_method_compile): Call handle_exception_clauses () in the same
	place it was called before too.

2009-12-03  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_jit_runtime_invoke): Avoid the call to mono_class_setup_vtable ()
	if no security manager is present, to speed up the AOT case. Call
	mono_class_vtable () full with raise_on_error == TRUE instead.

2009-12-03  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_method_compile): Call handle_exception_clauses earlier so
	the local optimization passes can take its result into account. Fixes
	#559876.

	* exceptions.cs: Add a test.

2009-01-24  Steven Munroe  <munroesj@us.ibm.com>

	This patch is contributed under the terms of the MIT/X11 license

        * cpu-ppc64.md (load_memindex): Add loadi8_memindex.

2009-12-03  Zoltan Varga  <vargaz@gmail.com>

	* mini.h (MonoInst): Remove unused 'ssa_op' field.

	* debugger-agent.c: Rework the handling of stack traces of running threads to
	avoid crashes if compute_frames () tries to walk the stack of running thread.

	* mini.c (mono_print_method_from_ip): Use mini_jit_info_table_find.

	* mini-exceptions.c (mono_jit_walk_stack_from_ctx_in_thread): Set frame->lmf.

	* mini.h (StackFrameInfo): Add an 'lmf' field.

2009-12-02  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (suspend_current): Always set really_suspended.

	* debugger-agent.c (clear_event_request): Clear method entry/exit requests too.

	* exceptions-x86.c (mono_arch_get_restore_context): Restore EAX too.

2009-12-01  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (vm_commands): Don't allow invokes on threads which are not
	really suspended.

2009-12-01  Zoltan Varga  <vargaz@gmail.com>

	* cpu-ppc64.md (store_memindex): Add storei8_memindex.

2009-12-01 Rodrigo Kumpera  <rkumpera@novell.com>

	* mini-trampolines.c: Fix MSVC build.

2009-12-01 Rodrigo Kumpera  <rkumpera@novell.com>

	* mini-trampolines.c: Check for mono_method_get_vtable_slot failures.

2009-11-30  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c (mono_arch_lowering_pass): Fix an assert which is hit when
	the instruction following an OP_FCOMPARE is optimized away.

2009-11-30  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (arch_emit_autoreg): Extract the auto-registration code from
	emit_autoreg () into this arch-specific function.

	* aot-compiler.c (emit_exception_debug_info): Don't emit the length of the
	code, it is no longer needed.

	* aot-runtime.c (decode_exception_debug_info): Don't read the code length.

	* mini.h: Bump AOT file format version.

	* aot-runtime.c (mono_aot_find_jit_info): Compute the length of the method
	using the sorted_code_offsets array, instead of reading it from the
	exception debug info.
	(load_method): Call mono_aot_find_jit_info instead of
	decode_exception_debug_info ().

	* aot-compiler.c (emit_exception_debug_info): Emit whenever the method was
	LLVM compiled as a flag.

2009-11-29  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (resume_thread): Fix a warning.

	* aot-compiler.c: Add an option to set the number of static rgctx trampolines
	generated.

2009-11-28  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c aot-runtime.c: Get rid of a few global symbols, move their
	contents to MonoAotFileInfo.

2009-11-27  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c aot-runtime.c: Reorganize the AOT file format once again.
	Put all binary data into a giant blob, similarly to the way .net assemblies
	store binary data. Emit offset tables in a compact form to reduce their size.

	* mini.h: Bump AOT file format version.

	* aot-compiler.c (emit_globals_table): Use temp_prefix instead of .L in a few
	places.

	* aot-compiler.c (emit_globals_table): Emit a hash table for the globals, to
	avoid linear searches at runtime.

	* aot-runtime.c (find_symbol): Update this to use the hash.

	* mini.h: Bump AOT file format version.

2009-11-26  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_klass_info): Save whenever the class has a generic
	container.

	* aot-runtime.c (decode_cached_class_info): Set the is_generic_container field
	too.

	* aot-compiler.c (mono_compile_assembly): Add a 'stats' option to print out
	the distribution of got slot types.

	* mini.h (MonoDebugOptions): Add 'explicit_null_checks' option.

	* method-to-ir.c: Add support for generating explicit null checks.

2009-11-25  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (vm_commands): Implement EXIT by invoking Environment.Exit ()
	on a random thread if possible.

	* aot-runtime.c (mono_aot_plt_resolve): Clean up the handling of function
	descriptors a bit, add comments, handle RGCTX_FETCH/GENERIC_CLASS_INIT_TRAMPOLINE
	correctly.

	* exceptions-ppc.c (mono_arch_find_jit_info_ext): Use mgreg_t as the type of
	regs. Pass the real size of the regs array to mono_unwind_frame ().

	* unwind.c (mono_unwind_frame): Remove an incorrect assert, add more correct
	ones instead.

2009-11-24  Geoff Norton  <gnorton@novell.com>

	* mini-darwin.c: Work around apple bug rdar://7209349  See
	http://openradar.appspot.com/7209349 for details.  Synopsis,
	CoreFoundation SIGTRAP's if you dlopen it off the main thread if its
	never been initialized before.

2009-11-24  Zoltan Varga  <vargaz@gmail.com>

	* tramp-arm.c: Use blx instead of mov pc, reg to improve support for thumb.

	* mini-arm.c (mono_arm_thumb_supported): New helper function.

2009-11-24  Zoltan Varga  <vargaz@gmail.com>

	* cfold.c (mono_constant_fold_ins): Fix a problem in the previous change,
	OP_SHL_IMM is not 32 bit.

2009-11-24  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (encode_patch): Fix the encoding of R8 on big-endian systems.

2009-11-24  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c: Avoid infinite recursion when generic virtual recursion is
	encountered.

	* debugger-agent.c (resume_vm): Signal the suspend_cond even if suspend_count
	> 0 since some threads can resume if their resume_count is > 0.
	(invoke_method): Avoid reading freed memory.

	* debugger-agent.c (process_suspend): Extract the suspend code from
	process_single_step_inner () to a separate function. Rework the code to prevent
	races between this function and thread interrupts.

	* debugger-agent.c (suspend_current): Check the resume_count field instead
	of resume_one so suspends+resumes during single threaded invokes work
	correctly.

2009-11-23  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_llvm_file): Enable some llvm optimizations which seem
	to make the generated code smaller.

	* tramp-amd64.c (mono_arch_nullify_class_init_trampoline): Add a code
	sequence generated by recent LLVM versions.

	* mini-llvm.c: Add support for a few simple cases which weren't supported
	before.

	* mini-trampolines.c (mono_magic_trampoline): Don't call
	mono_arch_get_vcall_slot () when llvm is enabled.

	* aot-compiler.c (emit_llvm_file): Add code to run the 'opt' llvm tool.

	* mini-trampolines.c (mono_magic_trampoline): Extract the bulk of this function
	into a new function called common_call_trampoline () which is used by the
	llvm vcall trampoline as well.

	* debugger-agent.c: Implement single threaded invokes.

	* debugger-agent.c: Revert change which broke the agent on linux.

	* method-to-ir.c (inline_method): Prevent infinite recursion. Fixes
	#557606.

	* generics.cs: Add a test.

2009-11-22  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c: Fix the cygwin build.

2009-11-21  Zoltan Varga  <vargaz@gmail.com>

	* cprop.c: Remove this unused file.

2009-11-21  Zoltan Varga  <vargaz@gmail.com>

	* cfold.c (mono_constant_fold_ins): Fix constant folding of shr_imm. Fixes
	#557262.

	* basic.cs: Add a test.

2009-11-21  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mono_method_to_ir): Use mono_use_llvm instead of ENABLE_LLVM
	in one more place.

2009-11-20  Zoltan Varga  <vargaz@gmail.com>

	* mini.c mini-trampolines.c driver.c: Add a 'mono_use_llvm' flag to control
	whenever the runtime uses LLVM code. Add a '--llvm' command line option to set
	it. Use this flag to control llvm related code paths instead of #ifdef
	ENABLE_LLVM, so a runtime configured without --enable-llvm can use LLVM compiled
	AOT code.

	* aot-runtime.c aot-compiler.c: Add a 'flag' field to MonoAotFileInfo.

	* mini.h: Bump AOT file format version.

	* tramp-ppc.c (mono_arch_create_generic_class_init_trampoline_full): These
	receive their argument in MONO_ARCH_VTABLE_REG, not in the first argument reg.

	* debugger-agent.c (create_event_list): Fix a crash if an empty assembly list
	was used as an assembly filter.

2009-11-19  Zoltan Varga  <vargaz@gmail.com>

	* unwind.c: Fix support for ppc.

	* exceptions-ppc.c (mono_arch_find_jit_info): Change this to use dwarf frame
	unwind info. Change to the mono_arch_find_jit_info_ext () interface.

2009-11-19  Zoltan Varga  <vargaz@gmail.com>

	* mini-ppc.c (mono_arch_emit_prolog): Fix a copy-paste error to fix the ppc64
	port.
	(mono_arch_cpu_init): Don't set cpu_hw_flags to 0 at the end, this was somehow
	added by the ps3 changes.

2009-11-19  Zoltan Varga  <vargaz@gmail.com>

	* mini-gc.c: Resurrect this, so at least it compiles.

	* debugger-agent.c (assembly_commands): Implement GET_NAME command.

2009-11-18  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (mono_debugger_agent_handle_exception): Pass a MonoJitInfo to
	create_event_list () so assembly filters can be used.

	* exceptions-ppc.c (mono_arch_find_jit_info): Fix the restoration of registers
	from the LMF.

2009-11-17  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (mono_debugger_agent_breakpoint_hit): Fix a warning.
	(mono_debugger_agent_thread_interrupt): Make this return FALSE if the agent
	is disabled.

	* aot-compiler.c (add_generic_instances): Emit instances of common generic
	classes for char/bool too.

	* debugger-agent.c (DebuggerTlsData): Honor the DISABLE_SOFT_DEBUG option.

	* debugger-agent.c (DebuggerTlsData): Add a 'really_suspended' flag, not yet
	used.

	* debugger-agent.c: Add some definitions to make backporting to 2.6 easier.
	Fix warnings.

2009-11-15  Andreas Faerber  <andreas.faerber@web.de>

	* debugger-agent.c (mono_debugger_agent_thread_interrupt): Signature fix.
	
	Code contributed under MIT/X11 license.

2009-11-14  Zoltan Varga  <vargaz@gmail.com>

	(mono_debugger_agent_thread_interrupt): Save the context so stacktraces for
	threads in native code work.

	* debugger-agent.c: Pass the 'flags' argument to VM_INVOKE_METHOD earlier in
	the parameter list, so it can be acted upon by vm_commands (). Bump protocol
	version.

2009-11-13 Jonathan Chambers <joncham@gmail.com>

	* debugger-agent.c: Implementation for Windows platform.

	* mini-x86.c: Add support for Windows. Use mono-* synchronization
	primitives. Use SEH to implement breakpoints and single stepping.

	* mini-x86.h: Enable soft debugger on Windows.

	Code contributed under MIT/X11 license.

2009-11-13  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (emit_call_body): Disable usage of near calls when running
	under XEN. Fixes #522894.

	* patch-info.h: Add LLVM_IMT_TRAMPOLINE.

	* mini-llvm.c aot-compiler.c aot-runtime.c mini.c: Add support for making
	interface calls in LLVM AOT code.

	* aot-compiler.c mini-llvm.c: Abort llvm compilation if a non-encodable patch
	is found.

	* mini-llvm.c: Add support for OP_VPHI.

	* objects.cs: Add a test.

2009-11-13  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (mono_debugger_agent_single_step_event): Avoid a crash if
	this is called on the debugger thread.

2009-11-12  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c: Add soft-float support.

	* method-to-ir.c (mono_decompose_soft_float): Restart after decomposing an
	FCALL which returns an R4.

	* driver.c (mono_main): Add a missing '\n'.

	* mini-trampolines.c (mono_create_llvm_imt_trampoline): Fix the build on
	platforms which doesn't support the LLVM IMT trampoline.

2009-11-11  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c (mono_llvm_emit_method): Fix LOCALLOC.

	* mini-llvm-cpp.cpp: Update to latest LLVM SVN.

	* mini-llvm.c (mono_llvm_emit_method): Avoid creating plt entries for
	virtual calls.

	* aot-runtime.c: Don't define HAVE_DL_ITERATE_PHDR, configure now does that.

2009-11-10  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c aot-runtime.c: Change how mono_arch_find_jit_info () works.
	Instead of emitting a method_order table, sort the contents of the code_offsets
	table and do a binary search in the sorted table. The previous approach doesn't
	work with LLVM which emits methods in a arbitrary order.

	* aot-runtime.c: Add support for creating MonoJitInfo structures by searching
	in the .eh_frame section in ELF files.

	* mini.h: Bump corlib file format version.

	* mini-llvm.c aot-compiler.c: Add support for AOT to the LLVM back end.

	* exceptions-arm.c (mono_arch_get_call_filter_full): Update after the
	LDMIA->LDM macro name change.

2009-11-09  Zoltan Varga  <vargaz@gmail.com>

	* tramp-x86.c (mono_arch_get_llvm_imt_trampoline): Fix and enable this for
	x86.

	* mini-llvm-cpp.cpp (JITMemoryManager): Fix compilation with LLVM 2.7
	SVN.

	* aot-compiler.c: Ditto.

	* mini-arm.c (mono_arch_allocate_vars): Fix the previous change by passing
	&align to mini_type_stack_size_full ().

	* mini-arm.c (mono_arch_emit_prolog): Implement support for varargs.

	* mini-ops.h: Add documentation for the OP_ARGLIST opcode.

2009-11-08  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c: Compute the stack space used by arguments using
	mini_type_stack_size_full ().

2009-11-08  Zoltan Varga  <vargaz@gmail.com>

	* optflags-def.h: Remove dead TREEPROP optimization.

2009-11-08  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini-ppc.h: Make mono compiler under FreeBSD/ppc64. 

	Patch by Justin Hibbits <chmeeedalf@gmail.com>.

2009-11-07  Zoltan Varga  <vargaz@gmail.com>

	* driver.c (mono_jit_parse_options): New public API function to parse options
	as done by the runtime executable.

	* debugger-agent.c (buffer_add_cattrs): Fix reading an uninitialized variable
	when handling named arguments.

2009-11-07  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c: Implement support for returning vtypes in registers, fix support
	for passing small vtypes in registers, make the CallInfo structures more
	similar to the code on the other platforms.

	* mini-arm.c (mono_arch_allocate_vars): Align small vtypes to 4 bytes too since
	the code in the prolog requires it.

2009-11-06  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c debugger-agent.c: Android changes from Koushik K. Dutta
	(koush@koushikdutta.com).

	* mini-arm.c (handle_thunk): Add a domain argument to control the domain
	where the thunk memory should be allocated from. Fixes appdomain unloading
	on arm.

2009-11-06  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c exceptions-arm.c: Make ctx->regs map directly to the 16 hardware
	registers, instead of r4..r11,ip,lr. Make restore_context () restore r0..r3 too.

2009-11-05  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_output_basic_block): Don't allow OP_SEQ_POINT in
	AOT, as it is not implemented yet.

	* mini-x86.c (mono_arch_output_basic_block): Ditto.

2009-11-05  Rodrigo Kumpera  <rkumpera@novell.com>

	* debugger-agent.c: Fix windows build.

2009-11-05  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (debugger_thread): Call mono_set_is_debugger_attached ()
	after the client connects/disconnects.

	* debugger-agent.c: Add an 'onthrow' option to start the debugger agent
	when an exception of a given type is thrown.

	* debugger-agent.c: Add a 'onuncaught' option to start the debugger agent
	only on an uncaught exception.

	* mini-exceptions.c: Notify the debugger agent on an uncaught exception.

	* debugger-agent.c: Add a 'launch' option.

2009-11-05  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c: Add a 'timeout' option.

2009-11-05  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c: Implement the 'server' and 'suspend' options supported by
	the JDWP agent.

2009-11-05  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c (set_breakpoint): Emit a log message.

2009-11-04  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c: Fix the arm build.

2009-11-04 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* aot-compiler.c: don't leak the value returned from
	mono_type_full_name().

2009-11-04 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* debugger-agent.c: defer including mono-mutex.h until we know the
	agent is supported.

2009-11-04 Jonathan Chambers <joncham@gmail.com>

	* debugger-agent.c: Changes to build on windows. Use mono-mutex instead
	of pthreads directly.

	* mini.c (mono_sigfpe_signal_handler): Changed signature of Windows
	exception handlers. Pass info argument.

	* mini.h: Adjust signatures of soft debugger functions to pass void*
	instead of siginfo_t. Adjust SIG_HANDLER_SIGNATURE on Windows.

	* mini-amd64.c (mono_arch_is_single_step_event): Adjust signature to pass void*
	instead of siginfo_t. Value is EXCEPTION_RECORD on Windows.
	(mono_arch_is_breakpoint_event): Adjust signature to pass void*
	instead of siginfo_t. Value is EXCEPTION_RECORD on Windows.

	* mini-amd64.h: Adjust MonoW32ExceptionHandler signature.

	* mini-x86.c (mono_arch_is_single_step_event): Adjust signature to pass void*
	instead of siginfo_t. Value is EXCEPTION_RECORD on Windows.
	(mono_arch_is_breakpoint_event): Adjust signature to pass void*
	instead of siginfo_t. Value is EXCEPTION_RECORD on Windows.

	* mini-x86.h: Adjust MonoW32ExceptionHandler signature.

	* exceptions-x86.c: Adjust W32_SEH_HANDLE_EX for new signature.

	* exceptions-amd64.c: Adjust W32_SEH_HANDLE_EX for new signature.

	* mono-semaphore.h: Skeleton implementation for Windows.

	Code contributed under MIT/X11 license.

2009-11-04 Jonathan Chambers <joncham@gmail.com>

	* simd-intrinsics.c (simd_intrinsic_emit_setter): Unfix my fix.

	Code contributed under MIT/X11 license.

2009-11-04 Jonathan Chambers <joncham@gmail.com>

	* simd-intrinsics.c (simd_intrinsic_emit_setter): Fix windows build.

	Code contributed under MIT/X11 license.

2009-11-04  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (mono_save_xdebug_info): Bump the threshold for flushing
	debug info to 100 because 10 still slows down gdb too much.

	* method-to-ir.c (mono_method_to_ir): Avoid rethrowing thread abort exceptions
	inside runtime invoke wrappers. This avoids the need to call ResetAbort () on
	them in the wrappers.

2009-11-03  Zoltan Varga  <vargaz@gmail.com>

	* mini-trampolines.c (mono_llvm_vcall_trampoline): Add an assert.

	* simd-intrinsics.c (simd_intrinsic_emit_setter): Fix a warning.

	* aot-runtime.c (mono_aot_get_method): Refactor some code into a new helper
	function mono_aot_get_array_helper_from_wrapper ().

	* aot-compiler.c (add_generic_class): Refactor the code a bit, really emit
	array helper methods.

2009-11-03  Rodrigo Kumpera  <rkumpera@novell.com>

	* simd-intrinsics.c (load_simd_vreg): Add extra argument to signal if
	the value was loaded from memory.

	* simd-intrinsics.c (simd_intrinsic_emit_setter): Store back to memory if
	the value was loader from there.

	* simd-intrinsics.c (simd_intrinsic_emit_shuffle): Fail correctly for Shuffle
	without constant swizzle.

2009-11-02 Jonathan Chambers <joncham@gmail.com>

	* mini-amd64.c: Put soft debugger functions behind a
	#ifdef MONO_ARCH_SOFT_DEBUG_SUPPORTED.

	* mini-amd64.h: disable the soft debugger in windows.

	Code contributed under MIT/X11 license.

2009-11-02 Jonathan Chambers <joncham@gmail.com>

	* mini-x86.c: Put soft debugger functions behind a
	#ifdef MONO_ARCH_SOFT_DEBUG_SUPPORTED.

	Code contributed under MIT/X11 license.

2009-11-02 Jonathan Chambers <joncham@gmail.com>

	* exceptions-x86.c (win32_handle_stack_overflow): Fix parameters
	to mono_arch_find_jit_info_ext.

	Code contributed under MIT/X11 license.

2009-11-03  Zoltan Varga  <vargaz@gmail.com>

	* debugger-agent.c: Include netinet/in.h to fix the bsd build.

	* debugger-agent.c: Add support for filtering events by assemblies.

	* debugger-agent.c (mono_debugger_agent_thread_interrupt): Return false if
	the agent is not enabled.

2009-11-02 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* exceptions-x86.c: hopefully last change to fix the windows build.
	This one courtesy of Jonathan Chambers.

2009-11-02 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* debugger-agent.c: remove unused function.

2009-11-02 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* debugger-agent.c: add #ifdefs for a few header files.
	* mini-x86.h: disable the soft debugger in windows.
	Step 1 of 2 to make this compile on windows with gcc.

2009-11-02  Zoltan Varga  <vargaz@gmail.com>

	* tramp-x86.c (mono_arch_get_llvm_imt_trampoline): Comment this out for now
	as it breaks the build.

2009-07-01  Zoltan Varga  <vargaz@gmail.com>

	Merge the soft debugger branch.

	* debugger-agent.h debugger-agent.c: New files containing the soft
	mode debugger module.

	* method-to-ir.c (mono_method_to_ir): Generate OP_SEQ_POINT opcodes
	at the appropriate locations.

	* mini-<ARCH>.c (mono_arch_output_basic_block): Handle OP_SEQ_POINT
	opcode.

	* mini-<ARCH>.c: Add new arch-specific functions to set/clear breakpoints,
	enable/disable single stepping.

	* exceptions-<ARCH>.c (mono_arch_find_jit_info_ext): New stack unwinding api
	which returns all information in a StackFrameInfo structure, and can handle the
	LMF frames added by the debugger.

	* mini-<ARCH>.h (MonoLMFExt): New structure containing additional information
	about an LMF frame.

	* mini-exceptions.c (mono_jit_walk_stack_from_ctx_in_thread): New stack
	walker function which works on a specific thread and passes a StackFrameInfo
	structure to its callback.

	* mini.c (mini_init): Initialize the debugger agent.

	* aot-compiler.c aot-runtime.c: Add soft-debug support.

	* mini-ops.h: Add OP_SEQ_POINT opcode.

	* driver.c (mono_main): Add new '--debugger-agent' option for passing
	arguments to the debugger agent.

2009-11-02  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_method_compile): Disable llvm for methods with an lmf here to
	speed things up.

	* mini-llvm.c (mono_llvm_emit_method): Add support for OP_LOCALLOC.

	* tramp-x86.c (mono_arch_get_llvm_imt_trampoline): Implement this for x86.

	* mini.c (mini_init): Avoid using the IMT trampoline in the LLVM case.

	* mini-trampolines.c (mono_llvm_vcall_trampoline): Add a static rgctx trampoline
	if needed.
	(mono_create_llvm_imt_trampoline): New function to create a trampoline which
	sets the IMT argument and makes a virtual call.

	* mini-llvm.c: Enable interface calls using the llvm imt trampoline.

2009-11-01  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am (llvm_sources): Enable the llvm option since it no longer breaks
	the windows build.

2009-10-30  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_cleanup): Call profiler shutdown before shutting down the
	runtime. Fixes #551228.

2009-10-29  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (mono_arch_output_basic_block): Fix % 1. Fixes #550970.

	* basic.cs: Add a test.

	* method-to-ir.c (mono_method_to_ir): Use EMIT_NEW_LOAD_MEMBASE_TYPE to
	load vtypes instead if OP_LOADV_MEMBASE in the implementation of
	CONSTRAINED. Fixes #550964.

	* generics.cs: Add a test.

2009-10-28  Mark Probst  <mark.probst@gmail.com>

	* mini-posix.c (add_signal_handler): Use
	mono_gc_get_suspend_signal() instead of GC_get_suspend_signal().

2009-10-28 Jerry Maine <crashfourit@gmail.com>

	Contributed under the terms of the MIT/X11 license by
	Jerry Maine <crashfourit@gail.com>.

	* mini-x86.c (mono_arch_cpu_enumerate_simd_versions): Added code to detect
	sse4a for simd intrinsics.

	* mini-amd64.c (mono_arch_cpu_enumerate_simd_versions): Added code to detect
	sse4a for simd intrinsics.

2009-10-27  Zoltan Varga  <vargaz@gmail.com>

	* ir-emit.h method-to-ir.c: Change a few _IMM macros to assign to inst_imm
	instead of inst_p1 which is not the same on ILP32 platforms.

2009-10-24  Zoltan Varga  <vargaz@gmail.com>

	* mini-ppc.c (mono_arch_emit_prolog): Load the current got address,
	not the mscorlib one before calling mono_get_lmf_addr.

	* tramp-ppc.c (mono_arch_create_trampoline_code_full): Fix the storing
	of the ip to the LMF.

	* method-to-ir.c (mono_method_to_ir): Fix the handling of the
	immediate in the op->op_imm optimization.

	* mini-ppc.c: Add a 'vtregs' field to ArgInfo to make the code easier to
	understand. VTypes now work, but are not abi compliant, as they are
	split into 4 byte parts instead of 8.
	(emit_memcpy): Fix the unrolled case to work on the PS3.

	* mini-ppc.c (get_delegate_invoke_impl): Fix this for the PS3.

	* aot-compiler.c (mono_compile_assembly): Make the autoreg option
	the default when static linking.

	* mini-ppc.c (mono_arch_emit_prolog): Fix handling of I8 arguments.

	* aot-compiler.c: Add an autoreg option to automatically register
	statically linked aot modules using ELF .ctors.

	* genmdesc.pl: Add __ppc64__ to allowed defines.

2009-10-25  Zoltan Varga  <vargaz@gmail.com>

	* mini-posix.c (add_signal_handler): Delay the GC suspend signal while
	executing a SIGSEGV handler on an altstack, since libgc can't handle that.

2009-10-24  Mark Probst  <mark.probst@gmail.com>

	* exceptions-x86.c (mono_arch_find_jit_info): Fix build.

2009-10-24  Zoltan Varga  <vargaz@gmail.com>

    	* mini-exceptions.c (mini_jit_info_table_find): Add an 'out_domain' argument
    	which will contain the domain where the method was found.

    	* exceptions-<ARCH>.c mini-exceptions.c: Update callers of
    	mini_jit_info_table_find ().

	* aot-compiler.c (xdebug_end_emit): Remove so stray debug code.

	* branch-opts.c (mono_if_conversion): Avoid running deadce if it is disabled.

2009-10-22  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (mono_arch_emit_prolog): Disable aot for methods with save_lmf
	set, its not supported yet.

2009-10-22  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (mono_aot_get_method): Avoid asserting if a array generic
	iface wrapper is not found.
	(mono_aot_get_method): Ditto for GetGenericValueImpl.

2009-10-21  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (mono_aot_get_method): Fix support for the IList<T> wrappers,
	which have a different name.

	* aot-runtime.c (mono_aot_get_method): Special case the array generic iface
	wrappers and Array.GetGenericValueImpl ().

	* aot-compiler.c: Avoid emitting some wrappers which are not needed anymore
	because of the change above.

	* generics.cs: Add a test for full aot + generic array ifaces.

2009-10-19  Sebastien Pouliot  <sebastien@ximian.com>

	* aot-compiler.c (emit_plt): Remove duplicate 'debug_sym' variable 
	that hides the previous one.

2009-10-18  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (can_marshal_struct): Allow some System.dll structs to be
	marshalled. Fixes #541623.

2009-10-16  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_extra_methods): Remove some asserts which are not needed.

2009-10-15  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_op_imm_to_op): Handle OP_AND/OR/XOR_IMM.

2009-10-14  Massimiliano Mantione  <massi@ximian.com>

	* mini-posix.c (sigprof_signal_handler):
	Implemented support for building stat call chans in different ways.

2009-10-14  Massimiliano Mantione  <massi@ximian.com>

	* mini-exceptions.c (mono_find_jit_info):
	Also check that a jit info has been found (fixes a profiler crash).

2009-10-14  Massimiliano Mantione  <massi@ximian.com>

	* mini.c (mono_codegen):
	Call mono_profiler_code_buffer_new with correct code address.

2009-10-14  Zoltan Varga  <vargaz@gmail.com>

	* driver.c (mono_main): Change the date in the copyright.

2009-10-14  Mark Probst  <mark.probst@gmail.com>

	* method-to-ir.c (mono_method_to_ir): Don't use a managed array
	allocator in shared generic code for open classes, because we
	can't get those classes' vtables.  We need to make managed
	allocators not depend on the vtable at compile-time to solve this.

2009-10-13  Martin Baulig  <martin@ximian.com>

	* debug-mini.c (mono_debugger_trampoline_compiled): Add
	`const guint8 *trampoline' argument; send both the old and the new
	notification.

2009-09-30  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (add_wrappers): Add a runtime invoke wrapper which is used by
	mono_runtime_capture_context () without calling mono_runtime_invoke ().
	(can_marshal_struct): Skip structures with auto layout.

	* tramp-arm.c (GEN_TRAMP_SIZE): Increase this by 4.

2009-10-02  Zoltan Varga  <vargaz@gmail.com>

	* mini-sparc.c (mono_arch_emit_setret): Emit long return values using OP_LMOVE.
	(mono_arch_create_vars): Instead of allocating a stack slot by hand, allocate
	a variable to hold the stack slot used by the int<->float conversion opcodes.

	* mini-sparc.c (mono_arch_build_imt_thunk): Implement support for fail_tramp.

2009-10-04  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (add_generic_class): Only add GetGenericValueImpl wrappers
	when using full-aot.

2009-10-06  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (add_generic_class): Add an instance of GenericComparer<T> for
	each instance of Comparer<T>.

	* generics.cs: Add a new test.

2009-10-09  Zoltan Varga  <vargaz@gmail.com>

	* driver.c (parse_debug_options): Add a 'gdb' option.

	* mini.c (mini_parse_debug_options): Add a 'gdb' option.

	* image-writer.c: Add support for emitting the image into a memory buffer.

	* dwarfwriter.c: Add support for sharing one IL file between multiple images.

	* aot-compiler.c: Add support for registering debug info with GDB using the
	new JIT debugging interface in GDB 7.0. It can be turned on by setting
	MONO_XDEBUG to 'gdb'.

2009-10-10  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (mono_save_trampoline_xdebug_info): Implement this for the
	gdb mode.

2009-10-11  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (mono_save_xdebug_info): Emit a symbol for the method which
	can be used to set breakpoints in gdb.

	* image-writer.c (bin_writer_emit_writeout): Add support for setting the text
	segment to an absolute address.

2009-10-13  Mark Probst  <mark.probst@gmail.com>

	* method-to-ir.c: Use the managed array allocator method if
	available.

2009-10-13  Bill Holmes  <billholmes54@gmail.com>

	* aot-compiler.c : Fix the MSVC builds

	Code is contributed under MIT/X11 license.

2009-10-13  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (mono_save_xdebug_info): Group methods into groups of 10 to
	avoid registering 1 symbol file per method with gdb.

2009-09-29  Zoltan Varga  <vargaz@gmail.com>

	* mini-sparc.c: Fix the handling of enums with base type long.

	* mini-sparc.c (mono_arch_output_basic_block): Fix IREM_UN_IMM.

	* mini-sparc.c (mono_arch_allocate_vars): Use mono_class_from_mono_type ()
	instead of using type->data.klass as the later doesn't work with generics.

2009-09-25  Mark Probst  <mark.probst@gmail.com>

	* method-to-ir.c, mini.h, mini-alpha.c, mini-amd64.c, mini-arm.c,
	mini-hppa.c, mini-ia64.c, mini-mips.c, mini-ppc.c, mini-s390.c,
	mini-s390x.c, mini-sparc.c, mini-x86.c: Thread.get_CurrentThread
	works differently now and we don't handle it in the JIT anymore.

	* mini.c, mini-exceptions.c, mini-posix.c, debug-debugger.c,
	debug-mini.c, tramp-amd64.c, tramp-x86.c: Changes resulting from
	the Thread class split.

2009-09-25  Zoltan Varga  <vargaz@gmail.com>

	* driver.c: Don't run tests with the obsolete treeprop optimization.

	* mini-sparc.c (mono_arch_create_vars): Make the component vars of a long ret
	variable volatile. Fixes #541577.

	* basic-calls.cs: Add a new test.

	* basic-long.cs: Remove tests which are now in basic-calls.cs.

2009-09-24  Zoltan Varga  <vargaz@gmail.com>

	* dwarfwriter.c (emit_debug_info_end): Disable this as it doesn't seem to
	work/required with recent iphone sdk versions.

	* aot-compiler.c (add_wrappers): Generate PtrToStructure wrappers for more
	structures.

	* decompose.c (mono_decompose_vtype_opts): Avoid reading uninitialized memory
	in the VCALL decomposition code.

2009-09-22  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c (mono_arch_output_basic_block): Fix ISHR/ISHR_IMM.

	* basic.cs: Add a test.

	* mini-ia64.c (mono_arch_build_imt_thunk): Implement support the virtual
	generic invokes.

	* mini-exceptions.c (mini_jit_info_table_find): New helper function which
	searches all the domains of the current thread.

	* exceptions-<ARCH>.c: Use it. Fixes #539394.

2009-09-21  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-arm.c (mono_arm_throw_exception): Set ctx->ebp to fp instead of sp
	so catching exceptions thrown in the same method works. Fixes exception17.exe.

	* tramp-arm.c (mono_arch_create_trampoline_code_full): Store NULL into lmf->method
	for non-jit trampolines.

	* mini.c (mono_jit_runtime_invoke): Allow string ctors with dyn runtime invoke.

	* aot-compiler.c (add_wrappers): Ditto.

	* mini-arm.c: Implement support for passing vtypes and floats, and increase
	the size of the param area used by dyn_call to 6 which covers the majority of
	methods.

	* mini.c aot-compiler.c: Allow dyn_call for string methods except ctors.

	* mini-arm.c: Implement support for passing/receiving
	longs and receiving floats in the dyn_call code.

	* mini-amd64.c: Implement support for receiving vtypes in registers in
	the dyn_call code.

	* mini.c mini-amd64.c: Implement partial support for passing vtypes in
	the dyn_call code.

2009-09-20  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c (get_call_info): Return more precise information in
	ArgInfo->regtype.
	(dyn_call_supported): Use the information in CallInfo.

	* mini-arm.c: Enable support for returning vtypes in the dyn_call code.

	* mini.c mini-amd64.c: Enable support for returning vtypes in the dyn_call
	code.

	* mini-arm.c: Update after the dyn_call api changes.

	* mini.c (mini_create_jit_domain_info): Register a destructor function
	for the runtime_invoke_hash.

	* mini-amd64.c (mono_arch_get_dyn_call_args): Rename this to
	'mono_arch_dyn_call_start'. Pass the pointer to the return value buffer to
	this function.
	(mono_arch_get_dyn_call_ret): Rename this to 'mono_arch_dyn_call_finish'.
	(dyn_call_supported): Simplify this by using get_call_info ().
	(mono_arch_dyn_call_free): New destructor function.

	* generics.cs: Remove a printf.

	* method-to-ir.c (mono_method_to_ir): Allocate some param area for DYN_CALL.

	* mini-arm.c: Add support for enum return values and passing a few arguments
	on the stack.
	
	* mini.c (mono_jit_runtime_invoke): Add support for enum return values to
	dyn invoke.

	* mini-amd64.c (mono_arch_get_dyn_call_ret): Ditto.

	* aot-compiler.c (add_wrappers): Add a few restrictions for the use of
	the dynamic invoke wrappers.

	* mini-arm.c: Implement OP_DYN_CALL for arm.

	* aot-compiler.c (add_wrappers): Avoid aot-ing runtime invoke wrappers
	supported by the dynamic runtime invoke wrapper.

	* aot-compiler.c aot-runtime.c: Add support for encoding the dynamic
	runtime invoke wrapper.

	* mini.c (mono_jit_runtime_invoke): Use the dynamic runtime invoke wrappers
	if possible when running with full-aot.

	* mini-ops.h: Add OP_DYN_CALL opcode.

	* mini-amd64.c method-to-ir.c: Add infrastructure for making method calls
	with dynamic arguments lists similar to libffi.

2009-09-19  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c: Fix the previous change on 64 bit platforms.
	
	* method-to-ir.c: Applied patch from Rodrigo Kumpera. Allow an i8 argument
	to NEWARR.

	* iltests.il.in: Add a new test.
	
2009-09-18  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (add_generic_instances): Add more instances of
	GenericEqualityComparer.

2009-09-18  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c: Add asserts for mono_class_vtable calls that are not meant to fail.

2009-09-18  Rodrigo Kumpera  <rkumpera@novell.com>

	* method-to-ir.c: Handle failures from mono_class_vtable. Added some
	comments on some functions that now can fail.

2009-09-17  Andrew Jorgensen  <ajorgensen@novell.com>

	* Makefile.am: Add Info.plist to EXTRA_DIST

2009-09-16  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mono_method_to_ir): Allow AOT for CEE_LDTOKEN in
	static synchronized wrappers. Fixes #539500.

2009-09-14  Rodrigo Kumpera  <rkumpera@novell.com>

	* jit-icalls.c (mono_class_static_field_address): handle vtable failure
	properly.

2009-09-16  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (mono_handle_exception_internal): Store the computed
	lmf before calling filter clauses as well. Fixes #539550.

	* exceptions.cs: Add a test.
	
2009-09-14  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (add_generic_class): Add instances of
	Array.GetGenericValueImpl as well.

	* Makefile.am (fullaotcheck): Copy and aot more assemblies so linq
	can be tested too.

	* generics.cs: Add a fullaot linq test.

2009-09-10  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (arch_emit_static_rgctx_trampoline): Don't clobber argument
	reg r1 on arm.

2009-09-10  Bill Holmes  <billholmes54@gmail.com>

	* mini-trampolines.c (mono_delegate_trampoline) : Call
	  mono_cominterop_get_invoke if the delegate target object
	  is a COM object.

	Code is contributed under MIT/X11 license.

2009-09-09  Sebastien Pouliot  <sebastien@ximian.com>

	* method-to-ir.c: For CoreCLR throw a SecurityException if an 
	internal call is defined outside platform code. Reduce code 
	duplication with existing [Method|Field]AccessException

2009-09-08  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini-x86.c (mono_arch_emit_call): Don't reduce stack usage by 4
	if the return value is a small struct passed on regs.

2009-09-09  Zoltan Varga  <vargaz@gmail.com>

	* cpu-arm.md mini-arm.c: Remove unused opcodes.

	* mini-codegen.c: Enable the cpu description validation for arm.

2009-09-08  Zoltan Varga  <vargaz@gmail.com>

	* basic-calls.cs: Move the test_0_float_load_and_store_with_big_offset ()
	test which depends on structs to objects.cs.
	
	* basic-calls.cs: Remove calls to Console.WriteLine and throws, since those
	require object model related stuff working.

	* cpu-x86.md mini-x86.c: Remove more unused opcodes.

	* mini-ops.h: Fix OP_BIGMUL instruction descriptions.

	* mini-codegen.c (mono_local_regalloc): Validate the cpu description 
	against the instruction metadata in mini-ops.h. amd64 only for now.

	* mini-ops.h: Fix some instruction descriptions.

	* mini-ops.h mini-x86.c mini-amd64.c cpu-<ARCH>.md: Remove some
	unused instructions.

2009-09-06  Zoltan Varga  <vargaz@gmail.com>

	* exceptions.cs: Add a new test.

2009-09-05  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini-x86.c (needs_stack_frame): OSX requires full frames to keep proper alignment.

2009-09-06  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c (mono_llvm_emit_method): Add a few more missing casts,
	skip empty phi opcodes.
	
	* mini-llvm.c (mono_llvm_emit_method): Handle unsigned volatile variables
	correctly by zero extending after loads. Skip methods containing calls
	to the monitor enter/exit trampolines.

	* tramp-x86.c (mono_arch_create_trampoline_code): Align the stack
	when calling mono_thread_force_interruption_checkpoint ().

	* mini.c (mini_method_compile): Disable llvm when AOT compiling.

	* tramp-amd64.c (mono_arch_patch_callsite): Add support for 32 bit ->
	64 bit thunks.
	(mono_arch_nullify_class_init_trampoline): Read 'buf' instead of 'code'.

	* mini-llvm.c (mono_llvm_emit_method): Add a few missing conversions so a 
	bootstrap could run.

2009-09-04  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_init): Set callbacks.get_runtime_build_info ().

2009-09-03  Zoltan Varga  <vargaz@gmail.com>

	* tramp-amd64.c (mono_arch_nullify_class_init_trampoline): Pass the start
	of the method to
	mono_breakpoint_clean_code () when using LLVM as the prologues generated by
	LLVM might be very short.

	* mini-x86.c (mono_arch_output_basic_block): Maintain stack alignment
	in OP_THROW/RETHROW.

	* exceptions-x86.c: Rewrite the throw trampolines so they maintain stack
	alignment on osx.

2009-09-03  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_get_vcall_slot): Pass the start of the method to
	mono_breakpoint_clean_code () when using LLVM as the prologues generated by
	LLVM might be very short.

2009-09-01  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-x86.c (throw_exception): Fix the previous change by substracting
	the alignment for the value of sp.

2009-09-01  Geoff Norton  <gnorton@novell.com>

	* mini.c (mono_get_lmf_addr): Fix jit_thread_attach for native to 
	managed wrappers in full aot.

2009-08-31  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-x86.c (get_throw_exception): Align the stack on osx.

2009-08-28  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm-cpp.cpp mini-llvm.c: Update to latest llvm api.

2009-08-25  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_exception_debug_info): Emit ei->flags too.

	* aot-runtime.c (decode_exception_debug_info): Decode ei->flags from the
	saved info.

	* mini.h (MONO_AOT_FILE_VERSION): Bump this.

	* aot-runtime.c aot-compiler.c: Emit exception causes fully so we don't
	depend on the info MonoMethodHeader which could be missing in IL stripped
	assemblies.

2009-08-25  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c (add_general): Fix the passing of 64 bit values on darwin, where
	they are only 4 byte aligned.

2009-08-21  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c (mono_arch_allocate_vars): Use FP as the frame pointer as
	was done previously, since using SP causes too many problems.

	* exceptions-arm.c: Fix the handling of sp/fp so unwinding through
	frames without a frame pointer works.

        * mini-arm.c (mono_arch_get_global_int_regs): Avoid using V5 as a
        global register in methods with calls, since the calls can go through
        a static rgctx trampoline which doesn't save it.

2009-08-19  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c (mono_arch_context_get_int_reg): Handle SP as well.

2009-08-18  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (add_generic_instances): Fix the net 1.1 build.

2009-08-18  Christian Hergert  <chris@dronelabs.com>

	* method-to-ir.c: Fix warnings for uninitialized variables.

2009-08-18  Christian Hergert  <chris@dronelabs.com>

	* mini-exceptions.c:
	* aot-compiler.c: Fix printf warnings.

2009-08-18  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (add_generic_instances): Add string[] wrapper methods.
	Add GetGenericValueImpl<string>.
	
	* aot-compiler.c (add_generic_instances): Add instances of
	GenericEqualityComparer<T> for primitive types. Only emit the array
	wrappers into the mscorlib image.

2009-08-15  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (load_method): Rename 'aot_module' -> 'amodule'. Allocate
	the methods_loaded array using amodule->info->nmethods.

	* mini.h (MonoAotFileInfo): Add an 'nmethods' field.
	(MONO_AOT_FILE_VERSION): Bump this.

	* aot-compiler.c: Emit more generic instances allowing some parts of linq
	to work.

	* aot-runtime.c (mono_aot_get_unwind_info): Handle the case when the
	MonoJitInfo doesn't belong to its methods aot image.

2009-08-14  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c (mono_arch_allocate_vars): Use SP as the default frame reg.

	* mini-arm.c: Fix warnings.
	
	* mini-arm.c (mono_arm_emit_load_imm): Only emit a movt if needed.

	* mini-arm.c (mono_arm_emit_load_imm): Use movt/movw if the cpu
	supports it.

2009-08-12  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (arch_emit_imt_thunk): Rework the arm code to
	avoid clobbering IP.

	* mini-trampolines.c (mono_magic_trampoline): Allocate a local to
	hold the trampoline argument, so its initial value is available during
	debugging.

2009-08-11 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* exceptions-arm.c:
	* exceptions-hppa.c:
	* mini.c:
	* exceptions-s390x.c:
	* exceptions-mips.c:
	* exceptions-ppc.c:
	* exceptions-sparc.c:
	* exceptions-alpha.c:
	* aot-runtime.c:
	* mini-trampolines.c:
	* exceptions-x86.c:
	* exceptions-s390.c: add and use #define's instead of sizeof()
	for MonoJitInfo and MonoJitInfoTable.

2009-08-10 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* tramp-arm.c:
	* tramp-amd64.c:
	* tramp-ppc.c:
	* tramp-x86.c: use a #define instead of sizeof() for a few
	structures that use a zero-length array.

2009-08-07  Rodrigo Kumpera  <rkumpera@novell.com>

	* method-to-ir.c (mono_method_to_ir/CEE_CONSTRAINED_): Handle the
	case when the method is dynamic. Fixes #529238.

2009-08-06  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_jit_compile_method_inner): Throw an exception instead
	of asserting when a method is JIT compiled in full-aot mode.

2009-08-03  Jerry Maine  <crashfourit@gmail.com>
	
	Contributed under the terms of the MIT/X11 license by
	Jerry Maine <crashfourit@gail.com>.
	
	* fixed wrong dates in changelog.

2009-08-03  Jerry Maine  <crashfourit@gmail.com>
	
	Contributed under the terms of the MIT/X11 license by
	Jerry Maine <crashfourit@gail.com>.

	* basic-simd.cs: added test for packed double square root.
	* cpu-amd64.md: added opcode info for packed double square root.
	* cpu-x86.md: added opcode info for packed double square root.
	* mini-ops.h: added IR opcode for packed double square root.
	* mini-x86.c: added IR to native translation code for packed double square root.
	* mini-amd64.c: removed todo for packed double square root.
	* simd-intrinsics.c: added method to IR opcode converstion for
	packed double square root.

2009-08-03 Jerry Maine <crashfourit@gmail.com>

	Contributed under the terms of the MIT/X11 license by
	Jerry Maine <crashfourit@gail.com>.

	* mini-amd64.c: Added a change to help tell the difference as 
	to what perpose	the xmm register is being used--mainly to help
	with debuging.
	* mini-amd64.h: Changed callee regs to use 15 out of 16 
	(one used for special cases) xmm registers for both fp
	and simd ops. Added define to turn on new feature in the regalloc
	that allows fp and simd ops to share the xmm regs happily.
	* codegen.c: Added code to detect for which perpose an xmm reg is
	being used (fp or simd)	and to translate back and forth to the
	correct logical reg bank (fp or simd) for 'spill load's.

2009-08-03 Jerry Maine <crashfourit@gmail.com>

	Contributed under the terms of the MIT/X11 license by
	Jerry Maine <crashfourit@gail.com>.

	* basic-simd.cs: Added tests for stressing the regalloc when running with
	16 simd regs and when simd and fp ops share the same reg bank.

2009-08-01  Mark Probst  <mark.probst@gmail.com>

	* method-to-ir.c (mini_emit_stobj): If we call mono_value_copy()
	in shared generic code, we might have to look up the class in the
	RGCTX.  If we use the class directly, compute its GC descriptor.

2009-07-31  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c (mono_jit_runtime_invoke): Fix a warning.

2009-07-31  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c (mono_jit_runtime_invoke): Initialize the class and
	check for errors. Fixed the case when the class with the Main
	method is broken.

2009-07-31 Jerry Maine <crashfourit@gmail.com>

	Contributed under the terms of the MIT/X11 license by
	Jerry Maine <crashfourit@gail.com>.

	* cpu-amd64.md: Fixed simple bug in machine discrition file.

2009-07-31  Zoltan Varga  <vargaz@gmail.com>

	* mini-sparc.c (mono_arch_output_basic_block): Implement OP_IREM_UN_IMM.

2009-08-30  Rodrigo Kumpera  <rkumpera@novell.com>

	* method-to-ir.c: Fix naming of stelem and ldelem.

2009-07-30  Zoltan Varga  <vargaz@gmail.com>

	* driver.c (main_thread_handler): Check that the assembly loaded
	matches the filename when doing AOT.

2009-07-30  Mark Probst  <mark.probst@gmail.com>

	* mini.c: get_ip_from_sigctx installer has been removed, so don't
	call it anymore.

	* mini-x86.h, mini-amd64.h, mini-ppc.h: UCONTEXT macros moved (to
	utils/mono-sigcontext.h).

	* exceptions-amd64.c: Use the UCONTEXT_GREGS macro instead of an
	#ifdef.

2009-07-29  Massimiliano Mantione  <massi@ximian.com>

	* mini.c (mono_codegen):
	Call profiler hook to keep track of method code buffers.

2009-07-27  Mark Probst  <mark.probst@gmail.com>

	* method-to-ir.c: Invoke write barriers for the
	Interlocked.(Compare)Exchange JIT intrinsics.

2009-07-26  Raja R Harinath  <harinath@hurrynot.org>

	* Makefile.am (version.h): Fix issues when built out of tree.
	Remove some redundant 'grep's piped through 'sed's.

Fri Jul 24 17:28:37 CEST 2009 Steven Munroe  <munroesj@us.ibm.com>

	This patch is contributed under the terms of the MIT/X11 license

	* mini-ppc.c (mono_arch_output_basic_block):
	(OP_STOREI1_MEMBASE_REG): Handle 32-bit offsets combining addis
	for bits 32-47 with signed load/store diplacements for bits
	48-63.  Use prefered base/offset order for indexed form.
	(OP_STOREI2_MEMBASE_REG, OP_STORE_MEMBASE_REG): Same.
	(OP_LOAD_MEMBASE, OP_LOADI4_MEMBASE, OP_LOADU4_MEMBASE,
	OP_LOADI1_MEMBASE, OP_LOADU1_MEMBASE, OP_LOADU2_MEMBASE,
	OP_LOADI2_MEMBASE): Same.
	(OP_STORER8_MEMBASE_REG, OP_LOADR8_MEMBASE,
	OP_STORER4_MEMBASE_REG, OP_LOADR4_MEMBASE): Same.
	(OP_STOREI1_MEMINDEX): Use prefered base/offset order for
	indexed form.
	(OP_STOREI2_MEMINDEX, OP_STORE_MEMINDEX): Same.
	(OP_LOAD_MEMINDEX, OP_LOADI4_MEMINDEX, OP_LOADU4_MEMINDEX,
	OP_LOADU2_MEMINDEX, OP_LOADI2_MEMINDEX, OP_LOADU1_MEMINDEX,
	OP_LOADI1_MEMINDEX): Same
	(OP_LOADR4_MEMINDEX, OP_LOADR8_MEMINDEX, OP_STORER4_MEMINDEX,
	OP_STORER8_MEMINDEX): Same
	(OP_JMP): Use addis/addi sequence for int cfg->stack_usage
	computations.
	(mono_arch_emit_prolog): Handle 32-bit offsets combining addis
	for bits 32-47 with signed load/store diplacements for bits
	48-63.  Use prefered base/offset order for indexed form.

Fri Jul 24 16:57:12 CEST 2009 Steven Munroe  <munroesj@us.ibm.com>

This patch is contributed under the terms of the MIT/X11 license

	* mini-ppc.c: Define PPC_MOVE_FPR_GPR and PPC_ISA_64.
	(mono_arch_get_vcall_slot): Fx pointer to int cast warning.
	(mono_arch_decompose_opts): Make OP_ICONV_TO_R4 and
	OP_ICONV_TO_R8 decompose conditional on !PPC_ISA_64.
	(mono_arch_output_basic_block) [OP_JMP]: Use ppc_load32 for
	cfg->stack_usage to avoid size warnings.
	(mono_arch_output_basic_block) [__mono_ppc64__]: Replace
	store/load sequence with mffgpr if PPC_MOVE_FPR_GPR is true.
	(mono_arch_output_basic_block) [!__mono_ppc64__]: For
	OP_ICONV_TO_R4 or OP_ICONV_TO_R8 and PPC_ISA_64 use fcfid
	to convert.
	(mono_arch_emit_prolog): Move mono_emit_unwind_op_def_cfa 
	after code varible is initialized.
	Add g_assert ppc_is_imm16 for ainfo->offset. Handle
	ainfo->size == 8 when ainfo->offset !ppc_is_imm16.
	(mono_arch_emit_epilog): 
	Move Use ppc_load32 for cfg->stack_usage to avoid size
	warnings.

2009-07-24  Mark Probst  <mark.probst@gmail.com>

	* method-to-ir.c: The write barrier doesn't do the store anymore,
	so we have always to emit it.  Also, emit the wbarrier after the
	store.

2009-07-24  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c (mono_arch_get_delegate_invoke_impls): Add a trampoline
	for argument count 3 too.

2009-07-23  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_jit_compile_method_with_opt): Add an 'ex' argument to let
	the caller handle the exceptions.
	(mono_jit_runtime_invoke): Handle exceptions thrown while compiling the
	method. Fixes #524498.

2009-07-22  Geoff Norton  <gnorton@novell.com>

	* mini-exceptions.c: Fix build on ia64.

2009-07-22  Mark Probst  <mark.probst@gmail.com>

	* mini-exceptions.c (ves_icall_get_frame_info): Use write
	barriers.

2009-07-21  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c (mono_arch_emit_prolog): Fix thread attaching in aot
	code.

2009-07-20  Zoltan Varga  <vargaz@gmail.com>

	* basic-simd.cs (Main): Pass args to the test driver.

2009-07-20  Geoff Norton  <gnorton@novell.com>

	* mini-x86.h: Fix the x86 version guards to use Apple's
	properly defined macros.

2009-07-20  Geoff Norton  <gnorton@novell.com>

	* mini-x86.c: Fix --trace on darwin-x86 and other systems which require
	aligned access.

2009-07-20  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_jit_runtime_invoke): Speed this up by adding a hash to
	MonoJitDomainInfo which maps MonoMethod's to a structure containing all
	the information which is needed for invokes, so only one locking+hash table
	lookup is needed.

	* aot-compiler.c: Add a 'tool-prefix' option to be used when cross-compiling.
	
	* aot-compiler.c (add_generic_instances): Emit instances of 
	GenericComparer<T> for primitive types.

2009-07-19 Rodrigo Kumpera  <rkumpera@novell.com>

	* mini-posix.c: Fix linux build.

2009-07-19  Geoff Norton  <gnorton@novell.com>

	* mini.h: Add prototypes for mono_runtime_syscall_fork and
	mono_gdb_render_native_backtraces
	* mini-darwin.c: Apple's syscall(SYS_fork) is very weird on x86,
	so we implement the sane semantics to the runtime here
	(mono_gdb_render_native_backtraces).  Apple also uses an ancient gdb
	so we need to call it differently (mono_gdb_render_native_backtraces)
	* mini-posix.c: Move the old semantics from mini.c to the prototypes
	here for default implementations.
	* mini.c: Refactor mono_handle_native_sigsegv so that we can properly
	support Apple's weird syscall (SYS_fork) implementation and not busy
	loop in abort() on native crashes on OSX anymore.

2009-07-18  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (load_method): Change the handling of the
	MONO_LASTAOT env variable so MONO_LASTAOT=0 means that no aot methods
	are used.

	* mini.c (mono_patch_info_equal): Really fix the handling of RGCTX_FETCH.

2009-07-17  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_patch_info_equal): Revert the last change for now as it
	seems to break the aot tests.
	
	* mini.c (mono_patch_info_equal): Fix the handling of 
	MONO_PATCH_INFO_RGCTX_FETCH.

2009-07-16  Zoltan Varga  <vargaz@gmail.com>

	* unwind.c: Use TARGET_AMD64 instead of __x86_64__.

	* mini.c (mono_patch_info_hash): Fix the handling of 
	MONO_PATCH_INFO_INTERNAL_METHOD.
	(mono_patch_info_equal): Ditto.

2009-07-16  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c (mono_llvm_emit_method): Use module instead of ctx->module
	in a few places.
	
	* mini-llvm.c: Add some infrastructure for AOT support.

2009-07-15  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm-cpp.c: Update to the latest llvm api.
	
	* mini-llvm-cpp.cpp (mono_llvm_create_ee): Set the EnablePrettyStackTrace
	option to false to prevent llvm from installing signal handlers which
	trip up the gc.
	
2009-07-15 Rodrigo Kumpera  <rkumpera@novell.com>

	* cpu-x86.md:
	* cpu-amd64.md: Revert previous change as those instructions
	take 2 separate arguments. Remember to read the arch docs more
	carefully next time.

2009-07-15  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm-cpp.cpp (mono_llvm_build_alloca): Update to latest llvm api.

Wed Jul 15 17:20:27 CEST 2009 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: exploit multiple load/store units if available (rest of
	the change from Steven Munroe (<munroesj@us.ibm.com>) first patch at 
	http://bugzilla.novell.com/show_bug.cgi?id=487846).

Wed Jul 15 16:24:57 CEST 2009 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: integrate most of Steven Munroe (<munroesj@us.ibm.com>)
	first patch at http://bugzilla.novell.com/show_bug.cgi?id=487846.

2009-07-14 Rodrigo Kumpera  <rkumpera@novell.com>

	* cpu-x86.md: Fix missing clobbering from trancendental simd
	ops.

	* cpu-amd64.md: Same.

2009-07-14 Jerry Maine <crashfourit@gmail.com>

	Contributed under the terms of the MIT/X11 license by
	Jerry Maine <crashfourit@gail.com>.

	* basic-simd.cs: Added tests for single and doulble indexers.

	* cpu-amd64.md: Added simd opcode information.

	* mini-amd64.c: Added IR to native simd generation code.
	Added simd register names and function that returns them.

	* mini-amd64.h: Added marcos to turn on simd code compilation in
	amd64. Added max simd register count marco. Added caller/callee
	register mask marcos. Added marcos to use simd register bank.

	* mini.h: Added helper marco for shufling dwords and simple
	floats.

2009-07-14  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm-cpp.cpp: Update to latest llvm SVN api.

	* Makefile.am (mono_LDADD): Pass LLVM_LDFLAGS to the linked.

	* unwind.c (mono_unwind_get_ops_from_fde): Make this return
	the length of the native code as well.

        * basic-simd.cs: Add a test for #521662.

Mon Jul 13 17:58:50 CEST 2009 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: fixed bug introduced by Steven's TLS changes.

2009-07-13  Mark Probst  <mark.probst@gmail.com>

	* mini.c: Register function for getting the IP from a signal
	context with metadata.

2009-07-13  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mono_method_to_ir): When calling a gshared method,
	call a generic class init trampoline if needed. Fixes #519336.

	* generics.cs: Add a test.
	
2009-07-09  Mark Probst  <mark.probst@gmail.com>

	* method-to-ir.c: When doing a call which might be remote from
	shared generic code to other shared code with open type arguments,
	get the remoting invoke wrapper from the RGCTX and do an indirect
	call to it.

2009-07-03  Zoltan Varga  <vargaz@gmail.com>

	* mini-trampolines.c (get_unbox_trampoline): Add an rgctx trampoline
	after the unbox trampoline in the full-aot case.

2009-07-02  jonas echterhoff <jonas@unity3d.com>
	
	* mini.c: Move initialization of jit_mutex before debugger initialization
	
	to avoid crashes.
	
	
	* Info.plist: added Info.plist and link flag to enable the mono executable
	to access other processes. Requires codesigning of the executable to work.
	
	* mdb-debug-info32-darwin.s: The same as mdb-debug-info32.s, changed to 
	
	compile on OS X.
	

2009-06-30  Zoltan Varga  <vargaz@gmail.com>

	* driver.c (mini_regression): Handle loading errors. Fixes #508869.

2009-06-29  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (get_generic_context_from_stack_frame): Fix the case
	when the generic instance is an instantiation of a subclass of the
	methods class. Fixes #517166.

2009-06-26  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_emit_prolog): Fix thread attaching in AOTed
	code.

	* mini.c (mono_jit_thread_attach): Allow domain to be NULL for calls from
	AOTed code.

	* CMakeLists.txt: Add minimal support for installation.

2009-06-25  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_and_reloc_code): Factor out the code to
	determine whenever a method is directly callable to a separate function.

	* mini-<ARCH>.c tramp-<ARCH>.c: Remove needless casts and add new
	needed ones as a result of the previous change.

	* mini-<ARCH>.c tramp-<ARCH>.c: Use mgreg_t* as the
	type of register arrays.

	* mini-trampolines.c tramp-<ARCH>.c aot-runtime.c: Use mgreg_t* as the
	type of register arrays.

2009-06-24  Jerry Maine  <crashfourit@gmail.com>
	
	Contributed under the terms of the MIT/X11 license by
	Jerry Maine <crashfourit@gail.com>.

	* mini-amd64.c: Added code to convert simd IR to native amd64 sse.

2009-06-24  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_plt): Define debug labels for most plt entries.

2009-06-24  Neale Ferguson <neale@sinenomine.net>

	* mini-s390x.c: Correct LCONV_TO_Ix and ICONV_TO_Ix routines. Fix leave_method
	dump of structure return value. Fix some formatting.
	* cpu-s390x.md: Fix lengths of instruction sequences.
	* mini-s390.c: Minor formatting changes.

2009-06-24  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.h: Applied patch from Romain Tartiere (romain@blogreen.org).
	Use sigaction on freebsd as well.

2009-06-23  Zoltan Varga  <vargaz@gmail.com>

	* mini.h: Don't define MONO_ARCH_HAVE_TLS_GET to 0, as some code
	uses #ifdef on it.
	
	* mini.c (mini_init): Revert a change which breaks cross-compilation.

2009-06-22  Mark Probst  <mark.probst@gmail.com>

	* mini-ppc.c, cpu-ppc.md: Enable TLS on Darwin/G4.

2009-06-22  Mark Probst  <mark.probst@gmail.com>

	* mini.c, mini.h: Tell the runtime whether we support MONO_TLS.

2009-06-20  Martin Baulig  <martin@ximian.com>

	* debug-mini.c
	(MonoDebuggerThreadFlags): New enum typedef.
	(MonoDebuggerThreadInfo): Added `guint32 thread_flags'.
	(mono_debugger_thread_created): Added `gpointer func' argument;
	initialize the new `thread_flags' field.

2009-06-18  Martin Baulig  <martin@ximian.com>

	* debug-debugger.h (MonoDebuggerRuntimeFlags): New enum typedef.
	(MonoDebuggerInfo): Renamed the `dummy' field info `runtime_info'.

	* debug-debugger.c
	(mini_debugger_set_attach_ok): New function; sets the attach-ok
	flag in `MONO_DEBUGGER__info.runtime_info'.

	* driver.c
	(mono_main): Call mini_debugger_set_attach_ok() if generics
	sharing is disabled.

2009-06-22  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (add_wrappers): Fix a warning.

	* mini-ppc.c tramp-ppc.c exceptions-ppc.c aot-compiler.c: Update after
	the ppc load/store macro changes.

2009-06-21  Zoltan Varga  <vargaz@gmail.com>

	* tramp-ppc.c (mono_arch_patch_plt_entry): Implement this.

	* aot-compiler.c (mono_compile_assembly): Sanitize the plt symbol too,
	not just the got symbol.

	* mini-ppc.c aot-compiler.c unwind.c: Implement generation of unwind info
	on ppc.

	* aot-compiler.c unwind.c: Add infrastructure for unwind support on
	ppc.
	
	* aot-compiler.c: Remove some fixmes.

	* driver.c (mono_main): Print a helpful message when cross-compiling.

	* mini.c (mini_init): Disable signal handlers when cross-compiling.

	* method-to-ir.c (initialize_array_data): Do the optimization if the
	target byte order is little endian, instead of the host byte order.

	* aot-compiler.c: Emit sizes for most symbols, only emit runtime-invoke
	wrappers into the mscorlib image, Emit a unique plt symbol for each
	image, emit symbols for plt entries.

	* image-writer.c (img_writer_emit_symbol_size): New function to emit
	a .size directive.
	
2009-06-20  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (add_wrappers): Avoid calling 
	mono_marshal_get_type_info () since it can assert for some types.

	* method-to-ir.c (mono_method_to_ir): Disable aot when some forms of 
	ldtoken are used inside wrappers.

	* helpers.c: Add support for prefixing tools with the arch name.

	* mini.h (OP_LOADR_MEMBASE): New opcodes to load/store pointer sized
	quantities when using ilp32.

	* mini-codegen.c: Use OP_LOADR_MEMBASE/OP_STORER_MEMBASE for loading/storing
	spill slots. Use sizeof(mgreg_t) for the spill slot size.

	* image-writer.c: Use .long on ilp32.

	* aot-compiler.c: Use 32 bit loads on ilp32.
	
2009-06-19  Zoltan Varga  <vargaz@gmail.com>

	* tramp-ppc.c (mono_arch_create_trampoline_code): Fix the ppc build.

	* mini-ops.h: Use TARGET_POWERPC define for consistency.

	* patch-info.h: Add 'MSCORLIB_GOT_ADDR' patch type.

	* aot-compiler.c aot-runtime.c: Put the mscorlib got address into the 
	second got slot of every aot image.
	
	* aot-compiler.c aot-runtime.c mini-trampolines.c: Add support for
	aot on platforms with function pointers.

	* mini-ppc.h mini-ppp.c cpu-ppc.md exceptions-ppc.c tramp-ppc.c: Add
	support for aot/full aot on ppc/ppc64.
	
	* tramp-<ARCH>.c (mono_arch_patch_plt_entry): Add 'got' and 'regs'
	arguments which are needed on ppc.

	* tramp-arm.c (mono_arch_nullify_class_init_trampoline): Add 'regs'
	argument.

	* mini-trampolines.c aot-runtime.c: Update after the above changes.
	
	* liveness.c (BITS_PER_CHUNK): Use MONO_BITSET_BITS_PER_CHUNK.

	* regalloc2.c (BITS_PER_CHUNK): Ditto.	

	* aot-compiler.c (emit_got_info): Fix reading unused memory.

	* ir-emit.h (alloc_dreg): Add a 'return -1' to quiet some compilers.

2009-06-17  Geoff Norton  <gnorton@novell.com>

	* aot-compiler.c: Ensure we dont try to close a null dwarf writer.

2009-06-17  Zoltan Varga  <vargaz@gmail.com>

	* dwarfwriter.c (mono_dwarf_writer_create): Add an 'appending' parameter
	to control whenever the dwarf writer is in xdebug or aot mode.
	(emit_class_dwarf_info): Use a separate abbrev for structures without
	children.

	* aot-compiler.c: Pass the appending parameter to 
	mono_dwarf_writer_create ().

	* branch-opts.c (mono_merge_basic_blocks): Fix the case when bbn
	falls through to its next bblock. Fixes #513931.

	* iltests.il: Add a test.

	* dwarfwriter.c (mono_dwarf_writer_emit_base_info): Emit some line number
	infor even if emit_line is FALSE, as the apple linker seems to require it.

	* image-writer.c (asm_writer_emit_symbol_diff): Call get_label ().

	* dwarfwriter.c (emit_cie): Emit a separate symbol for the cie start, as
	gcc does.
	(emit_fde): Ditto.

2009-06-15  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-mips.c (mono_arch_get_throw_exception_by_name): Fix the
	mips build.

2009-06-13  Zoltan Varga  <vargaz@gmail.com>

	* mini.h (struct MonoBasicBlock): Add 'has_jump_table' and 
	'has_call_handler' fields.

	* method-to-ir.c (mono_method_to_ir): Set them if needed.

	* branch-opts.c (mono_merge_basic_blocks): Avoid iterating through the
	first bblock if not needed. Fixes #512790.
	
2009-06-11  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (mono_compile_assembly): Fix a warning.
	
	* aot-compiler.c (add_wrappers): Don't emit remoting-invoke-with-check
	wrappers.

	* aot-runtime.c (mono_aot_get_method): Use the original method's code for
	remoting-invoke-with-check wrappers, which are not needed when running with
	full-aot, since it doesn't support remoting.
	
2009-06-10  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_got_info): Don't emit offsets for the plt got entries.

	* aot-compiler.c aot-runtime.c: Don't emit the first got offset in the
	method info, it is not used anymore.

	* mini.h: Bump AOT file format version.
	
	* aot-compiler.c (arch_emit_plt_entry): Make the arm plt entries one
	word smaller.

	* aot-runtime.c (mono_aot_get_plt_info_offset): Update after the
	change above.
	
	* tramp-arm.c (mono_arch_patch_plt_entry): Ditto.

	* mini.h: Bump AOT file format version.
	
2009-06-10  Zoltan Varga  <vargaz@gmail.com>

	* image-writer.c (asm_writer_emit_symbol_diff): Disable the 
	TARGET_ASM_APPLE stuff for now, as it doesn't seem to work on the
	iphone.

	* mini-arm.c (mono_arch_output_basic_block): Fix the implementation
	of CKFINITE and FBGE for VFP.

2009-06-09  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c: Don't align code to 16 bytes on arm.
	
	* aot-compiler.c (emit_method_code): Emit the unbox trampolines right
	before the methods they belong to.

	* aot-runtime.c (mono_aot_plt_resolve): Avoid creating trampolines in
	the full-aot case if possible, since the trampoline will be called right 
	away.

	* aot-compiler.c (mono_compile_assembly): Decrease the number of full aot
	trampolines to 1024 after the change above.

	* aot-compiler.c (arch_emit_specific_trampoline): Rework the arm
	trampoline to save 8 bytes per trampoline.

	* tramp-arm.c (mono_arch_create_trampoline_code_full): Update after the
	change above.

2009-06-08  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c: Use acfg->temp_prefix instead of .L to prefix labels.

2009-06-08  Martin Baulig  <martin@ximian.com>

	* debug-mini.c
	(MonoDebuggerExceptionAction): Moved into debug-mini.h.
	(_mono_debugger_throw_exception): Don't make this static.
	(_mono_debugger_unhandled_exception): Likewise.
	(mono_debugger_handle_exception): Moved to mini-exceptions.c

	* debug-mini.c
	(MonoDebuggerExceptionAction): Moved here from debug-mini.c.
	(_mono_debugger_throw_exception): Add function prototype.
	(_mono_debugger_unhandled_exception): Likewise.

	* mini-exceptions.c
	(mono_handle_exception_internal): Added `MonoJitInfo **out_ji'
	arg; return the first exception handler if the exception is caught
	and we're running inside the debugger.
	(mono_debugger_handle_exception): Moved here from debug-mini.c;
	improve exception handle inside runtime-invoke, check whether the
	exception is actually caught in the method being invoked and not
	by the runtime-invoke-wrapper.

2009-06-08  Zoltan Varga  <vargaz@gmail.com>

	* image-writer.c: Improve support for the osx assembler.

	* dwarfwriter.c: Avoid the usage of subsections if the assembler doesn't
	support them.

2009-06-08  Martin Baulig  <martin@ximian.com>

	* debug-mini.c
	(MonoDebuggerExceptionAction): Moved into debug-mini.h.
	(_mono_debugger_throw_exception): Don't make this static.
	(_mono_debugger_unhandled_exception): Likewise.
	(mono_debugger_handle_exception): Moved to mini-exceptions.c

	* debug-mini.c
	(MonoDebuggerExceptionAction): Moved here from debug-mini.c.
	(_mono_debugger_throw_exception): Add function prototype.
	(_mono_debugger_unhandled_exception): Likewise.

	* mini-exceptions.c
	(mono_handle_exception_internal): Added `MonoJitInfo **out_ji'
	arg; return the first exception handler if the exception is caught
	and we're running inside the debugger.
	(mono_debugger_handle_exception): Moved here from debug-mini.c;
	improve exception handle inside runtime-invoke, check whether the
	exception is actually caught in the method being invoked and not
	by the runtime-invoke-wrapper.

2009-06-07  Zoltan Varga  <vargaz@gmail.com>

	* image-writer.c (append_subsection): Don't align subsections of the
	debug_line section as a workaround.

	* dwarfwriter.c: Emit line number info in the AOT case as well.

2009-06-06  Steven Munroe  <munroesj@us.ibm.com>

	This patch is contributed under the terms of the MIT/X11 license

       * mini-ppc.c (mono_arch_emit_exceptions): Change assert to
       code_len <= code_size

2009-06-06  Zoltan Varga  <vargaz@gmail.com>

	* mini-mips.c (mips_emit_exc_by_name): Fix the mips build.

2009-06-04  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c aot-runtime.c: Delete references to static rgctx
	invoke wrappers, we now use trampolines instead.

2009-06-04  Mark Probst  <mark.probst@gmail.com>

	* mini-darwin.c: The exception thread must not be registered with
	the GC.

2009-06-04  Mark Probst  <mark.probst@gmail.com>

	* mini-gc.c: Disable the code because it makes SGen crash.

2009-06-03  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (mono_compile_assembly): Handle file open errors gracefully
	instead of asserting.

2009-05-31  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (mono_compile_assembly): Move the creation of the
	output file after the code has been compiled.

2009-05-30  Zoltan Varga  <vargaz@gmail.com>

	* tramp-ppc.c (mono_arch_get_static_rgctx_trampoline): Fix 64 bit support.

2009-05-31  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c aot-runtime.c: Get rid of the shared/non-shared got
	entries distinction to simplify the code.

	* mini.h: Bump AOT file format version.
	
2009-05-28  Zoltan Varga  <vargaz@gmail.com>

	* objects.cs: Fix the signature of one of the tests.

	* mini.c (mini_create_ftnptr): New helper function, moved here from
	object.c.
	(mini_get_addr_from_ftnptr): Ditto.
	(mini_init): Install the new helpers.

2009-05-28  Martin Baulig  <martin@ximian.com>

	Correctly initialize the debugger when embedding Mono.

	* mdb-debug-info32.s, mdb-debug-info64.s: Add a global variable
	`MONO_DEBUGGER__using_debugger' to the `.mdb_debug_info' section;
	see documentation in mini_debug_running_inside_mdb().

	* debug-debugger.c
	(mini_debug_running_inside_mdb): New function to check whether
	we're running inside mdb.

	* mini.c (mini_init): Call mini_debugger_init() if we're running
	inside the debugger.

	* driver.c (mono_main): Moved the call to mini_debugger_init()
	into mini_init() to make this work when embedding Mono.

	* debug-debugger.c (mini_debugger_init): Warn about duplicate
	calls to mini_debugger_init().

	* mini.h: Rename mono_debugger_init() -> mini_debugger_init(),
	mono_debugger_main() -> mini_debugger_main() and put them inside a
	`MONO_DEBUGGER_SUPPORTED' conditional.

2009-05-26 Rodrigo Kumpera  <rkumpera@novell.com>

	* mini-trampolines.c: Kill mono_find_delegate_trampoline_by_addr as
	this is no longer in use.
	* mini.h: Same.

2009-05-26  Zoltan Varga  <vargaz@gmail.com>

	* mini-sparc.c (add_outarg_load): Fix the sparc build.

	* aot-compiler.c (emit_method_code): Always write out C style symbols for
	methods.

2009-05-27  Martin Baulig  <martin@ximian.com>

2009-05-25 Rodrigo Kumpera  <rkumpera@novell.com>

	* mini-x86.c (mono_arch_output_basic_block): Fix the precision of
	long_conv_to_r_un to 64 bits.

	* cpu-x86.md: Increase the instruction size due to the changes.

	* iltests.il.in: Add regression test.

	Fixes #467201.

2009-05-25 Rodrigo Kumpera  <rkumpera@novell.com>

	* objects.cs: Move the previous test from basic.cs to here.

2009-05-25 Rodrigo Kumpera  <rkumpera@novell.com>

	* basic.cs: Add regression test for #506915.

2009-05-25 Rodrigo Kumpera  <rkumpera@novell.com>

	* method-to-ir.c (mono_method_to_ir): When doing the ldobj+stobj
	optimization we must check the bb of the first byte of stobj as
	it's the only one set in cil_offset_to_bb.

	Fixes #506915.	

2009-05-25  Zoltan Varga  <vargaz@gmail.com>

	* image-writer.c: Fix pointer directive on ppc64.

2009-05-24  Zoltan Varga  <vargaz@gmail.com>

	* image-writer.c (asm_writer_emit_section_change): Avoid using
	.bss subsections on ppc too.

2009-05-23  Zoltan Varga  <vargaz@gmail.com>

	* image-writer.c: Fix the definition of TARGET_ASM_....
	
	* image-writer.c: Fix the emission of assembler directives in the last
	change.

	* mini-ppc.c (mono_arch_emit_exceptions): Increase the size of the
	exception throwing code to accomodate ppc64.

	* tramp-ppc.c (mono_arch_get_nullified_class_init_trampoline): Increase the
	size to work on ppc64 too.

	* mini-ppc.h (MonoCompileArch): Enable static rgctx trampolines on ppc64
	too.

	* image-writer.c: Clean up the #ifdef hell a bit by adding defines for
	the assembler dialect instead of using platform specific defines.

2009-05-22  Geoff Norton  <gnorton@novell.com>

	* mini-arm.c (get_call_info): If a structure is split between the stack
	and argument registers, we should not advance the stack pointer by the entire
	native size, but just by the amount that spilled.

2009-05-22  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c (get_call_info): Handle structures with alignment requirements
	correctly.

2009-05-21  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_extra_methods): Encode direct runtime invoke
	wrappers normally.
	
	* aot-compiler.c (add_extra_method): Fix up the collection of extra
	methods so wrapper don't get added twice.
	(add_generic_instances): Don't add methods of arrays.

	* generics.cs: Mark one test as !FULLAOT.

2009-05-21 Rodrigo Kumpera  <rkumpera@novell.com>

	* mini-x86.c (emit_move_return_value): Remove unused vars.

2009-05-21 Rodrigo Kumpera  <rkumpera@novell.com>

	* mini-x86.c (mono_arch_emit_call): The decompose code now supports
	decomposing 8 bytes structs into a LCALL.

	* mini-x86.c (emit_move_return_value): We no longer push the vtype
	pointer for where to store the returned regs.

	* decompose.c (mono_decompose_vtype_opts): Fix the comment to properly
	state the concern.

	Fixes #471747, #471751 and #4734530 (in fact, it's a bunch of dups).

2009-05-20  Miguel de Icaza  <miguel@novell.com>

	* aot-runtime.c (mono_aot_init): Use g_getenv to work on systems
	without getenv.

2009-05-21  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (add_wrappers): Add StructureToPtr/PtrToStructure wrappers.

	* basic.cs: Move the test_2_cprop_bug () test to generics.cs as it involves
	generics.

2009-05-20 Rodrigo Kumpera  <rkumpera@novell.com>

	* local-propagation.c (mono_local_cprop): Avoid local propagation
	across paired add/sub if the first instruction dest reg is it's
	source reg. For example:

	int_add_imm R12 <- R12 [1] clobbers: 1
	int_sub_imm R42 <- R12 [1] clobbers: 1

	The cprop pass would wrongly const prop + 1 to int_sub_imm which doesn't
	maintain the math identify.

	Fixes #505375.

2009-05-20  Andreia Gaita  <avidigal@novell.com>

	* Makefile.am: avoid going on the network just to get the revision,
	use git log instead

2009-05-19  Massimiliano Mantione  <massi@ximian.com>

	Fixed estimate for short branches on amd64 (they were off mark, and
	enabling call prolog-epilog instrumentations caused assertions).
	* mini.h (struct MonoBasicBlock): added max_length field to hold the
	estimate for the maximum length of this basic block.
	* mini-amd64.c:
	- mono_arch_emit_prolog: compute max_length for each basic block
	  (instead of max_offset), and inflate size estimate also for entry bb
	  in case of code instrumentation.
	- mono_arch_output_basic_block: get rid of "cpos" (the current
	  estimated "position" in the code), and always use "offset" instead,
	  which is accurate; at the beginning of the function quickly recompute
	  max_offset for all the remaining blocks, starting from the current
	  cfg->code_len (which is correct, and not estimated) and using the
	  estimated block lengths computed previously.

2009-05-17  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-ppc.c: Remove the caching from the trampoline creation 
	functions, it is already done in the caller.

	* mini-trampolines.c (mono_llvm_vcall_trampoline): Fix the llvm build.

	* mini-ppc.h mini-arm.h mini-x86.h mini-amd64.h: Add 
	MONO_ARCH_GSHARED_SUPPORTED define.

	* mini.c (mini_init): Use the MONO_ARCH_GSHARED_SUPPORTED define.

	* mini-arm.c mini.c: Get rid of the unused mono_arch_fixup_jinfo ()
	function.

2009-05-16  Zoltan Varga  <vargaz@gmail.com>

	* jit-icalls.c (mono_helper_compile_generic_method): Get rid of the 
	call to mono_marshal_get_rgctx_invoke ().

	* mini.c method-to-ir.c mini-trampolines.c: Get rid of the usage of
	mono_marshal_get_static_rgctx_invoke (), all platforms which support
	gshared use the static rgctx trampolines now.
	
	* mini.c (mini_init): Call mono_set_generic_sharing_supported () if the
	platform supports it.

2009-05-15  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c (mono_arch_allocate_vars): Correctly save R5 when using AOT.

	* aot-compiler.c (emit_method_code): Avoid duplicate labels for methods.

2009-05-15  Zoltan Varga  <vargaz@gmail.com>

	* mini-ppc.c (mono_arch_emit_exceptions): Nullify the processed patches.

	* tramp-ppc.c (mono_arch_nullify_class_init_trampoline): Implement this
	for ppc.

2009-05-15  Massimiliano Mantione  <massi@ximian.com>

	Made it possible for mono_arch_instrument_epilog to preserve
	argument registers, otherwise instrumenting the "epilogue" before
	a tail call would clobber them.
	* mini.h: Added "mono_arch_instrument_epilog_full" prototype, which
	if like mono_arch_instrument_epilog but with an additional parameter
	that states if argument registers must be preserved.
	* mini.c: implemented mono_arch_instrument_epilog as a call to
	mono_arch_instrument_epilog_full without asking to preserve argument
	registers (this makes the existing code work as usual).
	* mini-amd64.c:
	- mono_arch_instrument_epilog: add parameter to transform it into
	mono_arch_instrument_epilog_full, and preserve argument registers
	when required.
	- mono_arch_output_basic_block, OP_TAILCALL case: call
	mono_arch_instrument_epilog_full.
	* mini-alpha.c, mini-arm.c, mini-hppa.c, mini-ia64.c, mini-mips.c,
	mini-ppc.c, mini-s390.c, mini-s390x.c, mini-sparc.c, mini-x86.c:
	only transformed mono_arch_instrument_epilog into
	mono_arch_instrument_epilog_full.

2009-05-15  Geoff Norton  <gnorton@novell.com>

	* mini-darwin.c: This works on arm now.

2009-05-14  Geoff Norton  <gnorton@novell.com>

	* jit.h, driver.c: Allow full-aot to be decided programatically by the
	embedding api.

2009-05-15  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_method_code): Skip a few more characters in the debug
	label names.

	* mini-trampolines.c (mono_magic_trampoline): Handle static rgctx invoke
	wrappers during full aot mode correctly.

	* aot-runtime.c (mono_aot_get_unbox_trampoline): Handle shared generic
	methods correctly.

	* aot-compiler.c (mono_aot_method_hash): Use our internal version of
	mono_metadata_type_hash ().

2009-05-14  Massimiliano Mantione  <massi@ximian.com>

	* mini.h, mini-codegen.c, mini-alpha.c, mini-amd64.c, mini-arm.c,
	mini-hppa.h, mini-hppa.c, mini-ia64.c, mini-mips.h, mini-mips.c,
	mini-ppc.c, mini-s390.c, mini-s390x.c, mini-sparc.c, mini-886.c:
	Removed MONO_INST_BRLABEL from the instruction flags, and the
	remaining code that used it, because we do not support branches inside
	basic blocks (and branch target labels) anymore.
	* Makefile.am: As part of the above cleanup, remove reference to
	BURG files which don't exist anymore.

2009-05-14  Zoltan Varga  <vargaz@gmail.com>

	* image-writer.c (asm_writer_emit_local_symbol): Make this a nop on
	osx.

	* mini-mips.c mini-mips.h exceptions-mips.c: Transition the mips backend
	to use mono_arch_throw_corlib_exception.

	* mini-ppc.c mini-ppc.h exceptions-ppc.c: Use 
	mono_arch_throw_corlib_exception for throwing corlib exceptions.

	* aot-runtime.c (decode_patch): Allocate the data for R4/R8 from the
	domain mempool.

	* mini.c (mono_patch_info_dup_mp): Copy the table of switch targets too.

	* aot-compiler.c: Emit a local symbol prefixed with the assembly name 
	for the got to make debugging easier and to avoid confusing it with the
	system got.
	
	* aot-compiler.c (emit_method_code): Emit a C style symbol for each
	method so a breakpoint can be set when using gdb.

2009-05-13  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (mono_aot_method_hash): Implement this properly based
	on mono_method_get_imt_slot ().

	* aot-runtime.c (find_extra_method_in_amodule): Get rid of the
	num_decodes variables.

	* aot-compiler.c (mono_aot_method_hash): Revert part of the last
	change as it doesn't seem to work.
	
	* aot-compiler.c (mono_aot_method_hash): Improve the hashing of
	wrappers.

2009-05-12  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c mini.c mini-amd64.h mini-arm.h: Kill 
	MONO_ARCH_FULL_AOT_IMT_SUPPORTED define, both platforms now support imt.

	* mini.c (mini_init): Install mono_aot_get_imt_thunk as the IMT thunk
	builder when using full aot.

	* mini-amd64.c (mono_arch_build_imt_thunk): Don't handle the full-aot case
	here, it is already handled.
	
	* mini-arm.c (mono_arch_emit_imt_argument): Pass the dynamic imt arg
	correctly for IMT.

	* aot-compiler.c (arch_emit_imt_thunk): Implement this for ARM.

	* mini-arm.h: Enable IMT for full aot.
	
	* aot-compiler.c (mono_compile_assembly): Don't emit imt thunk if the
	arch doesn't support it.

	* mini.c (mini_init): Don't disable IMT for full aot if the
	architecture supports it.

	* mini.h (MonoAotTrampoline): New enum containing the different types
	of 'numerous' trampolines.
	(MONO_AOT_FILE_VERSION): Bump this.

	* aot-compiler.c aot-runtime.c: Unify the handling of specific and
	static rgctx trampolines. Add support for full-aot IMT thunks.

	* mini-amd64.h: Enable IMT for full aot.

	* TestDriver.cs: Add a CategoryAttribute class and an --exclude option
	to exclude tests belonging to a category.

	* generics.cs: Mark some tests with a !FULLAOT category.

	* Makefile.am (fullaotcheck): Run tests with --exclude !FULLAOT. Include
	generics tests.

2009-05-11  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_and_reloc_code): Move the implementation of
	MONO_PATCH_INFO_GOT_OFFSET to a separate arch-specific function.
	(emit_plt): Fix a warning.

2009-05-10  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c aot-runtime.c: Fix the build by moving is_shared_got_patch
	back into aot-compiler.c to a place where the other functions shared by
	the runtime and aot compiler are.
	
	* aot-compiler.c aot-runtime.c: Emit the got addr using a separate symbol,
	as done previously, instead of in MonoAotFileInfo, since pointers might have
	alignment requirements.

	* mini.h: Bump AOT file format version.

2009-05-10  Miguel de Icaza  <miguel@novell.com>

	* aot-runtime.c (mono_aot_is_shared_got_patch): Move this routine
	that is used at runtime from the aot-compiler.c, this makes it
	work on setups that remove the AOT compiler from the output
	image. 

2009-05-09  Zoltan Varga  <vargaz@gmail.com>

	* tramp-ppc.c (mono_arch_get_static_rgctx_trampoline): Implement this for
	PPC.

	* mini-ppc.h: Enable static rgctx trampolines for ppc.

	* mini-<ARCH>.h: Kill the MONO_ARCH_ENABLE_EMIT_STATE_OPT define.

	* decompose.c (mono_decompose_long_opts): Move the ppc/sparc specific 
	stuff to mono_arch_decompose_long_opts ().
	(mono_decompose_opcode): Remove some dead code.

2009-05-08  Rodrigo Kumpera  <rkumpera@novell.com>

	* method-to-ir.c (mono_method_to_ir): Fix boostrap of non amd64 builds
	cmethod can be null for quite a some reasons.

2009-05-08  Rodrigo Kumpera  <rkumpera@novell.com>

	* method-to-ir.c (mono_method_to_ir): Fix non amd64 builds.

2009-05-08  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (arch_emit_got_access): Fix the aot-not-supported build.

2009-05-08  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mono_emit_call_args): Add a 'tail' flag argument.
	(mono_method_to_ir): Use MONO_ARCH_USE_OP_TAIL_CALL macro to determine
	whenever to make tail calls using OP_TAIL_CALL. Enable support for tail
	calls returning structures by addr on amd64.

	* mini-amd64.h (MONO_ARCH_USE_OP_TAIL_CALL): New arch-specific macro.

	* iltests.il.in: Restructure the tail call tests a bit.
	
2009-05-07  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (add_wrappers): Add remoting-invoke-with-check wrappers
	for virtual methods too.

2009-05-06  Raja R Harinath  <harinath@hurrynot.org>

	* method-to-ir.c (mono_method_to_ir): Revert change of 2009-05-02
	due to regression in verifying System.dll.

2009-05-06  Zoltan Varga  <vargaz@gmail.com>

	* debug-mini.c (mono_debugger_method_has_breakpoint): Allow breakpoints
	in dynamic methods.

	* dwarfwriter.c (emit_class_dwarf_info): Add support for generic
	instances.

	* aot-compiler.c aot-runtime.c: Use our own hash function instead of
	g_str_hash () which can change.

	* driver.c (mini_regression): Disable optimizations not supported by
	the cpu. Fixes #500019.

	* aot-runtime.c (mono_aot_get_unwind_info): Fix the --enable-minimal=aot
	build.

2009-05-06  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c (mono_llvm_emit_method): Update the OP_TLS_GET implementation
	to the latest LLVM code.

2009-05-05  Zoltan Varga  <vargaz@gmail.com>

	* genmdesc.pl (load_opcodes): Fix this after the TARGET_... changes.

2009-05-04  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c (mono_llvm_emit_method): Implement TLS support on 
	x86/amd64.

	* aot-compiler.c (encode_patch_list): Simplify this considerably as we are
	no longer saving offsets, so just save the patch types along with the other
	info.
	* aot-runtime.c (load_patch_info): Update after the changes to 
	encode_patch_list ().
	(decode_got_entry): Removed, merged into load_patch_info ().
	(is_shared_got_patch): Removed, call the same function from
	aot-compiler.c.

	* mini.h: Bump aot file format version.
	
	* aot-compiler.c aot-runtime.c: Resurrect static linking support. Kill the
	half-finished no-dlsym code.

	* aot-runtime.c (load_method): Kill the old and bit-rotten use_loaded_code
	option.

	* mini-<ARCH>.h mini-trampolines.c aot-runtime.c: Kill the 
	MONO_ARCH_HAVE_CREATE_TRAMPOLINE_FROM_TOKEN define.

2009-05-02  Zoltan Varga  <vargaz@gmail.com>

	* tramp-amd64.c (mono_arch_get_static_rgctx_trampoline): Increase the
	buffer length to work with AOT code.

	* method-to-ir.c (mono_method_to_ir): Handle loading errors in the
	ldfld/stfld opcodes.

	* exceptions-x86.c (mono_arch_get_throw_exception_by_name): Simplify this
	as it is not used.

	* mini-llvm.c mini-x86.c: Implement 32 bit and x86 support.

	* ssa.c (mono_ssa_compute): Don't skip I8 values when using LLVM.

	* mini-llvm-cpp.cpp (mono_llvm_create_ee): Update to the latest
	LLVM API.

	* mini.c (mini_method_compile): Set the from_llvm flag in MonoJitInfo
	if needed. Don't decompose long operations when using llvm.

2009-05-01  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c aot-runtime.c: Use mono_pagesize () instead of the
	PAGESIZE constant.

	* aot-runtime.c (load_aot_module): Get rid of another mprotect call.

2009-05-03  Martin Baulig  <martin@ximian.com>

	* debug-debugger.c (debugger_insert_source_breakpoint): Don't call
	mono_debugger_insert_method_breakpoint() since the class init
	handler we're inserting at the top of the method already gives us
	a notification.

2009-04-30  Zoltan Varga  <vargaz@gmail.com>

	* decompose.c (mono_decompose_long_opts): Move the implementation of LNEG
	to mono_arch_decompose_long_opts () for x86 and arm.

2009-04-29  Zoltan Varga  <vargaz@gmail.com>

	* mini-codegen.c (mono_regstate_alloc_int): Use __x86_64__ instead of
	TARGET_AMD64 here.

2009-04-28  Zoltan Varga  <vargaz@gmail.com>

	* *.h *.c: Use TARGET_<ARCH> defines instead of __<arch>__ defines in the
	JIT code.

2009-04-26  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (mono_aot_create_specific_trampoline): Add a stat for the
	number of trampolines used in full-aot mode.

	* aot-compiler.c: Add an ntrampolines option to set the number of 
	trampolines emitted in full-aot mode.

2009-04-27  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c (mono_llvm_emit_method): Implement OP_CHECK_THIS using
	a volatile load. Get rid of get_tempname (), llvm assigns names
	automatically.

	* mini-llvm-cpp.cpp (mono_llvm_build_volatile_load): New instruction
	builder function.

	* mini-llvm.c (mono_llvm_emit_method): Don't call LLVMGetParam on
	a value.

	* abcremoval.c (REPORT_ABC_REMOVAL): Don't output messages at verbose
	level 1.

	* mini-codegen.c (mono_local_regalloc): Prevent sreg1/dreg to be allocated
	to the same register as a fixed sreg2. Fixes #497271.

	* iltests.il.in: Add a new test.

2009-04-26  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c: Use moves instead of pushes for passing arguments on the
	stack, since pushes complicate exception handling.

	* exceptions-amd64.c (mono_arch_find_jit_info): Don't pop the arguments of
	the stack if they are passed using moves.

	* mini-trampolines.c (mono_llvm_vcall_trampoline): Add an assert.

	* method-to-ir.c (mono_method_to_ir): Disable fast virtual generic methods
	when using llvm.

	* mini-llvm.c (mono_llvm_emit_method): Call jit icall wrappers, not the 
	icalls themselves. Convert arguments of FCOMPARE. Convert the destination
	of FMOVE if it is an R4.

2009-04-25  Zoltan Varga  <vargaz@gmail.com>

	* mini-ops.h: Add OP_LLVM_OUTARG_VT opcode.

	* mini.h (LLVMCallInfo): New structure to store calling convention 
	information for the LLVM back end similar to the CallInfo structures in 
	the back-ends.

	* mini-amd64.c (mono_arch_get_llvm_call_info): New arch function to return
	call information in a format usable by LLVM.
	(mono_arch_emit_call): Move the LLVM handling code to mono_llvm_emit_call ().

	* method-to-ir.c (mono_emit_call_args): Emit calls using 
	mono_llvm_emit_call () when compiling using LLVM.

	* mini-llvm.c: Implement support for passing/receiving valuetypes. Add
	comments to all functions. Fix memory leaks. Add a public init/cleanup
	function.

	* mini.c: Call the llvm init/cleanup functions in mini_init()/cleanup().

	* method-to-ir.c (handle_array_new): Disable llvm when calling the vararg
	mono_array_new_va () jit icall.
	
Fri Apr 24 16:44:08 CEST 2009 Paolo Molaro <lupus@ximian.com>

	* Makefile.am, genmdesc.c, genmdesc.pl: tiny refactor to allow
	multiple machine description files to be specified.
	* mini-ops.h: fixes for cross-compilation.

2009-04-22  Miguel de Icaza  <miguel@novell.com>

	* aot-runtime.c (make_writable): Use mono_mprotect to simplify
	some porting work.

2009-04-22  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mono_method_to_ir): Force init_locals to be TRUE
	to prevent asserts in various passes. Fixes #497220.

2009-04-21  Zoltan Varga  <vargaz@gmail.com>

	* mini-trampolines.c (mono_generic_class_init_trampoline): Remove
	a racy assert.

	* aot-compiler.c aot-runtime.c: Emit the unwind info into a separate
	table to avoid duplicates.

	* mini.h (MONO_AOT_FILE_VERSION): Bump this.
	
	* aot-compiler.c (emit_method_code): Avoid writing symbols if the nodebug
	option is used.

2009-04-20 Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c (mini_method_verify): Fail fulltrust code if the exception
	is for method or field access.

2009-04-20  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm-cpp.cpp (mono_llvm_dump_value): New helper function to print
	a Value to stdout.

	* mini-llvm.c (mono_llvm_emit_method): Use it.
	
	* mini-llvm.c (type_to_llvm_type): Fix the mapping of enums.
	(mono_llvm_emit_method): Add support for CAS. Fix handling of CSET opcodes
	on volatile values.

	* mini-trampolines.c (mono_llvm_vcall_trampoline): Add support for 
	synchronized methods.

	* mini.c (mini_method_compile): Disable LLVM for dynamic methods.

	* mini.c (mini_method_compile): Enable ABCREM when running with LLVM.

	* mini-llvm.c (mono_llvm_emit_method): Add support for OP_LOADI4_MEM/
	OP_LOADI8_MEM.

	* mini-llvm-cpp.cpp (mono_llvm_create_ee): Add a MONO_LLVM env variable
	allowing some options to be set dynamically.

2009-04-19  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c (mono_llvm_emit_method): Handle compares followed by an
	unconditional branch.

	* mini.h (MonoTrampolineType): Add new trampoline type 
	'MONO_TRAMPOLINE_LLVM_VCALL' which handles virtual calls made from LLVM
	compiled code.

	* mini-trampolines.c (mono_llvm_vcall_trampoline): New C trampoline 
	function.

	* mini-trampolines.c (mono_create_llvm_vcall_trampoline): New trampoline
	creation function.

	* mini.c (mini_init): Avoid using the common vtable trampoline when LLVM
	is enabled. Instead, use the llvm vcall trampoline.
	
	* mini-trampolines.c (mono_get_vcall_slot_addr): New helper function.

	* mini-trampolines.c tramp-amd64.c tramp-x86.c: Use it.
	
	* mini-<ARCH>.c: Get rid of the identical mono_arch_get_vcall_slot_addr ()
	functions.

	* mini-<ARCH>.h mini-trampolines.c mini.c: Get rid of 
	MONO_ARCH_COMMON_VTABLE_TRAMPOLINE, it is supported by all archs.

	* mini-ia64.c (mono_arch_lowering_pass): Null out the sregs of the
	OP_IA64_CSET opcode.

	* mini.c: Fix a warning.

	* mini-llvm.c (mono_llvm_emit_method): Convert arguments of SWITCH and
	THROW to the appropriate llvm type.

2009-04-18  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_method_compile): Add statistics for methods JITted
	with/without LLVM.

2009-04-17  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c: Fix the computation of ins_sreg_counts for ia64
	OP_IA64_CMP_<cond>_IMM opcodes.

2009-04-17  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c (emit_cond_system_exception): Implement throwing of
	corlib exceptions.

	* dwarfwriter.c (mono_dwarf_writer_emit_method): Handle --regression
	correctly.

	* mini-llvm.c (type_to_llvm_type): Avoid accessing t->data.klass for
	GENERICINST.

2009-04-17  Atsushi Enomoto  <atsushi@ximian.com>

	* mini-exceptions.c : add thread id to EXCEPTION trace message.

2009-04-17  Zoltan Varga  <vargaz@gmail.com>

	* tramp-amd64.c (mono_arch_get_static_rgctx_trampoline): Fix AOT
	support.

	* tramp-x86.c (mono_arch_get_unbox_trampoline): Implement static
	rgctx invoke trampolines for x86.

	* mini-x86.c (mono_arch_output_basic_block): Add a few nops before
	indirect calls to simplify get_vcall_slot_addr (). Fixes #494567.
	(mono_arch_get_vcall_slot): Simplify this.

2009-04-16  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_get_delegate_invoke_impl): Move the calls to
	mono_debug_add_delegate_trampoline () to get_delegate_invoke_impl ().

2009-04-14  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c tramp-arm.c mini-arm.c: Implement static rgctx 
	trampolines for ARM. Add full-aot support for delegate invokes for ARM.

	* mini-trampolines.c (mono_magic_trampoline): Fix the build.

	* liveness.c (visit_bb): Remove a needless assert.

2009-04-13  Zoltan Varga  <vargaz@gmail.com>

	* mini-trampolines.c (mono_create_delegate_trampoline): Delegate the
	full aot support to the arch specific code.

	* mini-amd64.c (mono_arch_get_delegate_invoke_impl): Add full-aot support.

	* aot-compiler.c (emit_trampolines): Emit delegate invoke impl trampolines.

	* aot-compiler.c (emit_named_code): Rename this to 'emit_trampoline'.
	
	* mini-amd64.c (mono_arch_get_delegate_invoke_impls): New function to
	collect information about the delegate invoke impl trampolines.

	* mini.h (MonoAotTrampInfo): New structure collecting the information needed
	to save trampolines during full-aot mode.

	* mini-trampolines.c (mono_create_static_rgctx_trampoline): New trampoline
	creation function which returns a trampoline which sets the rgctx
	argument.
	(mono_magic_trampoline): Use the rgctx trampoline instead of an rgctx
	wrapper if possible.
	(mono_delegate_trampoline): Ditto.

	* mini.c (mono_jit_runtime_invoke): Ditto.

	* tramp-amd64.c: Add an implemention of static rgctx trampolines for AMD64.
	
	* aot-compiler.c aot-runtime.c: Add support for static rgctx trampolines.

	* mini.h (MONO_AOT_FILE_VERSION): Bump this.
	
2009-04-12  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c (mono_arch_lowering_pass): Use NULLIFY_INS instead of
	just setting the opcode to OP_NOP.

2009-04-11  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_method_compile): Put the last change inside an 
	#ifdef MONO_ARCH_HAVE_LIVERANGE_OPS.
	
	* mini.c (mini_method_compile): Disable sharing of stack slots/registers
	and extend live ranges to cover the whole method when using xdb.

	* jit-icalls.c (ldvirtfn_internal): Avoid creating rgctx wrappers here,
	do it in the trampolines.

	* mini-trampolines.c (mono_magic_trampoline): Add an rgctx wrapper if
	needed.

	* mini-trampolines.c (mono_delegate_trampoline): Ditto.
	
	* method-to-ir.c (mono_method_to_ir): Avoid using the fast virtual method
	call code in full-aot mode since IMT is disabled there.
	(mono_method_to_ir): Inline ldfld wrappers which return structures too, the
	new JIT no longer has that restriction.

	* mini.h (MONO_AOT_FILE_VERSION): Bump this.

	* aot-compiler.c (emit_extra_methods): Emit the wrapper method names in
	a more compact format.
	(mono_aot_wrapper_name): New function to return a unique name for a
	wrapper method, also used by the AOT runtime.

	* aot-runtime.c (find_extra_method_in_amodule): Update after the changes to
	aot-compiler.c.

	* aot-compiler.c (add_generic_class): Add the helper methods from T[]
	when a ICollection<T> etc is encountered.
	(add_generic_instances): Process method arguments/locals too.
	(emit_trampolines): Emit unbox trampolines for extra methods too. Shorten
	trampoline names.

	* aot-runtime.c (mono_aot_get_unbox_trampoline): Handle extra methods too.
	
2009-04-10  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c: Disable the AOT compiler if the JIT is disabled.

	* dwarfwriter.c (emit_type): Emit byref to reference types as 'int' for now.

	* decompose.c (mono_decompose_opcode): Make this return a MonoInst*
	representing the result of the decomposition. Nullify instructions
	instead of setting them to OP_NOP since nops can't have registers
	set.

2009-04-09  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (mono_compile_assembly): Split this huge function into
	smaller parts. Add 'nodebug' option to prevent generation of DWARF debug
	info. Strip 'mapping symbols' on ARM.

	* iltests.il.in (test_0_fconv_to_i): Disable this on ARM too.
	
	* genmdesc.pl: Applied patch by Martin Fuzzey (mfuzzey@parkeon.com). Sync
	this with the native genmdesc.

2009-04-08  Bill Holmes  <billholmes54@gmail.com>

	* aot-runtime.c:  Fixing the MSVC build.

	Code is contributed under MIT/X11 license.

2009-04-08  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c (mono_llvm_emit_method): Pass i1/i2 arguments as i4 since 
	JITted code depends on it.

2009-04-08  Raja R Harinath  <harinath@hurrynot.org>

	* aot-compiler.c: Use new MonoGenericParam accessors.

2009-04-08  Raja R Harinath  <harinath@hurrynot.org>

	Reduce memory usage and improve correctness wrt MonoGenericParam
	* aot-runtime.c (decode_klass_ref): Simplify generic parameter
	handing.  Avoid allocating MonoGenericParams, but use the ones in
	the container itself.

2009-04-07  Miguel de Icaza  <miguel@novell.com>

	* tasklets.c: Return exceptions in the out argument.

2009-04-08  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c (mono_llvm_emit_method): Fix alignment in the LOCALLOC_IMM
	opcode. Use pointer types in more places instead of casting them to 
	integers.

	* mini-llvm-cpp.cpp (mono_llvm_create_ee): Create a pass manager to run
	optimizations.
	(mono_llvm_optimize_method): New helper function to optimize a method.

	* method-to-ir.c (mono_emit_widen_call_res): Extract the call result 
	widening code so it could be called from more places.
	(mono_method_to_ir): Call mono_emit_widne_call_res () in several more
	code paths in the call opcodes.

Mon Apr 6 14:19:54 CEST 2009 Paolo Molaro <lupus@ximian.com>

	* exceptions-amd64.c, mini-amd64.h: amd64 support code for continuations.

2009-04-06  Zoltan Varga  <vargaz@gmail.com>

	* dwarfwriter.c: Use _ to separate class name 
	components as gdb can't handle '.'. Represent reference variables
	as 'class <NAME>&'.
	
	* mini.h (MonoCompile): Add locals_min_stack_offset/locals_max_stack_offset.

	* mini-amd64.c (mono_arch_allocate_vars): Save min/max stack offset.
	
	* mini-gc.c: New file, contains the SGEN GC related parts of the JIT.

	* gc-test.cs: New file with GC stack marking tests.
	
	* mini-arm.c (mono_arch_output_basic_block): Fix int->float conversion of
	negative numbers for vfp.

	* basic-float.cs: Add a test.
	
Mon Apr 6 14:12:10 CEST 2009 Paolo Molaro <lupus@ximian.com>

	* exceptions-x86.c, mini-x86.h: x86 support code for continuations.

Mon Apr 6 14:09:53 CEST 2009 Paolo Molaro <lupus@ximian.com>

	* tasklets.h, tasklets.c, mini.h, mini.c, Makefile.am: arch-indep
	part of tasklet/continuation support.

2009-04-05  Zoltan Varga  <vargaz@gmail.com>

	* mini-llvm.c (mono_llvm_emit_method): Move the handling of
	amd64 opcodes inside an ifdef.

	* dwarfwriter.c: Emit inheritance information for classes, emit fields
	of complex types.
	
	* dwarfwriter.c (emit_type): Emit the class info for classes.

2009-04-04  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am (AM_CXXFLAGS): Add GLIB_CFLAGS to this.

	* mini-llvm-cpp.h: New header file for mini-llvm-cpp.cpp.

	* mini-llvm.c: Remove unused fields from EmitContext, fix memory leaks.

	* ssa.c (mono_ssa_compute): Fix some memory leaks.

2009-04-03  Zoltan Varga  <vargaz@gmail.com>

	* mini.c mini-amd64.c method-to-ir.c: Use COMPILE_LLVM in a few more places.

	* mini-llvm.c: Update comments.

	* mini.h (COMPILE_LLVM): New macro.

	* decompose.c (mono_decompose_opcode): Use the COMPILE_LLVM macro.

	* ssa.c (mono_ssa_compute): Ditto.
	
	* unwind.c (mono_unwind_get_ops_from_fde): New helper function to extract
	the unwind ops from a DWARF FDE.

	* mini-llvm.c: Implement generation of unwind info for LLVM compiled
	methods by extracting the dwarf unwind ops from the unwind info generated
	by LLVM.
	
	* mini-llvm.c (mono_llvm_emit_method): Enable support for non-IMT virtual
	calls.

	* mini-amd64.c (mono_arch_get_vcall_slot): Handle more kinds of the SIB
	addressing modes.

2009-04-02  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am (llvm_sources): Enable this.

	* mini.c (mini_method_compile): Add support for compiling with LLVM, 
	failing back to the JIT if something cannot be handled.

	* mini-amd64.c (mono_arch_emit_call): Emit the arguments more simple when
	compiling with LLVM.

	* decompose.c (mono_decompose_opcode): Avoid decomposing some opcodes when
	compiling with LLVM.

	* method-to-ir.c (mono_method_to_ir): Avoid decomposing SWITCH when 
	compiling with LLVM.

	* mini-ops.h: Add a few opcodes needed by LLVM.

	* dwarfwriter.c (mono_dwarf_writer_emit_method): Avoid crashes if the method
	has no unwind info.

	* mini-llvm.c mini-llvm-cpp.cpp: New files containing the experimental llvm
	backend.

	* mini-arm.c (mono_arch_output_basic_block): Fix the ARM_FPU_NONE build.

	* mini-arm.h mini-arm.c cpu-arm.md: Finish VFP support.

2009-04-01  Mark Probst  <mark.probst@gmail.com>

	* regalloc.h, mini-codegen.c: Make vassign members gint32 to fix
	ridiculously large methods.

2009-03-31  Martin Baulig  <martin@ximian.com>

	* debug-debugger.c (debugger_remove_breakpoint): Call
	mono_debugger_remove_class_init_callback ().

2009-03-31  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (mono_compile_assembly): Call img_writer_emit_start ()
	right before emitting code, not at the start.

	* mini.c (mono_postprocess_patches): Extract this into a separate function
	from mono_codegen ().

	* ssa.c (mono_ssa_compute): Set ins->klass for every PHI node, handle
	byref types correctly.

2009-03-30  Zoltan Varga  <vargaz@gmail.com>

	* dwarfwriter.c (mono_dwarf_writer_emit_method): Fix a crash introduced
	by the last change.

2009-03-29  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_output_basic_block): Emit a few nops before 
	indirect calls, this avoids problems where get_vcall_slot () would get
	confused by the native code for the instruction preceeding the call.
	(mono_arch_get_vcall_slot): Simplify this.
	(mono_arch_emit_imt_argument): Remove this, it is no longer needed.

	* mini-ops.h: Fix the definitions of the OP_IA64 opcodes, since the local
	register allocator now seems to depend on them instead of the data in
	cpu-<ARCH>.md.

	* mini.c (mini_method_compile): Throw the correct type of exception if
	mono_method_get_header () fails because of a loading error.

2009-03-28  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_method_compile): Clear the loader error if the method
	header cannot be decoded.

	* mini-trampolines.c (mono_magic_trampoline): Handle generic virtual 
	interface methods on proxies correctly.

	* dwarfwriter.c (mono_dwarf_writer_emit_method): Fix handling of the
	this argument for vtype methods. Add precise liveness info for arguments.

	* mini-codegen.c (mono_print_ins_index): Print the vreg of the
	LIVERANGE_START/END opcodes.

	* method-to-ir.c (mono_spill_global_vars): Fix liverange calculation
	for arguments and values in registers.

2009-03-27  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mono_method_to_ir): Disable tail calls for calls which
	return a valuetype. Fixes #487518.

	* iltests.il: Add a test.
	
	* aot-compiler.c: Use mono_thread_create () to create helper threads.

	* mini-trampolines.c (mono_delegate_trampoline): Handle static delegates
	closed over a null reference correctly.

2009-03-26  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mono_handle_global_vregs): Fix support for ternary ops.

2009-03-25  Mark Probst  <mark.probst@gmail.com>

	* mini-codegen.c (mono_local_regalloc): Don't let sregs get
	allocated to the same registers as fixed sregs.

2009-03-24  Mark Probst  <mark.probst@gmail.com>

	* mini-ops.h: New ternary ATOMIC_CAS ops replace the old
	ATOMIC_CAS_IMM ops.

	* method-to-ir.c: Handle more cases for
	Interlocked.CompareExchange.

	* cpu-x86.md, mini-x86.c, mini-x86.h, cpu-amd64.md, mini-amd64.c,
	mini-amd64.h, cpu-ppc.md, cpu-ppc64.md, mini-ppc.c, mini-ppc.h:
	ATOMIC_CAS implementations for x86, AMD64, PPC and PPC64.

2009-03-23  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (decode_method_ref): Fix a warning.

	* unwind.c (mono_unwind_frame): Ditto.	

2009-03-22  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (arch_emit_unbox_trampoline): Fix the binary writer support.
	(mono_compile_assembly): Enable the binary writer for full-aot as well.

	* image-writer.c (do_reloc): Add support for the JUMP24 relocation,
	fix the handling of large values in the ALU_PC_G0_NC relocation.

2009-03-22  Zoltan Varga  <vargaz@gmail.com>

	* local-propagation.c method-to-ir.c local-propagation.c: Fix warnings.

2009-03-22  Mark Probst  <mark.probst@gmail.com>

	* method-to-ir.c (mono_spill_global_vars): Support for ternary
	ops.

2009-03-22  Mark Probst  <mark.probst@gmail.com>

	* method-to-ir.c: MINI_OP3 needs a comma.

	* method-to-ir.c, mini.h, mini.c: Remove
	mono_init_op_sreg_counts ().

2009-03-22  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c (mono_arch_output_basic_block): Fix aot support in
	OP_JMP.
	
	* mini-arm.c (mono_arch_build_imt_thunk): Disable the !fail_tramp
	assertion.

	* mini-ops.h: Fix arguments of the MEMINDEX opcodes.

	* mini-amd64.c (mono_arch_build_imt_thunk): Simplify the fail handling
	code somewhat.

2009-03-21  Mark Probst  <mark.probst@gmail.com>

	* cfold.c, cprop.c, decompose.c, genmdesc.c, helpers.c, ir-emit.h,
	liveness.c, local-propagation.c, method-to-ir.c, mini-codegen.c,
	mini.c, mini.h, simd-intrinsics.c, ssa.c: Support for ternary IR
	operations.

2009-03-20  Zoltan Varga  <vargaz@gmail.com>

	* driver.c: Change location of gc_wrapper.h.

	* method-to-ir.c (mono_find_block_region): Handle try clauses nested
	inside finally clauses correctly. Fixes #485721.

	* mini.c (mono_find_spvar_for_region): This needs to handle try regions
	after the change above.

	* exceptions.cs: Add a test.
	
2009-03-19  Zoltan Varga  <vargaz@gmail.com>

	* unwind.c (mono_unwind_ops_encode): Increase the size of the encode buffer.

	* mini-amd64.c (mono_arch_emit_epilog): Remove the encoding of stack size
	into cfg->used_int_regs, it is not needed with the dwarf unwinder.
	(mono_arch_compute_omit_fp): Remove the emit_epilog () workaround.

	* mini-amd64.c (mono_arch_compute_omit_fp): Add another check to avoid hitting
	the stack_alloc_size < (1 << 16) assertion in emit_prolog ().

2009-03-19  Sebastien Pouliot  <sebastien@ximian.com>

	* method-to-ir.c: Allow CoreCLR to throw FieldAccessException. 
	Simplify logic for ensure_method_is_allowed_to_call_method. 
	Handle wrappers on callers.

2009-03-19  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am (fullaotcheck): Don't run the generics tests, some of
	them don't run yet.

	* basic-simd.cs: Fix the names of some test methods.

2009-03-18  Geoff Norton  <gnorton@novell.com>

	* mini.c: Only chain sigfpe if it wasn't generated in mangaed code.

2009-03-18  Zoltan Varga  <vargaz@gmail.com>

	* dwarfwriter.c (token_handler): Fix a crash caused by the last change.

2009-03-17  Jb Evain  <jbevain@novell.com>

	* driver.c: remove now uneeded call to mono_gc_base_init before
	mono_profiler_load.

2009-03-17  Jb Evain  <jbevain@novell.com>

	* dwarfwriter.c (token_handler): handle more cases.

2009-03-17  Sebastien Pouliot  <sebastien@ximian.com> 

	* method-to-ir.c: Remove more dead code (that was required only
	because of method_is_safe). Fix compiler warnings.

2009-03-17  Sebastien Pouliot  <sebastien@ximian.com>

	* method-to-ir.c: Remove unneeded/useless method_is_safe
	http://lists.ximian.com/archives/public/mono-devel-list/2009-March/031404.html

2009-03-16 Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c (mini_method_compile): Print the method been compiled with
	verbose level 1 instead of 3 as this helps a lot debugging JIT crashes
	for people not familiar with the runtime.

2009-03-17  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (get_generic_info_from_stack_frame): Avoid returning
	a managed object which is later put into a GList. Return its class instead.

	* mini.c (mono_allocate_stack_slots_full): Avoid sharing ref and non-ref
	stack slots when using sgen.

2009-03-16  Zoltan Varga  <vargaz@gmail.com>

	* dwarfwriter.c (emit_line_number_info): Really fix the eglib build.

2009-03-14  Zoltan Varga  <vargaz@gmail.com>

	* local-propagation.c (reg_is_softreg_no_fpstack): Use >= instead of
	> so it works on the first vreg as well.

2009-03-13  Zoltan Varga  <vargaz@gmail.com>

	* dwarfwriter.c (emit_line_number_info): Disable an assert which seems to
	trigger randomly.

	* aot-compiler.c: Get rid of xdebug_lock (), use the loader lock instead.
	
	* dwarfwriter.c (emit_line_number_info): Fix eglib build as eglib doesn't
	implement GArray.

2009-03-12  Zoltan Varga  <vargaz@gmail.com>

	* dwarfwriter.c (emit_line_number_info): Optimize the computation of the
	native->IL offset mapping.

2009-03-11  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_output_basic_block): Fix % 1. Fixes #484323.

	* basic.cs: Add a test.

2009-03-11  Mark Probst  <mark.probst@gmail.com>

	* mini-x86.c (mono_arch_output_basic_block): Use different
	registers in case the ones we want to overwrite are used by the
	other operand.  Fixes regression in #480807.

2009-03-10  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (mono_compile_assembly): Make the output less verbose.

	* dwarfwriter.c (emit_line_number_info): The line number info for
	IL code was off by one. Fix that.

	* mini-s390x.c: Fix support for vtypes whose addresses are passed on the
	stack.

2009-03-09  Mark Probst  <mark.probst@gmail.com>

	Contributed under the terms of the MIT/X11 license by Steven
	Munroe <munroesj@us.ibm.com>.

	* mini-ppc.c: Correct handling of OP_LOADI4_MEMINDEX for ppc64.
	Fixes #483462.

2009-03-08  Zoltan Varga  <vargaz@gmail.com>

	* dwarfwriter.c (token_handler): Decode method references in non-wrappers
	as well.

2009-03-06  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mono_method_to_ir): Check for type load exceptions in
	the delegate ctor handling code. Fixes #482638.
	
	* method-to-ir.c (mini_emit_memset): Fix the handling of size '3'. Fixes
	#481458.

	* iltests.il.in: Add a test.
	
	* mini-darwin.c (mono_chain_signal): Remove this, it is already in
	mini-posix.c.

2009-03-05  Mark Probst  <mark.probst@gmail.com>

	* mini-trampolines.c (mono_create_jump_trampoline): If the method
	is shared generic code, return the trampoline, even if the method
	has already been compiled.  Fixes #479763.

	* mini.c, mini.h: New function
	mono_jit_find_compiled_method_with_jit_info() which is the same as
	mono_jit_find_compiled_method() but also returns the jit info.

2009-03-05  Mark Probst  <mark.probst@gmail.com>

	* method-to-ir.c (mono_method_to_ir): Only force the vtable var
	for methods which actually have one.  For all other methods, make
	sure the this argument var is live the whole method.

	* mini.c (mini_method_compile): Every shared method has a
	this/vtable/mrgctx info.  Fixes #480807.

2009-03-05  Mark Probst  <mark.probst@gmail.com>

	* mini-ppc.c (mono_arch_build_imt_thunk): Add support for mixed
	generic/imt thunks where some entries branch through the vtable,
	while other entries branch directly.

2009-03-05  Zoltan Varga  <vargaz@gmail.com>

	* mini-darwin.c (mono_chain_signal): Define this to fix the build.

	* mini-windows.c: Ditto.
	
	* mini.c (mono_jit_runtime_invoke): Speed up the invoking of parameterless
	ctors.

2009-03-04  Zoltan Varga  <vargaz@gmail.com>

	* dwarfwriter.c (emit_line_number_info): Add some debug code to help track
	down an assert.

2009-03-04  Mark Probst  <mark.probst@gmail.com>

	* method-to-ir.c: Don't inline methods that use JMP.  Fixes
	#481403.

2009-03-04  Mark Probst  <mark.probst@gmail.com>

	* exceptions-x86.c: Include debug-mini.h - fixes build.

2009-03-04  Martin Baulig  <martin@ximian.com>

	* debug-mini.c: Clean up the exception API and add documentation.
	(mono_debugger_handle_exception): New public method; this is
	called when throwing an exception or encountering an unhandled one.
	(mono_debugger_call_exception_handler): Formerly known as
	mono_debugger_handle_exception(); this is used to tell the
	debugger that we're about to invoke an exception handler.

2009-03-04  Martin Baulig  <martin@ximian.com>

	* debug-mini.c (mono_debugger_runtime_invoke): Moved here from
	../metadata/mono-debug-debugger.c; save and reset exception state.

2009-03-02  Martin Baulig  <martin@ximian.com>

	* debug-mini.c: Moved the debugger exception handling here from
	../metadata/mono-debug-debugger.c.

	* debug-mini.h
	(MonoDebuggerExceptionAction): New exception typedef.

	* debug-mini.c
	(MonoDebuggerThreadInfo): Added `MonoObject *last_exception'.

	* exceptions-amd64.c
	(mono_amd64_throw_exception): Use the new debugger exception
	handling code.

	* mini-exceptions.c
	(mono_handle_exception_internal): Don't call
	mono_debugger_unhandled_exception() here.

2009-03-03  Zoltan Varga  <vargaz@gmail.com>

	* mini.c aot-compiler.c: Update after the changes to 
	mono_marshal_get_runtime_invoke ().

	* mini-trampolines.c (mono_convert_imt_slot_to_vtable_slot): 
	Virtual generic methods might not have method->slot set, work around
	that.

	* generics.cs: Add a test.

2009-03-02  Geoff Norton  <gnorton@novell.com>

	* mini.c:
	* driver.c: Allow signal chaining of SIGFPE as well.

2009-03-02  Zoltan Varga  <vargaz@gmail.com>

	* mini-trampolines.c (mono_generic_virtual_remoting_trampoline): Update
	this since it now receives the method not its generic context in the
	IMT reg.

	* mini-amd64.c (mono_arch_build_imt_thunk): Add support for mixed
	generic/imt thunks where some entries branch through the vtable, while
	other entries branch directly.

	* mini-x86.c (mono_arch_build_imt_thunk): Ditto.

	* method-to-ir.c (mono_method_to_ir): Enable fast virtual generic call 
	support for interface methods as well.

	* mini-trampolines.c: Add support for virtual generic methods in interfaces
	using the normal IMT thunks.

	generics.cs: Add new tests.
	
	* method-to-ir.c (mono_method_to_ir): Pass the method instead of
	the generic inst to the generic imt thunks. This fixes AOT support, 
	improves consistency with the normal IMT thunks, and makes it easier to
	add support for interface generic virtual methods later.

	* mini-trampolines.c (mono_magic_trampoline): Ditto.	
	
2009-02-28  Zoltan Varga  <vargaz@gmail.com>

	* driver.c (mono_set_signal_chaining): New public API function to enable
	signal chaining on POSIX platforms.

	* mini-posix.c mini.c: Applied a variant of a patch by Simon Rowland 
	(si@lindenlab.com) to implement signal chaining. The original patch was
	contributed under the MIT X/11 license:
	https://bugzilla.novell.com/show_bug.cgi?id=318894

2009-02-27  Zoltan Varga  <vargaz@gmail.com>

	* iltests.il.in (test_0_implicit_float_to_double_conversion): Disable this
	too until it can be made to run on amd64.

2009-02-26  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (mono_arch_get_this_arg_from_call): Avoid expensive calls
	to  get_generic_context_from_code () + get_call_info () if possible.

2009-02-25  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (mono_handle_native_sigsegv): Implement the
	suspend-on-sigsegv functionality.

	* mini.c (mini_parse_debug_options): Add a new 'suspend-on-sigsegv' option
	to suspend when a native SIGSEGV is received. This is useful for debugging
	crashes which don't happen under gdb, since a live process contains more
	information than a core file.

	* mini-exceptions.c (mono_print_thread_dump): Use 
	MONO_ARCH_HAVE_SIGCTX_TO_MONOCTX instead of platform defines.

	* mini-x86.h (MONO_ARCH_HAVE_SIGCTX_TO_MONOCTX): New define.

	* mini-amd64.h (MONO_ARCH_HAVE_SIGCTX_TO_MONOCTX): Ditto.
	
	* basic-float.cs: Disable the tests which currently fail on amd64.

	* tramp-amd64.c (mono_arch_nullify_class_init_trampoline): Pass a non-null 
	value to mono_arch_patch_callsite () to fix crashes.
	
	* tramp-amd64.c (mono_arch_nullify_class_init_trampoline): Fix a warning.

2009-02-23  Zoltan Varga  <vargaz@gmail.com>

	* tramp-amd64.c (mono_arch_nullify_class_init_trampoline): Replace the
	nop code by patching the call address to point to the nullified class init
	trampoline, as the former does not seem to be safe on SMP machines.

2009-02-23  Mark Probst  <mark.probst@gmail.com>

	* mini-ops.h: Fix the argument types for a few x86 opcodes where
	they were wrong.

2009-02-23  Zoltan Varga  <vargaz@gmail.com>

	* basic-float.cs basic-calls.cs: Fix warnings.

2009-02-22  Mark Probst  <mark.probst@gmail.com>

	* tramp-ppc.c (mono_arch_create_trampoline_code): Store the
	correct frame pointer in the LMF.  Should fix #478394.

2009-02-22  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am (fullaotcheck): Copy Mono.Simd.dll as well.

	* image-writer.c: Make the binary writer less verbose.

2009-02-21  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mono_method_to_ir): Don't assert if string ctors
	are called from runtime invoke wrappers.

2009-02-20  Zoltan Varga  <vargaz@gmail.com>

	* cpu-ppc.md (store_memindex): Increase the size of this.

2009-02-20 Rodrigo Kumpera  <rkumpera@novell.com>

	Extracted from a patch by Kornel Pal <kornelpal@gmail.com>.

	* cpu-x86.md: Fix the sizes for long_conv_to_r_un and long_conv_to_r_un_2.

	* mini-x86.c (mono_arch_output_basic_block): Use only 64bits of precision for
	OP_LCONV_TO_R_UN.

	Last fix for of #467201.


2009-02-20 Rodrigo Kumpera  <rkumpera@novell.com>

	Extracted from a patch by Kornel Pal <kornelpal@gmail.com>.

	* cpu-x86.md: Fix the sizes for fcall(_reg,_membase), long_conv_to_r4_2
	and long_conv_to_r8_2:

	Fixed part of #467201.

2009-02-20 Rodrigo Kumpera  <rkumpera@novell.com>

	Extracted from a patch by Kornel Pal <kornelpal@gmail.com>.

	* mini-x86.c (mono_arch_output_basic_block): Adjust precision of int to float
	conversion to 32 bits.

	* cpu-x86.md: Increase the size of int_conv_to_r4.

	* basic-float.cs: Add a test for this.

	Fixed part of #467201.

2009-02-20 Rodrigo Kumpera  <rkumpera@novell.com>

	Extracted from a patch by Kornel Pal <kornelpal@gmail.com>.

	* mini-x86.c (mono_arch_output_basic_block): Adjust precision of long to double
	conversion to 64 bits.

	* basic-float.cs: Add a test for this.

	Fixed part of #467201.

2009-02-20 Rodrigo Kumpera  <rkumpera@novell.com>

	Extracted from a patch by Kornel Pal <kornelpal@gmail.com>.

	* mini-x86.c (emit_move_return_value): Don't reduce precision of functions returning float.
	This behavior is compatible with MS.

	* iltest.il.in: Add a test for this.

	Fixed part of #467201.

2009-02-20 Rodrigo Kumpera  <rkumpera@novell.com>

	Extracted from a patch by Kornel Pal <kornelpal@gmail.com>.

	* mini-x86.c (mono_arch_output_basic_block): Implement OP_FCONV_TO_R4, it must
	change the precision of the value.

	* cpu-x86.md: Define len for float_conv_to_r4.

	* basic-float.cs: Add a test for this.

	Fixed part of #467201.

2009-02-19 Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c: Adjust locking order to the new semantics where the loader lock
	comes first.

2009-02-18  Rodrigo Kumpera  <rkumpera@novell.com>

	* aot-runtime.c:
	* mini-amd64.c:
	* mini-arm.c:
	* mini-ia64.c:
	* mini-mips.c:
	* mini-ppc.c:
	* mini-sparc.c:
	* mini-trampolines.c:
	* mini-x86.c:
	* mini.c:
	* tramp-alpha.c:
	* tramp-amd64.c:
	* tramp-arm.c:
	* tramp-hppa.c:
	* tramp-ia64.c:
	* tramp-mips.c:
	* tramp-ppc.c:
	* tramp-s390.c:
	* tramp-s390x.c:
	* tramp-sparc.c:
	* tramp-x86.c: Use mono_domain_code_* functions instead of using MonoDomain::code_mp directly.

2009-02-18  Zoltan Varga  <vargaz@gmail.com>

	* mini-codegen.c (mono_local_regalloc): Remove a ! from if (!dest_sreg1)
	as it is incorrect.

2009-02-17  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (add_generic_class): Only add rgctx invoke wrappers
	for cctors if needed.

2009-02-17  Mark Probst  <mark.probst@gmail.com>

	* mini-ppc.c: Fix build on Darwin.

2009-02-17  Zoltan Varga  <vargaz@gmail.com>

	* dwarfwriter.c (mono_dwarf_writer_emit_base_info): Use 2 as the DWARF
	version instead of 3 as valgrind doesn't like version 3.

	* mini.h (MONO_AOT_FILE_VERSION): Bump this.

	* aot-compiler.c (mono_aot_method_hash): New function to return a hash
	usable for hashing methods.
	(emit_extra_methods): Use the new hash to avoid putting every method in the
	same hash bucket.

	* aot-runtime.c (find_extra_method_in_amodule): Use the new hash.

	* aot-runtime.c (can_method_ref_match_method): New function to quickly check
	whenever a method ref could match a method.
	
	* aot-runtime.c (load_image): Revert the previous change, it causes an AOT
	test to fail.
	
	* aot-runtime.c (find_extra_method_in_amodule): Add a cache for decoded 
	methods refs.

	* aot-runtime.c (load_image): Pass our basedir to mono_assembly_load.

	* aot-compiler.c (emit_exception_debug_info): Bump the maximum size of
	the encoding buffer.

	* method-to-ir.c (mono_method_check_inlining): Avoid calling 
	mono_method_get_header () on inflated methods as an optimization.

2009-02-16  Zoltan Varga  <vargaz@gmail.com>

	* ssa.c (fold_ins): Fix another crash if the instruction following the
	switch was optimized away.

2009-02-16  Mark Probst  <mark.probst@gmail.com>

	Contributed under the terms of the MIT/X11 license by Steven
	Munroe <munroesj@us.ibm.com>.

	* mini-ppc.c, mini-ppc.h: Implement TLS for PPC64.

2009-02-16  Zoltan Varga  <vargaz@gmail.com>

	* mini.c method-to-ir.c mini-trampolines.c aot-runtime.c: Remove locking
	around the mono_domain_alloc calls, it is now done by the functions
	themselves.

	* aot-compiler.c (compile_method): Only add wrappers referenced by
	the method if compiling with full AOT.
	(mono_compile_assembly): Error out if --aot=full is specified on
	a platform where it is not supported.

	* aot-compiler.c (emit_trampolines): Emit generic class init trampolines
	on ARM too.

	* tramp-arm.c (mono_arch_create_generic_class_init_trampoline_full): Add
	AOT support.

	* aot-runtime.c (load_named_code): Handle 
	mono_arm_throw_exception_by_token.

	* mini-arm.h: Add declaration of mono_arm_throw_exception_by_token.

	* image-writer.c (asm_writer_emit_pointer_unaligned): Make this really
	unaligned.

	* Makefile.am (fullaotcheck): Exit if a test fails.

	* aot-compiler.c (mono_compile_assembly): Use the ASM writer for full aot
	on ARM.
	(mono_compile_assembly): Handle the assembler failing.

	* image-writer.c (asm_writer_emit_section_change): Handle ARM gas not
	accepting subsections of .bss.

	* ssa.c (visit_inst): Fix a crash if the instruction following a switch
	was optimized away.

	* aot-compiler.c: Remove some unused includes.
	
	* aot-compiler.c (MonoAotCompile): Remove some unused fields which are
	now in MonoImageWriter.

	* mini-x86.c (mono_arch_get_vcall_slot): Handle yet another
	code sequence which matches a non-virtual call. Fixes #472654.

2009-02-15  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c: Use xdebug_lock ()/unlock () macros for locking in the
	xdebug code.
	
	* aot-compiler.c: Make the xdebug code not depend on the AOT compiler,
	use the image/dwarf writers directly.

	* image-writer.c (struct _MonoImageWriter): Remove the unused 'image'
	field.

	* aot-compiler.c (MonoAotCompile): Remove fields which are now in
	MonoDwarfWriter.

	* image-writer.h: Fix some typos.

	* dwarfwriter.h dwarfwriter.c: New files.
	
	* aot-compiler.c: Extract the DWARF info writing functionality into a 
	separate module.

	* tramp-amd64.c (mono_arch_create_trampoline_code_full): Add a 'out_unwind_ops'
	argument to return unwind info.

	* tramp-arm.c (mono_arch_create_trampoline_code_full): Ditto.

	* aot-compiler.c: Emit unwind info for trampolines in full-aot mode.
	
	* aot-runtime.c (decode_method_ref): Add a case for 
	MONO_AOT_METHODREF_WRAPPER_NAME.

	* mini.h: Add constants for the magic numbers used in encode_method_ref ()
	for AOT.

	* aot-compiler.c (encode_method_ref): Use the new constants.

	* aot-runtime.c (decode_method_ref): Ditto.

	* aot-compiler.c (compile_method): For generic icalls, queue the wrapper to
	be compiled, not the icall itself.

2009-02-14  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (find_extra_method_in_amodule): Avoid decoding wrapper names
	using decode_method_ref ().

	* method-to-ir.c (mini_emit_ldelema_1_ins): If the array index is a long,
	convert it to an in32. Fixes #475859.

	* arrays.cs: Add a test.

2009-02-12  Zoltan Varga  <vargaz@gmail.com>

	* mini-s390x.c (mono_arch_output_basic_block): Fix the shift amounts in 
	OP_LCONV_TO_U2.

	* basic-long.cs: Add a test.

2009-02-12  Mark Probst  <mark.probst@gmail.com>

	* mini-x86.c, mini-x86.h: Very simple frame pointer removal.  We
	remove the frame pointer in leaf methods which don't receive any
	arguments, don't throw exceptions and don't do dynamic stack
	allocations.

2009-02-12  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_build_imt_thunk): Fix size calculation after
	the fail_tramp changes. Hopefully fixes #475132.

2009-02-12  Rodrigo Kumpera  <rkumpera@novell.com>

	* method-to-ir.c (mono_emit_method_call_full): Use mono_metadata_signature_dup_mempool
	instead of mono_metadata_signature_dup_full.

2009-02-12  Zoltan Varga  <vargaz@gmail.com>

	* ssa.c (fold_ins): Use MONO_IS_JUMP_TABLE () and MONO_JUMP_TABLE_FROM_INS ()
	for processing jump tables. Fixes #473787.

2009-02-11  Mark Probst  <mark.probst@gmail.com>

	* mini-generic-sharing.c: mini_method_get_context() just calls
	mono_method_get_context_general() now.

	* mini.c, mini.h: Moved get_object_generic_inst(),
	construct_object_context_for_method() and
	mono_domain_lookup_shared_generic() to metadata/generic-sharing.c.

2009-02-11  Zoltan Varga  <vargaz@gmail.com>

	* branch-opts.c (mono_if_conversion): Handle the case where the merged 
	basic block fell through to its successor bblock without a branch. Fixes
	#474718.

	* iltests.il.in: Add a test.
	
	* aot-compiler.c (encode_method_ref): Encode methods of array types.
	(can_encode_patch): We can now handle arrays of generic parameters and
	array methods.

	* aot-runtime.c (decode_method_ref_2): Handle methods of array types.

	* aot-compiler.c aot-runtime.c: Emit the size of specific trampolines into
	the AOT file to avoid some #ifdefs in aot-runtime.c

	* mini.h: Bump AOT file format version.

2009-02-10  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am (fullaotcheck): Make this run the tests.

	* aot-compiler.c: Make the printing of skipped methods runtime configurable.

2009-02-10  Mark Probst  <mark.probst@gmail.com>

	* mini-x86.c (mono_arch_context_get_int_reg): Handle all registers
	individually.  Fixes #473482.

2009-02-10  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c (mono_arch_output_basic_block): Disable AOT for OP_JMP.

2009-02-09  Jeffrey Stedfast  <fejj@novell.com>

	* aot-compiler.c (arch_emit_plt_entry): Fixed to compile.
	(mono_compile_assembly): Hush compile warnings about
	uninitialized [tmp_]outfile_name variables in the !use_bin_writer
	code path.

2009-02-10  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-arm.c (mono_arch_find_jit_info): Fix aot support.

	* mini-arm.c: Checkin unwind related changes missing from an earlier commit.

	* aot-compiler.c: Fix arm support.

	* image-writer.c: Move the R_ARM constants to image-writer.h. Export a
	img_writer_emit_unset_mode () function.

	* unwind.c (mono_unwind_get_dwarf_data_align): New helper function.
	(mono_unwind_get_dwarf_pc_reg): Ditto.

	* aot-compiler.c (emit_dwarf_abbrev): Another large reorganization.
	Move almost all platform specific code to a set of arch_ functions, 
	and document them to ease porting.
	
	* aot-compiler.c (mono_xdebug_init): Fix xdebug support.

	* image-writer.h image-writer.c: New files, extracted from aot-compiler.c.

	* aot-compiler.c: Extract the image writing functionality into a separate
	module to reduce the size of this file.

2009-02-09  Geoff Norton  <gnorton@novell.com>

	* mini-s390.c: Fix the signature of emit_sig_cookie.

2009-02-09  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (is_shared_got_patch): Add MONO_PATCH_INFO_IMAGE.

	* aot-runtime.c (is_shared_got_patch): Ditto.

	* aot-runtime.c (load_named_code): Cope with the fact that 
	decode_got_entry () won't decode the patch fully if its corresponding got
	entry is already filled.
	
	* tramp-amd64.c (mono_arch_create_monitor_enter_trampoline_full): 
	Initialize *ji.
	(mono_arch_create_monitor_exit_trampoline_full): Ditto.

	* tramp-amd64.c (mono_arch_create_monitor_enter_trampoline_full): Use 'code'
	as the moving pointer instead of 'buf' for consistency with the rest of the
	codebase.
	(mono_arch_create_monitor_exit_trampoline): Ditto.

	* aot-compiler.c (emit_trampolines): Add throw_pending_exception/
	generic_class_init trampolines.
	(add_generic_class): Extract some code from add_generic_instances () into a
	separate function so it can be called from other places too.
	(compile_method): Call add_generic_class () for the classes of inflated methods
	referenced by the method.
	(can_encode_patch): Allow references to generic parameters.

	* aot-runtime.c: Add support the patches required by the new trampolines.
	
	* exceptions-amd64.c (mono_arch_get_throw_pending_exception_full): Add full-aot
	support.

	* tramp-amd64.c (mono_arch_create_generic_class_init_trampoline_full): Add
	full-aot support.

	* exceptions-amd64.c (mono_arch_get_throw_pending_exception_full): Rename
	this from get_throw_pending_exception, make the signature full aot compatible.

	* Makefile.am (fullaotcheck): New target to run full-aot tests.

	* method-to-ir.c (inline_method): Save/Restore cfg->ret_var_set too.

	* exceptions.cs: Add a test.

2009-02-07  Zoltan Varga  <vargaz@gmail.com>

	* unwind.c (mono_unwind_frame): Eliminate the data_align_factor argument,
	use the DWARF_DATA_ALIGN constant instead.

	* exception-<ARCH>.c: Update after the above change.

	* exceptions-arm.c (mono_arch_find_jit_info): Transition this to use the
	dwarf unwinder.

	* mini-arm.c: Enable the dwarf unwinder.

	* mini-trampolines.c (mono_magic_trampoline): Use mono_class_get_vtable_entry ()
	instead of mono_class_setup_vtable ().

2009-02-07  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-x86.c (mono_arch_find_jit_info): Transition this to use the
	dwarf unwinder.

	* mini-x86.h: Enable the dwarf unwinder.

2009-02-06  Raja R Harinath  <harinath@hurrynot.org>

	Fix mcs/tests/test-7.cs
	* mini-amd64.c (mono_arch_allocate_vars): Revert change from
	2009-02-03.

2009-02-06  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (print_jit_stats): Remove some unused statistics.

2009-02-05  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_klass_info): Update after MonoClass changes.

2009-02-05  Mark Probst  <mark.probst@gmail.com>

	* jit-icalls.c (mono_helper_compile_generic_method): Don't inflate
	the method we get from mono_object_get_virtual_method() because
	that function does it properly, now.

2009-02-05  Zoltan Varga  <vargaz@gmail.com>

	* unwind.c (mono_unwind_ops_encode): Handle offsets greater than 32 between
	opcodes. Fixes #472775.

2009-02-05  Mark Probst  <mark.probst@gmail.com>

	* mini-exceptions.c (ves_icall_get_frame_info): Account for the
	fact that mono_find_jit_info() sometimes returns the context
	corresponding to the jit info in new_ctx.  Fixes #472600.

2009-02-05  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c mini-hppa.c mini.c trace.c mini-s390x.c aot-compiler.c
	mini-s390.c: Use mono_class_enum_basetype () instead of accessing
	klass->enum_basetype directly.

	* aot-compiler.c (emit_class_dwarf_info): Add support for all possible
	enum subtypes.

	* unwind.c: Avoid 0 sized arrays.

2009-02-04  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (mono_setup_altstack): Use a more reasonable altstack
	size on systems with 64k pages. Fixes #471389.

2009-02-04  Mark Probst  <mark.probst@gmail.com>

	Contributed under the terms of the MIT/X11 license by Steven
	Munroe <munroesj@us.ibm.com>.

	* mini-ppc.c (mono_arch_output_basic_block): Generate better code
	for LOADI4_MEMBASE.  Use addi instead of addic if it's not
	necessary.

2009-02-04  Mark Probst  <mark.probst@gmail.com>

	Contributed under the terms of the MIT/X11 license by Steven
	Munroe <munroesj@us.ibm.com>.

	* exceptions-ppc.c (mono_arch_get_restore_context): Code size
	comparison fix.

	* tramp-ppc.c (mono_arch_create_generic_class_init_trampoline):
	The trampoline can be longer on PPC64.

2009-02-04  Mark Probst  <mark.probst@gmail.com>

	Contributed under the terms of the MIT/X11 license by Steven
	Munroe <munroesj@us.ibm.com>.

	* mini-ppc.c: Compiler warning fixes and trivial code
	simplifications.

2009-02-04  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mono_spill_global_vars): Fix problems caused by reading
	ins->dreg which could be a hardware register, not a vreg.

	* aot-compiler.c (emit_method_dwarf_info): Ditto.
	
	* mini.h (MonoCompile): Remove vreg_to_var_num array, it is no longer used.
	(struct MonoMethodVar): Add a vreg field, holding the vreg of variable.

	* mini.c (mono_compile_create_var_for_vreg): Set var->vreg.
	
	* mini-amd64.c (mono_arch_output_basic_block): Avoid reading cfg->varinfo[..]
	->dreg, that is not the vreg we are looking for.

	* mini-amd64.h mini-x86.h: Enable MONO_ARCH_LIVENESS_OPS again.

	* mini-x86.c (mono_arch_output_basic_block): Add support for LIVERANGE_START/
	LIVERANGE_END.

	* method-to-ir.c (mono_spill_global_vars): Add an assert to help track down
	strange crashes.

2009-02-03  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (mono_arch_emit_prolog): Emit unwind info.

	* aot-compiler.c (emit_line_number_info): Fix line number emission when
	the line diff is 0.

	* aot-compiler.c: Add xdebug support on x86.

	* unwind.c: Add x86 support.
	
	* aot-compiler.c (emit_exception_debug_info): Control the emission of
	unwind info using a new MONO_ARCH_HAVE_XP_UNWIND define.

	* mini.c (mini_method_compile): Ditto.
	
	* mini-amd64.c (mono_arch_allocate_vars): Avoid setting cfg->ret->dreg to
	the variable index.

	* aot-compiler.c: Add emit_push_section ()/emit_pop_section () helper functions
	which mimic .push_section/.pop_section in GAS.
	
	* aot-compiler.c: Emit precise live range information for variables.

	* mini-amd64.c (mono_arch_output_basic_block): Add OP_LIVERANGE_START/END.

	* method-to-ir.c (mono_spill_global_vars): Compute the instructions marking
	the live ranges of variables, and emit OP_LIVERANGE_START/END opcodes for
	them.

	* mini-ops.h: Add OP_LIVERANGE_START/END opcodes to mark
	the live ranges of variables.

	* mini.h (struct MonoMethodVar): Add two fields containing the live range
	of the variable in terms of native offsets.

2009-02-03  Rodrigo Kumpera  <rkumpera@novell.com>

	* arrays.cs: Test for Get/SetValue of array with negate lower bounds.
	
2009-02-02  Mark Probst  <mark.probst@gmail.com>

	Contributed under the terms of the MIT/X11 license by Steven
	Munroe <munroesj@us.ibm.com>.

	* exceptions-ppc.c (restore_regs_from_context): Correct operand
	order (offset then base reg) for ppc_load_multiple_regs.
	(emit_save_saved_regs) Correct operand order for
	ppc_store_multiple_regs.
	(mono_arch_get_call_filter): Correct operand order for
	ppc_load_multiple_regs.

	* mini-ppc.c (emit_memcpy): Fix operand order for
	ppc_load_reg_update and ppc_store_reg_update.
	(mono_arch_output_basic_block): Correct operand order for ppc_lha.
	(mono_arch_emit_epilog): Correct operand order for
	ppc_load_multiple_regs.

	* tramp-ppc.c (mono_arch_create_trampoline_code): Correct operand
	order for ppc_store_multiple_regs and ppc_load_multiple_regs.

2009-02-02  Mark Probst  <mark.probst@gmail.com>

	* cpu-ppc64.md: Fixed storer4_memindex length.

2009-02-02  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_line_number_info): Optimize the size of the emitted
	line number info.
	
	* aot-compiler.c (emit_line_number_info): Optimize this.

2009-02-01  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c: Disassemble tokens in the IL disassembly.
	
	* aot-compiler.c: Add debug info for methods without debug info by
	emitting an IL file and having the line number info referencing that file.

	* aot-compiler.c: Optimize the size of the generated line number info.

	* aot-compiler.c: Emit line number info in xdebug mode.

	* aot-compiler.c (mono_save_xdebug_info): Receive a MonoCompile instead of a
	million arguments.

2009-01-31  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_method_dwarf_info): Emit names for local variables.

	* driver.c (mono_main): Enable debugging support automatically if XDEBUG
	is used.

2009-01-31  Rodrigo Kumpera  <rkumpera@novell.com>

	* basic-calls.cs: Test for the weird crash found on arm.
	
2009-01-31  Rodrigo Kumpera  <rkumpera@novell.com>

	* cpu-arm.md: Increase the size of storer8_membase_reg and
	loadr8_membase_reg to 24 bytes to accomodate the extra add.

	* mini-arm.c (mono_arch_output_basic_block): Under FPA, when emitting
	OP_STORER8_MEMBASE_REG and OP_LOADR8_MEMBASE_REG, add the original
	reg to LR otherwise we'll be loading/storing from just the offset.

2009-01-30  Miguel de Icaza  <miguel@novell.com>

	Question: if we are storing gint32's inside the "*native_offset",
	should we change the signature to "gint32 *native_offset" to
	ensure that we do not have type definition problems?
	
	* mini-exceptions.c (ves_icall_get_frame_info): Cast the gint32 to
	an int * as this is what the other function expects, causes
	problems with Freescale's compiler that defined int32_t to be a
	long and makes int incompatible 

2009-01-30  Miguel de Icaza  <miguel@novell.com>

	* Rename generic-sharing.c to mini-generic-sharing.c to avoid the
	filename conflict with bjam.

2009-01-30  Rodrigo Kumpera  <rkumpera@novell.com>

	* cpu-arm.md: Increase the size of storer8_membase_reg to 20 bytes
	as it might use decomposed ops.

2009-01-30  Zoltan Varga  <vargaz@gmail.com>

	* jit-icalls.c (mono_imul_ovf): Fix one of the literals.

	* mini.c (mini_init): Emulate mul.ovf opcodes if MONO_ARCH_EMULATE_MUL_OVF
	is defined.

	* mini-arm.h (MONO_ARCH_EMULATE_MUL_OVF): New define.

	* mini-arm.c (mono_arch_build_imt_thunk): Rewrite this to allow large vtable
	offsets.

	* mini-arm.c (mono_arch_context_get_int_reg): Adapt this to the "clever"
	way registers are stored in MonoContext on arm.

	* unwind.c: Rewrite the handling of the cached_info array to use hazard pointers
	instead of locking so mono_get_cached_unwind_info () becomes signal safe.

	* mini.c (mini_init): Emuate OP_FCONV_TO_I when using soft float.

	* mini-arm.c (emit_load_volatile_arguments): Avoid an unneccesary assert.

	* mini.c (mini_init): Register mono_isfinite.

	* jit-icalls.c (mono_isfinite): New jit icall.

	* method-to-ir.c (mono_decompose_soft_float): Add support for OP_CKFINITE.
	
	* exceptions-arm.c (mono_arch_find_jit_info): When unwinding using the LMF,
	set esp to ARMREG_FP instead of R12, since R12 stores the value of sp for
	the parent frame.

2009-01-30  Rodrigo Kumpera  <rkumpera@novell.com>

	* exceptions-arm.c (mono_arch_find_jit_info): The frame layout on arm have
	separate frame and stack pointers, so we must use FP to find the register
	spill area.
	The FP reg is retrieved from the MonoContext::regs array.

2009-01-30  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini-arm.c (mono_arch_output_basic_block): Emit two cond ops for OP_FBGE
	as FPA requires it.

2009-01-30  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini-arm.c (mono_arch_emit_setret): Emit OP_FMOVE for methods that
	return R4 and R8 when not running under softfloat.

	Fixes basic-calls.exe

2009-01-30  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c: Implement some overflow opcodes.

2009-01-29  Miguel de Icaza  <miguel@novell.com>

	* ssa.c: handle another alloca.h

	* mini-exceptions.c (mono_handle_native_sigsegv): Do not use
	PLATFORM_WIN32 for detecting if we have sigaction.   Instead use
	MONO_ARCH_USE_SIGACTION. 

	* aot-runtime.c, mini-exceptions.c: Replace platform define with
	capability defines.

	* method-to-ir.c (mono_method_to_ir): Type cast fix on some platforms.

	* mini-ppc.h (MONO_ARCH_USE_SIGACTION): Do not define this for all
	PPC targets as sigaction does not exist on all platforms, define
	this on a per-platform basis.

	Instead of erroring out if the platform is not defined, include
	mini-ppc-os.h, and expect that the OS specific setting provides
	the required information.   

2009-01-30  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c: Fix --enable-minimal=aot.

2009-01-30  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-arm.c (mono_arch_get_throw_exception_generic): Fix the
	previous change.

2009-01-29  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-arm.c: Fix warnings.

	* tramp-arm.c aot-compiler.c unwind.h unwind.c: Implement xdebug support for
	ARM.

	* mini-x86.c: Fix --enable-minimal=jit build.

	* mini.c: Really fix --enable-minimal=jit build.
	
	* mini.c (construct_object_context_for_method): Move this outside
	the DISABLE_JIT block to fix the --enable-minimal=jit build.

	"Backported" of r124984 from 2.0 branch.
	
	* aot-compiler.c aot-runtime.c: Add full-aot support delegate BeginInvoke/EndInvoke.

	"Backport" of r124977 + r124978 from 2.0 branch.
	
	* exceptions-arm.c (mono_arm_throw_exception_by_token): New helper function
	to avoid calling mono_exception_from_token () from the throw trampoline.
	(mono_arch_get_throw_exception_generic): call throw_exception_by_token
	for throwing corlib exceptions, this fixes full-aot support for corlib
	exceptions.

	* aot-compiler.c (compile_method): Make a copy of cfg->locals to fix the build.

2009-01-29  Miguel de Icaza  <miguel@novell.com>

	* mini-darwin.c, mini-windows.c, mini-posix.c: Commit the first
	part of the changes to split the code in mini into operating
	system specific files.

	This patch was done by copying mini.c to the respective files to
	preserve SVN history.

2009-01-29  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_method_dwarf_info): Add minimal support for locals.

2009-01-28  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mono_method_to_ir): Avoid generic sharing for calls made to
	remoting-invoke-with-check wrappers of shared methods.

	* mini.c (print_jit_stats): Print out major gc count/time for libgc too.

2009-01-27  Mark Probst  <mark.probst@gmail.com>

	* method-to-ir.c (emit_stloc_ir): Only apply the reg-reg move
	optimization if the top of stack is the last instruction in the
	bblock.  Otherwise it might have been used after its definition.
	Fixes #469742.

2009-01-27  Zoltan Varga  <vargaz@gmail.com>

	* mini-trampolines.c (mono_magic_trampoline): Print out the caller
	method as well when get_vcall_slot () fails to match a code sequence.

	* mini-arm.c: Fix the android build, which doesn't have
	__aeabi_read_tp.

2009-01-26  Zoltan Varga  <vargaz@gmail.com>

	* mini-s390x.c: Remove a stray declaration of emit_sig_cookie () to fix
	the s390x build.

2009-01-26  Rodrigo Kumpera  <rkumpera@novell.com>

	* unwind.c (mono_unwind_cleanup): Don't crash if cached_info is NULL.

2009-01-26  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_method_compile): Save the unwind info generated by the JIT
	and put its id into jinfo->used_regs. This is only used on amd64,
	which is currently the only platform generating unwind info.

	* exceptions-amd64.c: Instead of unwinding based on a register mask, use
	the dwarf unwinder. This is required to correctly handle async exceptions
	like thread abort and stack overflows, which can happen while a method
	is in the middle of its prolog or epilog.
	
	* aot-runtime.c (mono_aot_get_unwind_info): New helper function to obtain
	the unwind info belonging to an AOTed method.

	* aot-compiler.c aot-runtime.c: Save/Load the unwind info emitted by the JIT
	into cfg->unwind_ops.
	
	* unwind.c (mono_unwind_frame): Use <= instead of < for the loop exit check.

	* mini.c (mini_init): Call mono_unwind_init ().
	(mini_cleanup): Call mono_unwind_cleanup ().

	* unwind.c: Add functions for managing a set of unwind info entries, allowing
	unwind info to be shared between methods.

	* mini-amd64.c (mono_arch_emit_prolog): Emit unwind info for the registers
	saved in the LMF.

	* exceptions-amd64.c (mono_arch_exceptions_init): Call 
	get_throw_pending_exception () to avoid initialization races.

	* mini-exceptions.c (mono_exceptions_init): Call an arch specific
	mono_arch_exceptions_init () function.

	* mini.h (MONO_INST_NEW): Remove duplicate setting of cil_code.

2009-01-25  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_get_domain_intrinsic): New helper function.
	(mono_get_thread_intrinsic): Ditto.

	* mini-arm.c mini-ia64.c: Use the new helper functions.
	
	* method-to-ir.c (mono_method_to_ir): Fix the comment for
	the last constrained_call change, since it is needed in the non-AOT
	case as well.

	* mini-arm.c: Implement OP_TLS_GET on arm eabi linux.
	
	* mini-arm.c (mono_arch_emit_prolog): Add an inlined version of 
	mono_get_lmf_addr () on arm eabi linux.

2009-01-24  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_get_vcall_slot): Handle yet another
	code sequence which matches a non-virtual call.

2009-01-23  Mark Probst  <mark.probst@gmail.com>

	* mini-ppc.c (mono_arch_context_get_int_reg): Allow access to the
	stack pointer (r1).

2009-01-23  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c aot-runtime.c: Treat delegate-invoke wrappers similarly to
	runtime-invoke wrappers, since they are also shared based on signature.

2009-01-22  Mark Probst  <mark.probst@gmail.com>

	* mini-exceptions.c (ves_icall_get_frame_info): Fetch the generic
	info from the (correct) context.

2009-01-22  Zoltan Varga  <vargaz@gmail.com>

	* unwind.c (mono_unwind_frame): Remove a stray g_free ().
	
	* unwind.c (mono_unwind_frame): New function to unwind through a frame
	using dwarf unwinding info. Not yet used.

	* mini.c (mini_init): When using xdebug, disable freeing of domains.

2009-01-21  Mark Probst  <mark.probst@gmail.com>

	* mini-ppc.c (mono_arch_delegate_invoke_impl): Return function
	descriptors.

	* mini-trampolines.c (mono_delegate_trampoline): Remove the PPC64
	special case and handle mono_arch_delegate_invoke_impl() returning
	function descriptors.

	* tramp-ppc.c (mono_arch_create_trampoline_code): Delegate
	trampolines return function descriptors, too.

2009-01-21  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (handle_alloc): Avoid generic instances in the
	out_of_line optimization.

2009-01-21  Martin Baulig  <martin@ximian.com>

	* mini.h
	(MonoCompile): Added `disable_deadce_vars' to disable removing
	unused variables.

	* mini.c
	(mini_method_compile): Set `cfg->disable_deadce_vars' when running
	inside the debugger.

	* liveness.c (mono_analyze_liveness): Don't remove any unused
	variables if `cfg->disable_deadce_vars' is set.

2009-01-21  Mark Probst  <mark.probst@gmail.com>

	* method-to-ir.c: Only apply exception constructor optimization if
	the the method actually belongs to an exception class.  Fixes
	#467456.

2009-01-21  Zoltan Varga  <vargaz@gmail.com>

	* mini-trampolines.c (mono_delegate_trampoline): Put back the previous
	change inside a #ifdef __mono_ppc64__.

	* aot-compiler.c (compile_method): Remove the previous limitation.

	* method-to-ir.c (method-to-ir.c): Add support for the constrained prefix
	on type variables in AOTed code.
	
	* aot-compiler.c (compile_method): Skip generic methods having type 
	constraints on their generic parameters.

	* aot-compiler.c (compile_method): Check for methods which cannot be
	encoded inside RGCTX_FETCH patches as well.

	* mini-exceptions.c (mono_print_thread_dump): Fix the windows
	build.

2009-01-20  Mark Probst  <mark.probst@gmail.com>

	* method-to-ir.c: Force the vtable variable in shared generic code
	for the case that they might show up on a stack trace where they
	are needed.

	* mini-exceptions.c: Save and use generic sharing info as well as
	IP in stack traces to resolve shared generic instantiations.

2009-01-20  Zoltan Varga  <vargaz@gmail.com>

	* mini-trampolines.c (mono_delegate_trampoline): Revert the change which
	added a mono_get_addr_from_ftnptr () as it breaks the ia64 build.

2009-01-20  Mark Probst  <mark.probst@gmail.com>

	* method-to-ir.c: Do generic sharing for array constructors.

2009-01-20  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini-exceptions.c (mono_print_thread_dump): Add information
	about the thread state using wapi_current_thread_desc.

2009-01-19  Rodrigo Kumpera  <rkumpera@novell.com>

	* basic-simd.cs: Tests for the new constructors. 

2009-01-19  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini-ops.h: Added OP_EXPAND_*

	* cpu-x86.md: Same.

	* mini-x86.c (mono_arch_output_basic_block): Same.
	
	* simd-intrinsics.c (simd_intrinsic_emit_setter): Add support for single element constructors.

2009-01-19  Zoltan Varga  <vargaz@gmail.com>

	* iltests.il.in: Add a test for #467385.

2009-01-18  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini.c (mini_thread_cleanup): Don't cleanup TLS storage if the
	thread been cleaned up is not the same currently in execution.

	Fixes appdomain-unload crashes on windows, osx and linux variants
	without the __thread keyword.

2009-01-18  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c (mono_arch_flush_icache): Applied patch from Koushik Dutta
	(koush@koushikdutta.com). Implement this for android.

	* helpers.c (mono_disassemble_code): Avoid assembler errors if the id
	begins with a digit.

	* method-to-ir.c: Call mono_gc_get_write_barrier () instead of
	mono_marshal_get_write_barrier ().

2009-01-17  Rodrigo Kumpera  <rkumpera@novell.com>

	* decompose.c (mono_decompose_vtype_opts): Fix the decomposition
	of OP_VCALL_* ops for 8 bytes vtypes on 32 bits archs and platorms
	that pass them on a register pair.

	This affects windows, OSX and FreeBSD. The mono/tests/handleref.exe
	test was crashing due to that.

Fri Jan 16 15:21:21 CET 2009 Paolo Molaro <lupus@ximian.com>

	* exceptions-ppc.c: tweaks from malc (OV-Soft) to fix the size of the
	trampoline code. Include ucontext.h only if available.

2009-01-15  Mark Probst  <mark.probst@gmail.com>

	* mini.c: mono_domain_lookup_shared_generic() takes an open method
	and doesn't check whether it's sharable, like it was before
	removing the shared generics hash.  This brings IronPython
	performance back to what it was before that change.

2009-01-14  Mark Probst  <mark.probst@gmail.com>

	* method-to-ir.c: Handle delegate invocation optimization earlier,
	otherwise it would be handled (much more slowly) by the
	final/sealed optimization.

2009-01-13  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (SIG_HANDLER_SIGNATURE): Avoid crashes when the current thread or
	domain is not set. Fixes #465864.

2009-01-12  Mark Probst  <mark.probst@gmail.com>

	* method-to-ir.c: Don't stop sharing of generic methods with catch
	clauses - we already handle those.

2009-01-12  Mark Probst  <mark.probst@gmail.com>

	* mini.c, mini.h: lookup_generic_method() is now
	mono_domain_lookup_shared_generic() and uses the jit_code_hash,
	making the shared_generics_hash obsolete.

2009-01-12  Mark Probst  <mark.probst@gmail.com>

	* mini-ppc.c, exceptions-ppc.c, cpu-ppc.md, cpu-ppc64.md: Don't
	use the red zone.  Make room on the stack first and then use it,
	not the other way around.

2009-01-12  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_init): Call mono_xdebug_init ().

	* aot-compiler.c (mono_xdebug_init): Make this non-static.

2009-01-11  Zoltan Varga  <vargaz@gmail.com>

	* TestDriver.cs: Add an --iter argument to run tests multiple times.

	* tramp-amd64.c (mono_arch_create_trampoline_code_full): Emit debug info for
	trampolines.

	* aot-compiler.c (mono_save_trampoline_xdebug_info): New function to emit
	debug+unwind info for trampolines.

	* mini.c (mono_create_unwind_op): New helper function.

	* unwind.h: Add macros for emitting unwind ops without a MonoCompile.

2009-01-10  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c: Fix the build.

2009-01-09  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am: Update dtrace-prelink.sh location.

2009-01-08  Zoltan Varga  <vargaz@gmail.com>

	* method-to-ir.c (mono_method_to_ir): Fix the check for the mscorlib ldstr 
	optimization. Fixes #464520.

2009-01-07  Bill Holmes  <billholmes54@gmail.com>

	* mini-amd64.c : Adding code to save/restore non-volatile registers
	   on Winx64.

	* exceptions-amd64.c : Adding code to save/restore non-volatile 
	  registers on Winx64.

	Contributed under MIT/X11 license.

2009-01-07  Zoltan Varga  <vargaz@gmail.com>

	* mini-arm.c (mono_arch_flush_icache): Use __GNUC_PREREQ instead of checking
	__GNUC_MINOR__ which can break when the major version changes.

2009-01-07  Rodrigo Kumpera  <rkumpera@novell.com>

	* basic-simd.cs: Add tests for usage of the sizeof opcode.

2009-01-07  Geoff Norton  <gnorton@novell.com>

	* helpers.c:  Allow mono -v -v -v to work on darwin.

2009-01-05  Bill Holmes  <billholmes54@gmail.com>

	* mini-amd64.c (mono_arch_get_vcall_slot) : Handle an additional instruction
	  pattern. 

	Contributed under MIT/X11 license.

2009-01-05  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_allocate_stack_slots_full2): Use mono_class_from_mono_type
	instead of directly accessing type->data.klass. Fixes #462016.
	(mono_allocate_stack_slots_full): Ditto.

	* mini-arm.c (mono_arch_flush_icache): Applied patch from Riku Voipio 
	<novell@kos.to>. Fix cache flush on kernels without OLDABI compat option.

	* aot-compiler.c (emit_plt): Fix ARM build.

2009-01-04  Zoltan Varga  <vargaz@gmail.com>

	* branch-opts.c (mono_if_conversion): Optimize this using ins->prev.
	
	* branch-opts.c (mono_if_conversion): Fix an assert introduced by the last
	change.

	* branch-opts.c (mono_if_conversion): Use branch->inst_true_bb/inst_false_bb
	instead of bblock->out_bb [0]/[1], the two might not be the same. Fixes
	#463357.

	* iltests.il.in: Add a regression test.

2009-01-04  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini-codegen.c (mono_print_ins_index): Pretty print XPHI and VPHI.

2009-01-04  Rodrigo Kumpera  <rkumpera@novell.com>

	* basic-simd.cs: Add a regression test for #462457.

2009-01-04  Rodrigo Kumpera  <rkumpera@novell.com>

	* mini-ops.h: Add a definition of XPHI.

	* mini.h (MONO_IS_PHI): Make is aware of simd instrincs. 

	* ssa.c (op_phi_to_move): Handle XPHI.

	* ssa.c (mono_ssa_compute): Generate a XPHI for simd intrinsics instead of VPHI.

	Fixes #462457

2009-01-04  Rodrigo Kumpera  <rkumpera@novell.com>

	* method-to-ir.c (mono_emit_rgctx_calli): Fix a warning.

2008-12-31  Geoff Norton  <gnorton@novell.com>

	* mini-ppc.c: The prolog size allocated can be too small for darwin
	ppc32 under certain circumstances.  Also fix a small logic bug.

